#include <bits/stdc++.h>

#define MIN_INT -2147483648
#define MAX_INT 2147483647
#define MIN_LONG -9223372036854775808L
#define MAX_LONG 9223372036854775807L

#define long long long int

using namespace std;

// @author: pashka

struct Line {
    long a, b, c;
};

vector<Line> tree;

bool lower(Line l1, Line l2, int x) {
    // y = (-ax-c) / b;
    return (l1.a * x + l1.c) * l2.b >= (l2.a * x + l2.c) * l1.b;
}

void add_line(Line line, int n, int l, int r) {
    if (r - l <= 0)
        return;
    bool b1 = lower(line, tree[n], l);
    bool b2 = lower(line, tree[n], r - 1);
    if (b1 && b2) {
        tree[n] = line;
        return;
    }
    if (!b1 && !b2) {
        return;
    }
    int m = (l + r) / 2;
    add_line(line, 2 * n + 1, l, m);
    add_line(line, 2 * n + 2, m, r);
}

long X, Y;

void add_line(Line line) {
    add_line(line, 0, 0, X);
}

long divide(long a, long b) {
    if (a < 0) {
        long ans = a / b;
        if (a % b != 0) ans--;
        return ans;
    } else {
        return a / b;
    }
}

long get(int x, int n, int l, int r) {
    long y = divide((-tree[n].a * x - tree[n].c) , tree[n].b);
    if (r > l + 1) {
        int m = (l + r) / 2;
        if (x < m) {
            y = min(y, get(x, 2 * n + 1, l, m));
        } else {
            y = min(y, get(x, 2 * n + 2, m, r));
        }
    }
    return y;
}

long get(int x) {
    return get(x, 0, 0, X);
}

int main() {
    ios::sync_with_stdio(false);

    int n;
    cin >> X >> Y >> n;
    vector<long> x(n);
    vector<long> y(n);
    for (int i = 0; i < n; i++) {
        cin >> x[i] >> y[i];
    }

    long L = 0;
    long R = X;
    for (int i = 1; i < n; i++) {
        if (y[i] == y[0]) {
            if (x[i] < x[0]) {
                L = max(L, (x[i] + x[0] + 1) / 2);
            } else {
                R = min(R, (x[i] + x[0]) / 2);
            }
        }
    }

    X++;

    tree.assign(4 * X, {0, 1, -1000000});
    for (int i = 1; i < n; i++) {
        if (y[i] > y[0]) {
            long a = x[i] - x[0];
            long b = y[i] - y[0];
            long c = -((x[0] + x[i]) * a + (y[0] + y[i]) * b);
            a *= 2;
            b *= 2;
//            cerr << a << " " << b << " " << c << "\n";
            add_line({a, b, c});
        }
    }
    vector<long> up(X);
    for (int i = 0; i < X; i++) {
        up[i] = min(get(i), Y);
    }

    tree.assign(4 * X, {0, 1, -1000000});
    for (int i = 1; i < n; i++) {
        if (y[i] < y[0]) {
            long a = x[i] - x[0];
            long b = y[0] - y[i];
            long c = -((x[0] + x[i]) * a - (y[0] + y[i]) * b);
            a *= 2;
            b *= 2;
//            cerr << a << " " << b << " " << c << "\n";
            add_line({a, b, c});
        }
    }
    vector<long> down(X);
    for (int i = 0; i < X; i++) {
//        cout << i << " " << get(i) << "\n";
        down[i] = max(-get(i), 0ll);
    }

    for (int i = L; i <= R; i++) {
//        cout << i << " " << down[i] << " " << up[i] << "\n";
    }

    long s = 0;
    for (int i = L; i <= R; i++) {
//        cout << i << " " << up[i] << " " << down[i] << "\n";
//        cout << i << " " << max(up[i] - down[i] + 1, 0) << "\n";
        s += max(up[i] - down[i] + 1, 0ll);
    }
    cout << s << "\n";

    return 0;
}