#include <iostream>
#include <string>
#include <vector>

using namespace std;

const size_t pmax = 100500;
const size_t tmax = 100500;

vector<size_t> p[pmax];
vector<size_t> t[tmax];
vector<size_t> lazy;

int _t[tmax];

size_t P, T, M;

void relaxp(size_t player) {
    for (size_t i = 0; i < p[player].size(); ++i) {
        --_t[p[player][i]];
    }
}

void unrelaxp(size_t player) {
    for (size_t i = 0; i < p[player].size(); ++i) {
        ++_t[p[player][i]];
    }
    cout << endl;
}

size_t check() {
    size_t answer = 0;
    for (size_t i = 1; i <= T; ++i) {
        if (_t[i] == 0) {
            ++answer;
        }
    }
    return (answer);
}

void RELAXT(size_t task) {
    for (size_t i = 0; i < t[task].size(); ++i) {
        relaxp(t[task][i]);
    }
}

size_t relaxt(size_t task) {
    for (size_t i = 0; i < t[task].size(); ++i) {
        relaxp(t[task][i]);
    }
    size_t answer = check();
    for (size_t i = 0; i < t[task].size(); ++i) {
        unrelaxp(t[task][i]);
    }
    return (answer);
}

int main() {
    std::cin >> P >> T >> M;

    for (size_t i = 0; i < M; ++i) {
        size_t u, v;
        std::cin >> u >> v;
        t[v].push_back(u);
        p[u].push_back(v);
        ++_t[v];
    }

    size_t minimum = P;
    for (size_t i = 1; i <= T; ++i) {
        minimum = min(t[i].size(), minimum);
    }

    for (size_t i = 1; i <= T; ++i) {
        if (t[i].size() == minimum) {
            lazy.push_back(i);
        }
    }

    size_t T_0 = check();
    int safe = -1;
    for (size_t i = 0; i < lazy.size(); ++i) {
        size_t r = relaxt(lazy[i]);
        if (r > T_0) {
            T_0 = r;
            safe = lazy[i];
        }
    }

    std::cout << P - minimum << " " << T_0 << endl;
    if (safe != -1)
        RELAXT(safe);

    for (size_t i = 1; i <= T; ++i) {
        if (_t[i] == 0) {
            std::cout << i << " ";
        }
    }
    return 0;
}

/*
 *
3 3 7
1 1
1 2
1 3
2 1
2 2
2 3
3 3

 */