#include <iostream>
#include <synchapi.h>
#include <vector>
#include <set>
#include <map>

typedef long long ll;
typedef unsigned long long ull;
using namespace std;
const int MAXN = 1e5 + 7;
const int MOD = 1e9 + 7;

#define int long long

vector<vector<ll> > a(3, vector<ll>(3));

vector<vector<ll> > mult(vector<vector<ll> > a, vector<vector<ll> > b) {
    vector<vector<ll> > c(a.size(), vector<ll>(b[0].size(), 0));
    for (int i = 0; i < a.size(); i++) {
        for (int j = 0; j < b[0].size(); j++) {
            for (int k = 0; k < b.size(); k++) {
                c[i][j] = (c[i][j] + a[i][k] * b[k][j] % MOD) % MOD;
            }
        }
    }
    return c;
}

vector<vector<ll> > pw(vector<vector<ll> > a, int n) {
    if (n == 0) {
        vector<vector<ll> > b(a.size(), vector<ll>(a.size(), 0));
        b[0][0] = b[1][1] = b[2][2] = 1;
        return b;
    } if (n == 1) {
        return a;
    } else {
        vector<vector<ll> > b = pw(a, n / 2);
        b = mult(b, b);
        if (n % 2 == 1) {
            b = mult(b, a);
        }
        return b;
    }
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    if (n < 4) {
        cout << 0 << endl;
        return 0;
    }
    if (n == 4) {
        return cout << 4 << endl, 0;
    }
    a = {{1, 0, 0},
         {1, 26, 0},
         {0, 26, 26}};
    a = pw(a, n - 4);
    ll x = (ll)4 * 26 * 26 * 26 * 26 % MOD, y = (ll)5 * 26 * 26 * 26 * 26 * 26 % MOD, z = (ll)26 * 26 * 26 * 26 * 26 % MOD;
    ll ans = (x * a[0][0] % MOD + y * a[1][0] % MOD + z * a[2][0] % MOD) % MOD * (ll)189438834 % MOD;
    cout << ans << endl;

    return 0;
}