#include <iostream>
#include <synchapi.h>
#include <vector>
#include <set>
#include <map>

typedef long long ll;
typedef unsigned long long ull;
using namespace std;
const int MAXN = 2e5 + 7;
const int MOD = 1e9 + 7;

#define int long long

struct node {
    int par;
    vector<int> term;
    map<char, int> next;
};

node v[MAXN];
int sz = 1, h[MAXN], order[MAXN];

void add(string s, int idx) {
    int cur = 0;
    for (int i = 0; i < s.size(); i++) {
        if (!v[cur].next.count(s[i])) {
            v[cur].next[s[i]] = sz;
            v[sz].par = cur;
            h[sz] = h[cur] + 1;
            sz++;
        }
        cur = v[cur].next[s[i]];
    }
    order[idx] = cur;
    v[cur].term.push_back(idx);
}

int superlink[MAXN], cnt_t[MAXN];

int get_superlink(int pos) {
    if (pos == 0) return 0;
    if (v[pos].next.size() > 1 || !v[pos].term.empty()) return pos;
    if (superlink[pos] != -1) return superlink[pos];
    return superlink[pos] = get_superlink(v[pos].par);
}

int get_link_len(int pos) {
    return h[pos] - h[get_superlink(v[pos].par)];
}

int get_sum(int pos) {
    if (v[pos].next.empty()) return v[pos].term.size();
    if (cnt_t[pos] != -1) return cnt_t[pos];
    int cnt = v[pos].term.size();
    for (auto p : v[pos].next) {
        cnt += get_sum(p.second);
    }
    return cnt_t[pos] = cnt;
}

int k;
void rec(int pos, int pos_origin, int &sum, int &ost) {
    if (pos == 0) {
        sum = 0;
        ost = 0;
        return;
    }
    rec(get_superlink(v[pos].par), pos, sum, ost);
    int cnt = get_sum(pos);
    int len = get_link_len(pos);
    if (pos_origin != -1) {
        cnt -= get_sum(pos_origin);
    }
    if (len * k + ost <= cnt) {
        sum = sum + len * k + ost;
        ost = 0;
    } else {
        sum = sum + cnt;
        ost = len * k + ost - cnt;
    }
    return;
}

int process_query(int pos, int kek) {
    k = kek;
    int sum = 0, ost = 0;
    rec(order[pos], -1, sum, ost);
    return sum;
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    memset(superlink, -1, MAXN * sizeof(int));
    memset(cnt_t, -1, MAXN * sizeof(int));
    int n; cin >> n;
    for (int i = 0; i < n; i++) {
        string s; cin >> s;
        add(s, i);
    }
    int q; cin >> q;
    while (q--) {
        int pos, k; cin >> pos >> k;
        pos--;
        int ans = process_query(pos, k);
        cout << ans << "\n";
    }
    return 0;
}
/*
3
aa
ab
ab
6
1 1
2 1
1 2
3 2
2 2
3 1






 */