#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;

const ll mod = 1e9 + 7;

ll pow(ll a, ll b)
{
    if (b == 1)
        return a % mod;

    ll x = pow (a, b / 2);
    if (b % 2)
        return (((x * x) % mod) * a) % mod;
    else
        return (x * x) % mod;
}


ll divide(ll a, ll b)
{
    return (a * pow(b, mod - 2)) % mod;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	ll n;
	cin >> n;
	if (n < 4)
    {
        cout << 0;
        return 0;
    }

    ll left = (pow(26, n - 3) * (n + 1)) % mod;
    ll right = divide((pow(26, n - 2) - 1), 25);
    ll sum = (left - right - 3 + mod) % mod;
    cout << divide(sum, 25);
	return 0;
}














