#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
using namespace std;

const long long prime = 3;
const long long mod = 1e9 + 7;


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	vector<long long> pow_prime(1e6 + 1);
	pow_prime[0] = 1;
	for (int i = 1; i < 1e6 + 1; i++) {
		pow_prime[i] = (pow_prime[i - 1] * prime) % mod;
	}
	int p, t, m;
	cin >> p >> t >> m;
	vector<vector<int> > g(t);
	vector<int> deg(t, 0);
	int min_deg = 1e9;
	for (int i = 0; i < m; i++) {
		int x, y;
		cin >> x >> y;
		g[y - 1].push_back(x - 1);
		deg[y - 1]++;
	}
	for (int i = 0; i < t; i++) {
		min_deg = min(min_deg, deg[i]);
	}
	map<long long, vector<int> > m_hash;
	vector<long long> hash(t, -1);
	for (int i = 0; i < t; i++) {
		if (deg[i] == min_deg) {
			hash[i] = 0;
			for (int j = 0; j < min_deg; j++) {
				hash[i] += pow_prime[g[i][j]];
				hash[i] %= mod;
			}
			m_hash[hash[i]].push_back(i + 1);
		}
	}
	int ans = 0;
	int hash_ans;
	for (auto pr : m_hash) {
		ans = max(ans, (int)pr.second.size());
		hash_ans = pr.first;
	}
	if (min_deg == p) {
		cout << 0 << " " << t << endl;
		for (int i = 0; i < t; i++) {
			cout << i + 1 << " ";
		}
		return 0;
	}
	//cout << hash_ans << endl;
	cout << p - min_deg << " " << ans + 1 << endl;
	for (auto i : m_hash[hash_ans])
		cout << i << " ";
	return 0;
}