#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <iomanip>
#include <cmath>
#include <stack>
#include <bitset>
#include <unordered_set>
#include <unordered_map>

using namespace std;

#define forn(i,n) for(int i=0;i<n;i++)
#define fornr(i,n) for(int i=n-1;i>=0;i--)
#define forab(i,a,b) for(int i=a;i<b;i++)
#define pb push_back
#define all(v) v.begin(),v.end()
#define sz(v) int(v.size())
#define first fst
#define second snd
#define make_pair mp

typedef double dbl;
typedef unsigned long long ull;
typedef long long ll;
typedef vector<int> vi;

const int N = int(1e5) + 100;
const int MOD = int(1e9) + 7;

int add(int a, int b) {
    a += b;
    return a >= MOD ? a - MOD : a;
}

int mul(int a, int b) {
    return int((a * 1ll * b) % MOD);
}

int toPower(int x, int d) {
    if (d == 0) return 1;
    int t = toPower(x, d / 2);
    if (d & 1) return mul(mul(t, t), x);
    else return mul(t, t);
}

int val[N];
int pr[N];

int calc(int k) {
    pr[0] = 1;
    forab(i, 1, N) {
        pr[i] = mul(pr[i - 1], 26);
    }
    int sum = 0;
    for (int i = 4; i < 4 + k; i++) {
        val[i] = mul(i, pr[i - 4]);
        sum = add(sum, val[i]);
    }
    return sum;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif
    int n;
    cin >> n;
    int k = 30000;
    int step = calc(k);
    int sumPower = 0;
    forn(i, k) {
        sumPower = add(sumPower, pr[i]);
    }
    int ans = 0;
    int cur = 4;
    int curBlock = 0;
    while(cur <= n) {
        if (cur + k <= n) {
            ans = add(ans, mul(step, toPower(26, mul(k, curBlock))));
            ans = add(ans, mul(mul(sumPower, toPower(26, cur - 4)), add(cur, MOD - 4)));
            cur += k;
            curBlock++;
        } else {
            ans = add(ans, mul(toPower(26, cur - 4), cur));
            cur++;
        }
    }
    cout << ans << '\n';
    return 0;
}