#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <iomanip>
#include <queue>
#include <cmath>
#include <stack>
#include <bitset>
#include <unordered_set>
#include <unordered_map>
#include <cassert>

using namespace std;

#define forn(i,n) for(int i=0;i<n;i++)
#define fornr(i,n) for(int i=n-1;i>=0;i--)
#define forab(i,a,b) for(int i=a;i<b;i++)
#define pb push_back
#define all(v) v.begin(),v.end()
#define sz(v) int(v.size())
#define fst first
#define snd second
#define mp make_pair

typedef double dbl;
typedef unsigned long long ull;
typedef long long ll;
typedef pair<int,int> pii;
typedef vector<int> vi;

const int N = 1005;
const int INF = 1e9 + 7;

int used[N * N], dist[N * N], prv[N * N];
int usedNow[N][N], timeNow = 1;
int f[N][N], comp[N][N], portalComp[N][N][4];
int d[4][2] = {{1, 0}, {0, 1}, {-1, 0}, {0, -1}};
pii closestShit[N][N][4], portalLocation[N][N][4];

string orient[4] = {"D", "R", "U", "L"};

struct OrPosition {
    int x, y, k;
};

map<int, OrPosition> fromComp[N * N];
set<int> g[N * N];

void markComp(int x, int y, int c) {
    comp[x][y] = c;
    forn(k, 4) {
        int xx = x + d[k][0], yy = y + d[k][1];
        if (!f[xx][yy] && !comp[xx][yy]) markComp(xx, yy, c);
    }
}

void calcShitRec(int x, int y, int k) {
    if (closestShit[x][y][k] != mp(-1, -1)) return;
    int xx = x + d[k][0], yy = y + d[k][1];
    calcShitRec(xx, yy, k);
    closestShit[x][y][k] = closestShit[xx][yy][k];
}

void calcClosestShit(int n, int m) {
    forn(i, n) {
        forn(j, m) {
            forn(t, 4) closestShit[i][j][t] = mp(-1, -1);
            if (f[i][j] == 2) {
                forn(t, 4) closestShit[i][j][t] = mp(i, j);
            }
        }
    }
    forn(i, n) {
        forn(j, m) {
            forn(t, 4)
                calcShitRec(i, j, t);
        }
    }
}

void calcPortalLocation(int x, int y, int k) {
    if (f[x][y] == 2) return;
    pii toShit = closestShit[x][y][k];
    int xTo = toShit.fst - d[k][0], yTo = toShit.snd - d[k][1];
    portalLocation[x][y][k] = mp(xTo, yTo);
    portalComp[x][y][k] = comp[xTo][yTo];
}

void finish() {
    cout << -1 << " " << -1 << '\n';
    exit(0);
}

OrPosition checkFromComp(int c, int n, int m) {
    forn(i, n) {
        forn(j, m) {
            if (comp[i][j] != c) {
                continue;
            }
            forn(t, 4) {
                if (portalComp[i][j][t] == c) {
                    return {i, j, t};
                }
            }
        }
    }
    return {-1, -1, -1};
}

bool dfsTo(int x, int y, int xTo, int yTo, vector<OrPosition> &seq) {
    //  cerr << x << " " << y << " " << xTo << " " << yTo << '\n';
    usedNow[x][y] = timeNow;
    if (x == xTo && y == yTo) {
        return true;
    }
    forn(t, 4) {
        int xx = x + d[t][0], yy = y + d[t][1];
        if (usedNow[xx][yy] != timeNow && !f[xx][yy] && dfsTo(xx, yy, xTo, yTo, seq)) {
            seq.pb({x, y, t});
            return true;
        }
    }
    return false;
}

void addToTotalAns(int x, int y, int xTo, int yTo, vector<string> &totalAns) {
    vector<OrPosition> ans;
    timeNow++;
    //   cerr << x << " " << y << " " << xTo << " " << yTo << '\n';
    assert(dfsTo(x, y, xTo, yTo, ans));
    reverse(all(ans));
    for(auto p : ans) totalAns.pb("M" + orient[p.k]);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n, m;
    cin >> n >> m;
    forn(i, n) {
        string s;
        cin >> s;
        forn(j, m) {
            if (s[j] == 'W') f[i][j] = 2;
            else if (s[j] == 'G') f[i][j] = 1;
        }
    }
    calcClosestShit(n, m);
    int compNum = 0;
    forn(i, n) {
        forn(j, m) {
            if (f[i][j] == 0 && !comp[i][j]) {
                markComp(i, j, ++compNum);
            }
        }
    }

    int xS, yS, xF, yF;
    cin >> xS >> yS >> xF >> yF;
    xS--, yS--, xF--, yF--;
    int compS = comp[xS][yS];
    int compF = comp[xF][yF];

    vector<OrPosition> ans;
    if (compS == compF) {
        cout << 0 << ' ';
        dfsTo(xS, yS, xF, yF, ans);
        reverse(all(ans));
        cout << sz(ans) << '\n';
        for(auto& s : ans) {
            cout << "M" << orient[s.k] << '\n';
        }
        return 0;
    }

    if (!compS || !compF) {
        finish();
    }
    forn(i, n) {
        forn(j, m) {
            forn(t, 4) {
                calcPortalLocation(i, j, t);
                int compFrom = comp[i][j];
                int compTo = portalComp[i][j][t];
                if (!compFrom || !compTo) {
                    continue;
                }
                g[compFrom].insert(compTo);
                fromComp[compFrom][compTo] = {i, j, t};
            }
        }
    }

    OrPosition initPosition = checkFromComp(compS, n, m);
    if (initPosition.x == -1) finish();

    forn(i, compNum) {
        dist[i + 1] = INF;
    }
    dist[compS] = 0;
    queue<int> q;
    q.push(compS);
    prv[compS] = compS;
    while(!q.empty()) {
        int v = q.front();
        q.pop();
        for (int to : g[v]) {
            if (dist[to] > dist[v] + 1) {
                dist[to] = dist[v] + 1;
                prv[to] = v;
                if (!used[to]) {
                    q.push(to);
                    used[to] = 1;
                }
            }
        }
    }
/*    forn(i, n) {
        forn(j, m) {
            cout << comp[i][j];
        }
        cout << '\n';
    }
    cout << dist[compF] + 1 << '\n';*/
    if (dist[compF] >= INF) finish();

    vi compSeq;
    int curComp = compF;
    compSeq.pb(curComp);
    do {
        curComp = prv[curComp];
        compSeq.pb(curComp);
    } while(prv[curComp] != curComp);
    reverse(all(compSeq));
    /*  for(int c : compSeq) {
          cerr << c << '\n';
      }*/


    cout << dist[compF] + 1 << " ";
    vector<string> totalAns;

    curComp = compS;
    int xCur = xS, yCur = yS;
    int got = 0;
    forn(i, sz(compSeq) - 1) {
        while(true) {
            int xx = initPosition.x + d[initPosition.k][0], yy = initPosition.y + d[initPosition.k][1];
            if (comp[xx][yy] != comp[initPosition.x][initPosition.y]) {
                break;
            }
            initPosition.x = xx;
            initPosition.y = yy;
        }
        //      cerr << i << '\n';
        OrPosition whereToGo = fromComp[curComp][compSeq[i + 1]];
        //      cerr << initPosition.x << " " << initPosition.y << '\n';
        //     cerr << whereToGo.x << " " << whereToGo.y << '\n';
        addToTotalAns(xCur, yCur, whereToGo.x, whereToGo.y, totalAns);
        xCur = whereToGo.x, yCur = whereToGo.y;
        if (got == 0) totalAns.pb("O" + orient[whereToGo.k]);
        else if (got == 1) totalAns.pb("B" + orient[whereToGo.k]);
        got ^= 1;
        if (i != 0) {
            addToTotalAns(xCur, yCur, initPosition.x, initPosition.y, totalAns);
            xCur = initPosition.x, yCur = initPosition.y;
        } else {
            addToTotalAns(xCur, yCur, initPosition.x, initPosition.y, totalAns);
            xCur = initPosition.x, yCur = initPosition.y;
            if (got == 0) totalAns.pb("O" + orient[initPosition.k]);
            else if (got == 1) totalAns.pb("B" + orient[initPosition.k]);
        }
        totalAns.pb("M" + orient[initPosition.k]);
        pii finalPortal = portalLocation[whereToGo.x][whereToGo.y][whereToGo.k];
        initPosition = {finalPortal.fst, finalPortal.snd, whereToGo.k};
        curComp = compSeq[i + 1];
        xCur = initPosition.x, yCur = initPosition.y;
    }
    addToTotalAns(xCur, yCur, xF, yF, totalAns);
    assert(sz(totalAns) - (dist[compF] + 1) <= 2 * n * m);
    cout << sz(totalAns) - (dist[compF] + 1) << '\n';
    for (string tt : totalAns) cout << tt << '\n';
    return 0;
}