#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <iomanip>
#include <queue>
#include <cmath>
#include <stack>
#include <bitset>
#include <unordered_set>
#include <unordered_map>
#include <cassert>

using namespace std;

#define forn(i,n) for(int i=0;i<n;i++)
#define fornr(i,n) for(int i=n-1;i>=0;i--)
#define forab(i,a,b) for(int i=a;i<b;i++)
#define pb push_back
#define all(v) v.begin(),v.end()
#define sz(v) int(v.size())
#define fst first
#define snd second
#define mp make_pair

typedef double dbl;
typedef unsigned long long ull;
typedef long long ll;
typedef pair<int,int> pii;
typedef vector<int> vi;

const int K = 26;
const int N = int(2e5) + 100;

struct Node {
    int inNode;
    int to[K];
    int got[K];
    int total;
    int gotWithout[K];

    Node() {
        total = 0;
        inNode = 0;
        forn(i, K) {
            to[i] = -1;
            got[i] = 0;
            gotWithout[i] = 0;
        }
    }
};

Node nodes[N];
int totalNodes = 1;

void addString(string &t) {
    int curNode = 0;
    nodes[curNode].inNode++;
    for(char c : t) {
        if (nodes[curNode].to[c - 'a'] == -1) {
            nodes[curNode].to[c - 'a'] = totalNodes++;
        }
        nodes[curNode].got[c - 'a']++;
        nodes[curNode].total++;
        curNode = nodes[curNode].to[c - 'a'];
        nodes[curNode].inNode++;
    }
}

string s[N];
map<pii, int> savedAns;

int stupidCalc(int w, int k) {
    int ans = 0;
    int curNode = 0;
    int kSlow = 0;
    int alreadyGot = 0;
    int shouldAdd = 1;
    forn(i, sz(s[w])) {
        char c = s[w][i];
        int to = c - 'a';
        curNode = nodes[curNode].to[to];

        int stringsAround = nodes[curNode].inNode;
        if (i == sz(s[w]) - 1) {
            stringsAround--;
        } else {
            to = s[w][i + 1] - 'a';
            stringsAround -= nodes[nodes[curNode].to[to]].inNode;
        }

        while(kSlow && stringsAround + alreadyGot >= k) {
            kSlow--;
            stringsAround -= (k - alreadyGot);
            ans +=  (k - alreadyGot);
            alreadyGot = 0;
        }
        if (stringsAround < k) {
            ans += stringsAround;
            kSlow++;
            alreadyGot += stringsAround;
        } else {
            ans += k;
            if (i == sz(s[w]) - 1) {
                shouldAdd = 0;
            }
        }
    }
    return ans + shouldAdd;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif
    int n;
    cin >> n;
    forn(i, n) {
        cin >> s[i];
        addString(s[i]);
    }
    forn(i, totalNodes) {
        forn(j, K) {
            nodes[i].gotWithout[j] = nodes[i].total - nodes[i].got[j];
        }
    }

    int q;
    cin >> q;
    forn(qq, q) {
        int w, k;
        cin >> w >> k;
        w--;
        if (savedAns.find(mp(w, k)) == savedAns.end()) {
            int ans = stupidCalc(w, k);
            savedAns[mp(w, k)] = ans;
        }
        cout << savedAns[mp(w, k)] << '\n';
    }
    return 0;
}