#include <bits/stdc++.h>

using namespace std;


int64_t getHashByVector(vector <int> &v) {
    int64_t h = 1;
    for (int i = 0; i < v.size(); i++) {
        h *= 3005711;
        h += (v[i] + 1);
    }
    return h;
}

int64_t getHashByVector2(vector <int> &v) {
    int64_t h = 0;
    for (int i = 0; i < v.size(); i++) {
        h *= 171917;
        h += (v[i] + 3);
    }
    return h;
}



struct graph {
    vector<vector <int>> leftVector;
    vector<vector <int>> rightVector;

    graph(int left, int right): leftVector(left), rightVector(right) {
    }

    void addEdge(int left, int right) {
        left--;
        right--;
        leftVector[left].push_back(right);
        rightVector[right].push_back(left);
    }

    int getCntTask() {
        int mincnt = leftVector.size();
        for (int i = 0; i < rightVector.size(); i++) {
            mincnt = min(mincnt, (int)rightVector[i].size());
        }
        return mincnt;
    }

    void doSort() {
        for (int i = 0; i < rightVector.size(); i++) {
            sort(rightVector[i].begin(), rightVector[i].end());
        }
    }

    void getAns() {
        doSort();
        map<pair<int64_t, int64_t>, vector<int>> ansMap;
        int revAns = getCntTask();

        for (int i = 0; i < rightVector.size(); i++) {
            if (rightVector[i].size() == revAns) {
                int64_t h = getHashByVector(rightVector[i]);
                int64_t h2 = getHashByVector2(rightVector[i]);
                if (ansMap.count({h, h2}) == 0) {
                    vector <int> x(1, i);
                    ansMap[{h, h2}] = x;
                } else {
                    ansMap[{h, h2}].push_back(i);
                }
            }
        }

        vector <int> ans;
        for (auto x: ansMap) {
            if (ans.size() < x.second.size()) {
                ans = x.second;
            }
        }
        cout << (leftVector.size() - revAns) << ' ' << ans.size() << endl;
        for (auto x: ans) {
            cout << x + 1 << ' ';
        }
    }
};


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int P, T, M;
    cin >> P >> T >> M;
    graph gr(P, T);
    for (int i = 0; i < M; i++) {
        int left, right;
        cin >> left >> right;
        gr.addEdge(left, right);
    }
    gr.getAns();

    return 0;
}
