﻿#pragma GCC optimize("O3")
//#pragma GCC target("sse2","sse4")
//#pragma GCC optimize("unroll-loops")

#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cmath>
#include <cassert>
#include <cstring>
#include <string>
#include <bitset>
#include <iomanip>
#include <random>
#include <ctime>
#include <unordered_map>
#include <unordered_set>

#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define mp make_pair
#define eb emplace_back

using namespace std; using ll = long long; using pii = pair<int, int>; using vi = vector<int>; using ld = long double;
/*
struct Line {
	ld a, b, c;
};

struct Point {
	ld x, y;
	Point() {}
	Point(ld x, ld y) : x(x), y(y) {}
	Point operator + (const Point& other) {
		return Point(x + other.x, y + other.y);
	}
	Point operator * (ld a) {
		return Point(a * x, a * y);
	}
	ld len() {
		return x * x + y * y;
	}
};

Point isec(const Line& l1, const Line& l2) {
	ld y = ( l2.a * l1.c - l2.c * l1.a ) / ( l1.a * l2.b - l2.a * l1.b );
	ld x = ( -l1.b * y - l1.c ) / l1.a;
	return Point(x, y);
}

Point base;

ld dot(const Point& a, const Point& b) {
	return a.x * b.y - a.y * b.x;
}

const ld eps = 1e-8;

bool eq(ld a, ld b) {
	return abs(a - b) < eps;
}

bool cmp(Point a, Point b) {
	a.x -= base.x;
	a.y -= base.y;
	b.x -= base.x;
	b.y -= base.y;
	bool up1 = a.y > 0 || (a.y == 0 && a.x > 0);
	bool up2 = b.y > 0 || (b.y == 0 && b.x > 0);
	if (up1 != up2) return up1 > up2;
	ld d = dot(a, b);
	if (eq(d, 0)) return a.len() < b.len();
	else return d > 0;
}

bool same(Point a, Point b) {
	a.x -= base.x;
	a.y -= base.y;
	b.x -= base.x;
	b.y -= base.y;
	bool up1 = a.y > 0 || (a.y == 0 && a.x > 0);
	bool up2 = b.y > 0 || (b.y == 0 && b.x > 0);
	if (up1 != up2) return false;
	ld d = dot(a, b);
	if (eq(d, 0)) return true;
	else return false;
}


*/


struct edge {
	int wh;
	int str;
	int start;
	int end;

	edge() {
		wh = -1;
	}
};

bool dfs(vector<string>& lab, pair<int, int> x, pair<int, int> y, vector<vector<bool>>& vis, vector<string>& pth) {
	if (x.first == y.first && x.second == y.second) return 1;
	if (vis[x.first][x.second]) return 0;
	vis[x.first][x.second] = true;

	if (x.first > 0 && lab[x.first - 1][x.second] == '.') {
		if (dfs(lab, mp(x.first - 1, x.second), y, vis, pth)) {
			pth.pb("MU");
			return 1;
		}
	}

	if (x.first < sz(lab) - 1 && lab[x.first + 1][x.second] == '.') {
		if (dfs(lab, mp(x.first + 1, x.second), y, vis, pth)) {
			pth.pb("MD");
			return 1;
		}
	}

	if (x.second > 0 && lab[x.first][x.second - 1] == '.') {
		if (dfs(lab, mp(x.first, x.second - 1), y, vis, pth)) {
			pth.pb("ML");
			return 1;
		}
	}

	if (x.second < sz(lab[x.first]) - 1 && lab[x.first][x.second + 1] == '.') {
		if (dfs(lab, mp(x.first, x.second + 1), y, vis, pth)) {
			pth.pb("MR");
			return 1;
		}
	}

	return 0;
}

// BLYAT ROMA UMER..... 
const int M = 1e5 + 1488;
vector<int> g[1000005];
int32_t main() {
	ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
	//ifstream cin("in.txt");
	
	int N, M;
	cin >> N >> M;

	vector<string> lab(N);
	for (int i = 0; i < N; i++) cin >> lab[i];

	int sx, sy, ex, ey;
	cin >> sx >> sy >> ex >> ey;
	sx--, sy--, ex--, ey--;

	// Portal Gun

	vector<vector<int>> ptN(N, vi(M)), ptS(N, vi(M)), ptW(N, vi(M)), ptE(N, vi(M));

	// North
	for (int i = 0; i < M; i++) {
		int wall_pos = 0;
		for (int j = 0; j < N; j++) {
			if (lab[j][i] == 'W') wall_pos = j;
			ptN[j][i] = wall_pos + 1;
		}
	}

	// South
	for (int i = 0; i < M; i++) {
		int wall_pos = 0;
		for (int j = N - 1; j >= 0; j--) {
			if (lab[j][i] == 'W') wall_pos = j;
			ptS[j][i] = wall_pos - 1;
		}
	}

	// West
	for (int i = 0; i < N; i++) {
		int wall_pos = 0;
		for (int j = 0; j < M; j++) {
			if (lab[i][j] == 'W') wall_pos = j;
			ptW[i][j] = wall_pos + 1;
		}
	}

	// East
	for (int i = 0; i < N; i++) {
		int wall_pos = 0;
		for (int j = M - 1; j >= 0; j--) {
			if (lab[i][j] == 'W') wall_pos = j;
			ptE[i][j] = wall_pos - 1;
		}
	}

	// 0-1 BFS

	vector<int> dist(N * M, 1e9);
	dist[sx * M + sy] = 0;
	vector<pair<bool, pair<int, int>>> last(N * M, mp(false, mp(-1, -1)));

	vector<pair<int, int>> zero, one;
	zero.pb(mp(sx, sy));

	while (!zero.empty()) {
		auto cur = zero.back();
		zero.pop_back();

		// NO PORTAL
		if (cur.first > 0 && lab[cur.first - 1][cur.second] == '.' && dist[(cur.first - 1) * M + cur.second] > dist[cur.first * M + cur.second]) {
			dist[(cur.first - 1) * M + cur.second] = dist[cur.first * M + cur.second];
			last[(cur.first - 1) * M + cur.second] = mp(false, cur);
			zero.eb(cur.first - 1, cur.second);
		}
		if (cur.first < N - 1 && lab[cur.first + 1][cur.second] == '.' && dist[(cur.first + 1) * M + cur.second] > dist[cur.first * M + cur.second]) {
			dist[(cur.first + 1) * M + cur.second] = dist[cur.first * M + cur.second];
			last[(cur.first + 1) * M + cur.second] = mp(false, cur);
			zero.eb(cur.first + 1, cur.second);
		}
		if (cur.second > 0 && lab[cur.first][cur.second - 1] == '.' && dist[cur.first * M + cur.second - 1] > dist[cur.first * M + cur.second]) {
			dist[cur.first * M + cur.second - 1] = dist[cur.first * M + cur.second];
			last[cur.first * M + cur.second - 1] = mp(false, cur);
			zero.eb(cur.first, cur.second - 1);
		}
		if (cur.second < M - 1 && lab[cur.first][cur.second + 1] == '.' && dist[cur.first * M + cur.second + 1] > dist[cur.first * M + cur.second]) {
			dist[cur.first * M + cur.second + 1] = dist[cur.first * M + cur.second];
			last[cur.first * M + cur.second + 1] = mp(false, cur);
			zero.eb(cur.first, cur.second + 1);
		}

		// PORTAL
		if (lab[ptN[cur.first][cur.second]][cur.second] == '.' && dist[ptN[cur.first][cur.second] * M + cur.second] > dist[cur.first * M + cur.second] + 1) {
			dist[ptN[cur.first][cur.second] * M + cur.second] = dist[cur.first * M + cur.second] + 1;
			last[ptN[cur.first][cur.second] * M + cur.second] = mp(true, cur);
			one.eb(ptN[cur.first][cur.second], cur.second);
		}
		if (lab[ptS[cur.first][cur.second]][cur.second] == '.' && dist[ptS[cur.first][cur.second] * M + cur.second] > dist[cur.first * M + cur.second] + 1) {
			dist[ptS[cur.first][cur.second] * M + cur.second] = dist[cur.first * M + cur.second] + 1;
			last[ptS[cur.first][cur.second] * M + cur.second] = mp(true, cur);
			one.eb(ptS[cur.first][cur.second], cur.second);
		}
		if (lab[cur.first][ptW[cur.first][cur.second]] == '.' && dist[cur.first * M + ptW[cur.first][cur.second]] > dist[cur.first * M + cur.second] + 1) {
			dist[cur.first * M + ptW[cur.first][cur.second]] = dist[cur.first * M + cur.second] + 1;
			last[cur.first * M + ptW[cur.first][cur.second]] = mp(true, cur);
			one.eb(cur.first, ptW[cur.first][cur.second]);
		}
		if (lab[cur.first][ptE[cur.first][cur.second]] == '.' && dist[cur.first * M + ptE[cur.first][cur.second]] > dist[cur.first * M + cur.second] + 1) {
			dist[cur.first * M + ptE[cur.first][cur.second]] = dist[cur.first * M + cur.second] + 1;
			last[cur.first * M + ptE[cur.first][cur.second]] = mp(true, cur);
			one.eb(cur.first, ptE[cur.first][cur.second]);
		}

		if (zero.empty()) swap(zero, one);
	}

	vector<pair<bool, pair<int, int>>> actions;
	int cur_x = ex, cur_y = ey;
	if (dist[cur_x * M + cur_y] == 1e9) {
		cout << "-1 -1" << endl;
		return 0;
	}

	while (cur_x != sx || cur_y != sy) {
		actions.eb(last[cur_x * M + cur_y].first, mp(cur_x, cur_y));
		auto lnk = last[cur_x * M + cur_y].second;
		cur_x = lnk.first;
		cur_y = lnk.second;
	}

	actions.eb(false, mp(sx, sy));

	reverse(all(actions));

	// 0 - N
	// 1 - E
	// 2 - S
	// 3 - W

	vector<pair<int, pair<int, int>>> ploc;

	bool found_portal = false;

	for (int i = 0; i < N && !found_portal; i++) {
		for (int j = 0; j < M && !found_portal; j++) {
			if (dist[i * M + j] == 0) {
				if (i > 0 && lab[i - 1][j] == 'W') ploc.eb(0, mp(i, j)), found_portal = true;
				else if (i < N - 1 && lab[i + 1][j] == 'W') ploc.eb(2, mp(i, j)), found_portal = true;
				else if (j > 0 && lab[i][j - 1] == 'W') ploc.eb(3, mp(i, j)), found_portal = true;
				else if (j < M - 1 && lab[i][j + 1] == 'W') ploc.eb(1, mp(i, j)), found_portal = true;
			}
		}
	}

	for (int i = 1; i < sz(actions); i++) {
		if (actions[i].first) {
			if (actions[i].second.first < actions[i - 1].second.first) ploc.eb(0, actions[i].second);
			else if (actions[i].second.second > actions[i - 1].second.second) ploc.eb(1, actions[i].second);
			else if (actions[i].second.first > actions[i - 1].second.first) ploc.eb(2, actions[i].second);
			else if (actions[i].second.second < actions[i - 1].second.second) ploc.eb(3, actions[i].second);
		}
	}

	vector<vector<bool>> vis(N, vector<bool>(M));

	if (sz(ploc) + !found_portal == 1) {
		cout << 0 << ' ' << sz(actions) - 1 << endl;
		for (int i = 1; i < sz(actions); i++) {
			cout << "M";
			if (actions[i].second.first < actions[i - 1].second.first) cout << "U\n";
			else if (actions[i].second.second > actions[i - 1].second.second) cout << "R\n";
			else if (actions[i].second.first > actions[i - 1].second.first) cout << "D\n";
			else if (actions[i].second.second < actions[i - 1].second.second) cout << "L\n";
		}
	}

	else if (!found_portal) {
		cout << "-1 -1" << endl;
	}
	else {
		// 1st open portal --
		// go to portal location, open, go through
		// Others - without 'open'

		vector<string> acc;
		int portals_vis = 1;

		for (int i = 1; i < sz(actions); i++) {
			if (!actions[i].first) {
				acc.pb("M");
				if (actions[i].second.first < actions[i - 1].second.first) acc.back() += "U";
				else if (actions[i].second.second > actions[i - 1].second.second) acc.back() += "R";
				else if (actions[i].second.first > actions[i - 1].second.first) acc.back() += "D";
				else if (actions[i].second.second < actions[i - 1].second.second) acc.back() += "L";
			}
			else {
				if (portals_vis % 2) acc.pb("O");
				else acc.pb("B");
				if (ploc[portals_vis].first == 0) acc.back() += "U";
				if (ploc[portals_vis].first == 1) acc.back() += "R";
				if (ploc[portals_vis].first == 2) acc.back() += "D";
				if (ploc[portals_vis].first == 3) acc.back() += "L";

				vector<string> pth;

				dfs(lab, actions[i - 1].second, ploc[portals_vis - 1].second, vis, pth);
				reverse(all(pth));
				for (auto el : pth) {
					acc.pb(el);
				}

				if (portals_vis == 1) {
					acc.pb("B");
					if (ploc[0].first == 0) acc.back() += "U";
					if (ploc[0].first == 1) acc.back() += "R";
					if (ploc[0].first == 2) acc.back() += "D";
					if (ploc[0].first == 3) acc.back() += "L";
				}

				acc.pb("M");
				if (ploc[portals_vis - 1].first == 0) acc.back() += "U";
				if (ploc[portals_vis - 1].first == 1) acc.back() += "R";
				if (ploc[portals_vis - 1].first == 2) acc.back() += "D";
				if (ploc[portals_vis - 1].first == 3) acc.back() += "L";

				portals_vis++;
			}
		}

		cout << sz(ploc) << ' ' << sz(acc) - sz(ploc) << endl;
		for (auto el : acc) {
			cout << el << "\n";
		}
	}

	/*
	int x, y, k;
	cin >> x >> y >> k;
	if (k == 1) return cout << 1LL * (x + 1) * (y + 1), 0;
	vector<Point> a(k);
	for (auto& p : a) cin >> p.x >> p.y;
	base = a[0];
	sort(a.begin() + 1, a.end(), cmp);
	{
		vector<Point> tmp = { a[0] };
		for (int i = 1; i < k; i++) {
			tmp.pb(a[i]);
			while (i < k - 1) {
				if (!same(a[i], a[i + 1])) break;
				i++;
			}
		}
		a = tmp;
	}
	vector<Line> l;
	for (int i = 1; i < k; i++) {
		auto p1 = a[0], p2 = a[i];
		Line cur;
		l.pb({ p2.y - p1.y, p1.x - p2.x, -p1.x * (p2.y - p1.y) + p1.y * (p2.x - p1.x) });
	}
	vector<Line> perp;
	int kek = 1;
	for (auto& c : l) {
		Line cur = { -c.b, c.a, 0 };
		auto mid = (a[0] + a[kek]) * 0.5;
		cur.c = -cur.a * mid.x - cur.b * mid.y;
		perp.pb(cur);
		kek++;
	}
	vector<Point> o;
	for (int i = 0; i < k; i++) {

	}
	ld s = 0;
	for (int i = 0; i < sz(o); i++) {
		int j = (i + 1) % sz(o);
		s += dot(o[i], o[j]);
	}
	s = abs(s) / 2;
	*/
	return 0;
}