﻿#pragma GCC optimize("O3")
//#pragma GCC target("sse2","sse4")
//#pragma GCC optimize("unroll-loops")

#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cmath>
#include <cassert>
#include <cstring>
#include <string>
#include <bitset>
#include <iomanip>
#include <random>
#include <ctime>
#include <unordered_map>
#include <unordered_set>

#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define mp make_pair
#define eb emplace_back

using namespace std; using ll = long long; using pii = pair<int, int>; using vi = vector<int>; using ld = long double;
/*
struct Line {
	ld a, b, c;
};

struct Point {
	ld x, y;
	Point() {}
	Point(ld x, ld y) : x(x), y(y) {}
	Point operator + (const Point& other) {
		return Point(x + other.x, y + other.y);
	}
	Point operator * (ld a) {
		return Point(a * x, a * y);
	}
	ld len() {
		return x * x + y * y;
	}
};

Point isec(const Line& l1, const Line& l2) {
	ld y = ( l2.a * l1.c - l2.c * l1.a ) / ( l1.a * l2.b - l2.a * l1.b );
	ld x = ( -l1.b * y - l1.c ) / l1.a;
	return Point(x, y);
}

Point base;

ld dot(const Point& a, const Point& b) {
	return a.x * b.y - a.y * b.x;
}

const ld eps = 1e-8;

bool eq(ld a, ld b) {
	return abs(a - b) < eps;
}

bool cmp(Point a, Point b) {
	a.x -= base.x;
	a.y -= base.y;
	b.x -= base.x;
	b.y -= base.y;
	bool up1 = a.y > 0 || (a.y == 0 && a.x > 0);
	bool up2 = b.y > 0 || (b.y == 0 && b.x > 0);
	if (up1 != up2) return up1 > up2;
	ld d = dot(a, b);
	if (eq(d, 0)) return a.len() < b.len();
	else return d > 0;
}

bool same(Point a, Point b) {
	a.x -= base.x;
	a.y -= base.y;
	b.x -= base.x;
	b.y -= base.y;
	bool up1 = a.y > 0 || (a.y == 0 && a.x > 0);
	bool up2 = b.y > 0 || (b.y == 0 && b.x > 0);
	if (up1 != up2) return false;
	ld d = dot(a, b);
	if (eq(d, 0)) return true;
	else return false;
}


*/


struct edge {
	int wh;
	int str;
	int start;
	int end;

	edge() {
		wh = -1;
	}
};


int32_t main() {
	ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
	//ifstream cin("in.txt");
	int N;
	cin >> N;

	vector<string> strs(N);

	for (int i = 0; i < N; i++) cin >> strs[i];

	vector<vector<edge>> bohr(1, vector<edge>(26));
	vector<int> bohr_sz(1, N);

	for (int i = 0; i < N; i++) {
		int pos = 0;
		int s_pos = 0;
		while (s_pos < sz(strs[i])) {
			int v = strs[i][s_pos] - 'a';
			if (bohr[pos][v].wh == -1) {
				bohr[pos][v].wh = sz(bohr);
				bohr[pos][v].str = i;
				bohr[pos][v].start = s_pos;
				bohr[pos][v].end = sz(strs[i]);
				bohr.eb(26);
				bohr_sz.pb(1);
				break;
			}
			int l = 0;
			while (s_pos + l < sz(strs[i]) && l < bohr[pos][v].end - bohr[pos][v].start && strs[i][s_pos + l] == strs[bohr[pos][v].str][bohr[pos][v].start + l]) l++;

			if (l == bohr[pos][v].end - bohr[pos][v].start) {
				s_pos += l;
				pos = bohr[pos][v].wh;
				bohr_sz[pos]++;
			}
			else {
				int n_pos = sz(bohr);
				bohr.eb(26);
				bohr_sz.pb(bohr_sz[bohr[pos][v].wh] + 1);
				bohr[n_pos][strs[i][s_pos + l] - 'a'].wh = sz(bohr);
				bohr[n_pos][strs[i][s_pos + l] - 'a'].str = i;
				bohr[n_pos][strs[i][s_pos + l] - 'a'].start = s_pos + l;
				bohr[n_pos][strs[i][s_pos + l] - 'a'].end = sz(strs[i]);
				bohr.eb(26);
				bohr_sz.pb(1);
				bohr[n_pos][strs[bohr[pos][v].str][bohr[pos][v].start + l] - 'a'] = bohr[pos][v];
				bohr[n_pos][strs[bohr[pos][v].str][bohr[pos][v].start + l] - 'a'].start += l;
				bohr[pos][v].end = bohr[pos][v].start + l;
				bohr[pos][v].wh = n_pos;
				break;
			}
		}
	}

	int Q;
	cin >> Q;

	for (int i = 0; i < Q; i++) {
		int s, k;
		cin >> s >> k;
		s--;

		int pos = 0;
		int s_pos = 0;
		int carry = 0;
		int ans = 0;

		while (s_pos < sz(strs[s])) {
			int v = strs[s][s_pos] - 'a';
			int vd = min(carry, - bohr_sz[bohr[pos][v].wh] + bohr_sz[pos]);
			carry -= vd;
			carry += k * (bohr[pos][v].end - bohr[pos][v].start);
			ans += vd;

			s_pos += bohr[pos][v].end - bohr[pos][v].start;
			pos = bohr[pos][v].wh;
		}

		ans += min(carry, bohr_sz[pos]);

		cout << ans << endl;
	}

	/*
	int x, y, k;
	cin >> x >> y >> k;
	if (k == 1) return cout << 1LL * (x + 1) * (y + 1), 0;
	vector<Point> a(k);
	for (auto& p : a) cin >> p.x >> p.y;
	base = a[0];
	sort(a.begin() + 1, a.end(), cmp);
	{
		vector<Point> tmp = { a[0] };
		for (int i = 1; i < k; i++) {
			tmp.pb(a[i]);
			while (i < k - 1) {
				if (!same(a[i], a[i + 1])) break;
				i++;
			}
		}
		a = tmp;
	}
	vector<Line> l;
	for (int i = 1; i < k; i++) {
		auto p1 = a[0], p2 = a[i];
		Line cur;
		l.pb({ p2.y - p1.y, p1.x - p2.x, -p1.x * (p2.y - p1.y) + p1.y * (p2.x - p1.x) });
	}
	vector<Line> perp;
	int kek = 1;
	for (auto& c : l) {
		Line cur = { -c.b, c.a, 0 };
		auto mid = (a[0] + a[kek]) * 0.5;
		cur.c = -cur.a * mid.x - cur.b * mid.y;
		perp.pb(cur);
		kek++;
	}
	vector<Point> o;
	for (int i = 0; i < k; i++) {

	}
	ld s = 0;
	for (int i = 0; i < sz(o); i++) {
		int j = (i + 1) % sz(o);
		s += dot(o[i], o[j]);
	}
	s = abs(s) / 2;
	*/
	return 0;
}