﻿#pragma GCC optimize("O3")
//#pragma GCC target("sse2","sse4")
//#pragma GCC optimize("unroll-loops")

#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cmath>
#include <cassert>
#include <cstring>
#include <string>
#include <bitset>
#include <iomanip>
#include <random>
#include <ctime>
#include <unordered_map>
#include <unordered_set>

#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define pb push_back
#define mp make_pair
#define eb emplace_back

using namespace std; using ll = long long; using pii = pair<int, int>; using vi = vector<int>; using ld = long double;



struct Point {
	ld x, y;
	Point() {}
	Point(ld x, ld y) : x(x), y(y) {}
	Point operator + (const Point& other) {
		return Point(x + other.x, y + other.y);
	}
	Point operator * (ld a) {
		return Point(a * x, a * y);
	}
	ld len2() {
		return x * x + y * y;
	}
};

struct Line {
	ld a, b, c;
	ld eval(Point& p) {
		return a * p.x + b * p.y + c;
	}
	ld evalx(ld x) {
		return (-c - a * x) / b;
	}
};

bool cmp1(const Line& l1, const Line& l2) {
	return (-l1.a / l1.b > -l2.a / l2.b) || (-l1.a / l1.b == -l2.a / l2.b && l1.c / l1.b > l2.c / l2.b);
}

bool cmp2(const Line& l1, const Line& l2) {
	return (-l1.a / l1.b > -l2.a / l2.b) || (-l1.a / l1.b == -l2.a / l2.b && l1.c / l1.b < l2.c / l2.b);
}

Point isec(const Line& l1, const Line& l2) {
	ld y = (l2.a * l1.c - l2.c * l1.a) / (l1.a * l2.b - l2.a * l1.b);
	ld x = (l2.b * l1.c - l2.c * l1.b) / (l1.b * l2.a - l2.b * l1.a);
	return Point(x, y);
}

ld dot(const Point& a, const Point& b) {
	return a.x * b.y - a.y * b.x;
}

const ld eps = 1e-12;

bool eq(ld a, ld b) {
	return abs(a - b) < eps;
}

int32_t main() {
	ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
	//ifstream cin("in.txt");
	int x, y, k;
	cin >> x >> y >> k;
	if (k == 1) return cout << 1LL * (ll)(x + 1) * (y + 1), 0;
	vector<Point> a(k);
	for (auto& p : a) cin >> p.x >> p.y;

	vector<Line> l;
	for (int i = 1; i < k; i++) {
		auto p1 = a[0], p2 = a[i];
		Line cur = { p2.y - p1.y, p1.x - p2.x, -p1.x * (p2.y - p1.y) + p1.y * (p2.x - p1.x) };
		l.pb(cur);
	}
	vector<Line> up = { { (ld)0, (ld)1, (ld)-y } }, dow = { { (ld)0, (ld)1, (ld)0 } }; // perps
	ld leftmost = 0, rightmost = x;
	for (int i = 0; i < k - 1; i++) {
		auto& c = l[i];
		auto mid = (a[0] + a[i + 1]) * 0.5;
		Line cur = { -c.b, c.a, 0 };
		cur.c = -cur.a * mid.x - cur.b * mid.y;
		if (eq(cur.b, 0)) {
			ld xx = -cur.c / cur.a;
			if (xx < a[0].x) leftmost = max(leftmost, xx);
			else rightmost = min(rightmost, xx);
		}
		else {
			if ((cur.eval(a[0]) > 0) ^ (cur.b > 0)) up.pb(cur);
			else dow.pb(cur);
		}
	}
	sort(all(up), cmp1);
	sort(all(dow), cmp2);
	reverse(all(dow));
	vector<Line> hup;
	for (auto l : up) {
		while (sz(hup) > 1) {
			int n = sz(hup);
			if (isec(hup[n - 2], hup[n - 1]).x < isec(hup[n - 1], l).x) break;
			hup.pop_back();
		}
		if (sz(hup) == 0 || !eq(-l.a / l.b, -hup.back().a / hup.back().b)) hup.pb(l);
	}
	vector<Line> hdow;
	for (auto l : dow) {
		while (sz(hdow) > 1) {
			int n = sz(hdow);
			if (isec(hdow[n - 2], hdow[n - 1]).x < isec(hdow[n - 1], l).x) break;
			hdow.pop_back();
		}
		if (sz(hdow) == 0 || !eq(-l.a / l.b, -hdow.back().a / hdow.back().b)) hdow.pb(l);
		//hdow.pb(l);
	}

	for (auto& ln : hup) ln.c += eps * (2 * signbit(ln.b) - 1);
	for (auto& ln : hdow) ln.c -= eps * (2 * signbit(ln.b) - 1);

	ll ans = 0;
	int p1 = 0, p2 = 0;

	//auto isecur = isec(hup[p1], hup[p1 + 1]);

	for (int i = ceil(leftmost - eps); i <= floor(rightmost + eps); i++) {
		while (p1 < sz(hup) - 1 && isec(hup[p1], hup[p1 + 1]).x <= i) p1++;
		while (p2 < sz(hdow) - 1 && isec(hdow[p2], hdow[p2 + 1]).x <= i) p2++;
		ll yup = floor(hup[p1].evalx(i) + eps);
		ll ydow = ceil(hdow[p2].evalx(i) - eps);
		ans += max(0LL, yup - ydow + 1);
	}
	cout << ans;
	return 0;
}