

#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <cmath>
#include <set>
#include <string>
#include <deque>
#include <stack>
#include <queue>

#define MP make_pair
#define PB push_back
#define F first
#define S second
#define EPS 1e-7
#define MOD 1000000007

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<long long, long long> pll;
typedef long double ld;

vector<vector<int>> problem;
vector<vector<int>> person;
vector<bool> used_pr;
vector<bool> used_per;
int curr_pr = 0, curr_per = 0;
int best_pr = 0, best_per = 1e9;
vector<int> curr;
vector<int> best;


void dfs(int v, bool prob) {
    if (prob) {
        used_pr[v] = true;
        curr_pr++;
        curr.PB(v);
        for (auto &per: problem[v])
            if (!used_per[per])
                dfs(per, false);
    } else {
        used_per[v] = true;
        curr_per++;
        for (auto &pr: person[v])
            if (!used_pr[pr])
                dfs(pr, true);
    }
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int p, t, m;
    cin >> p >> t >> m;
    problem.resize(t);
    used_pr.resize(t);
    person.resize(p);
    used_per.resize(p);
    for (int i = 0, a, b; i < m; i++) {
        cin >> a >> b;
        problem[--b].PB(--a);
        person[a].PB(b);
    }
    int cnt = 0;
    for (int i = 0; i < t; i++) {
        cnt += problem[i].empty();
    }
    if (cnt == 0) {
        int min_v = 0;
        for (int i = 1; i < t; i++)
            if (problem[i].size() < problem[min_v].size())
                min_v = i;
        best.PB(min_v);
        best_pr = 1;
        best_per = problem[min_v].size();
        for (int i = 0; i < t; i++)
            if (problem[i].size() > best_per)
                used_pr[i] = true;
        for (int i = 0; i < t; i++) {
            if (!used_pr[i]) {
                curr.resize(0);
                curr_per = 0;
                curr_pr = 0;
                dfs(i, true);
                if (curr_per < best_per || (curr_per == best_per && curr_pr > best_pr)) {
                    best_pr = curr_pr;
                    best_per = curr_per;
                    swap(curr, best);
                }
            }
        }
        cout << p - best_per << ' ' << best_pr << '\n';
        for (auto &el: best)
            cout << el + 1 << ' ';
        return 0;
    }
    cout << p << ' ' << cnt << '\n';
    for (int i = 0; i < t; i++)
        if (problem[i].empty())
            cout << i + 1 << ' ';
    return 0;
}


/*5 4 9
1 1
2 1
3 2
3 3
3 4
4 2
4 3
4 4
 5 4*/