#include <iostream>
#include <set>
#include <vector>
#include <map>
#include <unordered_map>
#include <utility>
#include <cmath>
#include <queue>

template <typename T>
T make_vector() {
    return T();
}

template <typename T, typename V, typename... Args>
auto make_vector(V v, Args... args) {
    return std::vector(v, make_vector<T>(args...));
}

template <typename... Args>
void read(Args&... args) {
    (std::cin >> ... >> args);
}

void print() {
    std::cout << '\n';
}

template <typename T, typename... Args>
void print(T&& t, Args&&... args) {
    std::cout << std::forward<T>(t) << ' ';
    print(std::forward<Args>(args)...);
}

int main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
#ifdef HOME
    std::freopen("input.txt", "rt", stdin);
#endif
    print(1);
    return 0;
}
