#include <iostream>
#include <set>
#include <vector>
#include <map>
#include <unordered_map>
#include <utility>
#include <cmath>
#include <queue>

template <typename T>
T make_vector() {
    return T();
}

template <typename T, typename V, typename... Args>
auto make_vector(V v, Args... args) {
    return std::vector(v, make_vector<T>(args...));
}

template <typename... Args>
void read(Args&... args) {
    (std::cin >> ... >> args);
}

void print() {
    std::cout << '\n';
}

template <typename T, typename... Args>
void print(T&& t, Args&&... args) {
    std::cout << std::forward<T>(t) << ' ';
    print(std::forward<Args>(args)...);
}

using namespace std;

struct Player {
    int rost;
    int ryki;
    int score;
    int podb;
    int pered;
};

struct Param {
    int low;
    int lowMiddle;
    int highMiddle;
    int high;
};

void process(Param& answer, int leftBound, int rightBound, int actual) {
    if (actual < leftBound) {
        answer.low++;
    } else if (actual > rightBound) {
        answer.high++;
    } else if (actual - leftBound < rightBound - actual) {
        answer.lowMiddle++;
    } else {
        answer.highMiddle++;
    }
}

Param get(Player p) {
    Param result = {0, 0, 0, 0};
    process(result, 190, 220, p.rost);
    process(result, 200, 250, p.ryki);
    process(result, 10, 20, p.score);
    process(result, 2, 6, p.podb);
    process(result, 3, 7, p.pered);
    return result;
}

int main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
#ifdef HOME
    std::freopen("input.txt", "rt", stdin);
#endif
    int n;
    cin >> n;
    vector<Player> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].rost >> a[i].ryki >> a[i].score >> a[i].podb >> a[i].pered;
    }
    for (int i = 0; i < n; i++) {
        Player pl = a[i];
        Param p = get(pl);
        if (p.high >= 3 && (pl.rost > 220 || pl.ryki > 250)) {
            cout << 0 << endl;
            continue;
        }
        if (p.high >= 3 || (p.high == 2 && p.highMiddle > 0)) {
            cout << 1 << endl;
            continue;
        }
        if (p.low == 0 && (p.highMiddle + p.high >= 3)) {
            cout << 1 << endl;
            continue;
        }
        if (p.high >= 2 || (p.high == 1 && p.highMiddle >= 1)) {
            cout << 2 << endl;
            continue;
        }
        if (p.high + p.highMiddle >= 3) {
            cout << 2 << endl;
            continue;
        }
        cout << 3 << endl;
    }
}
