import java.io.*;
import java.util.*;

public class A {
	
	FastScanner in;
	PrintWriter out;

	public long pow(long x, long p) {
		if (p == 0) {
			return 1;
		}
		if (p % 2 == 0) {
			long ans = pow(x, p / 2);
			return ans * ans % mod;
		}
		return pow(x, p - 1) * x % mod;
	}
	
	public long modInv(long x) {
		return pow(x, mod - 2);
	}
	
	long n;
	long a = 26;
	long mod = 1000000007;
	
	public void solve() {
		n = in.nextLong();
		if (n < 4) {
			out.print(0);
			return;
		}
		long x = ((((((n + 1) * pow(a, n) - 4 * pow(a, 3)) % mod) * (a - 1)) % mod) + mod) % mod;
		x += (((pow(a, 4) - pow(a, n + 1)) % mod) + mod) % mod;
		x %= mod;
		long y = pow(a, 3) * pow(a - 1, 2);
		out.print(x * modInv(y) % mod);
	}
	
	public void run() {
		in = new FastScanner();
		out = new PrintWriter(System.out);
		
		solve();
		
		out.close();
	}
	
	class FastScanner {
		StringTokenizer st;
		BufferedReader in;
		
		FastScanner() {
			in = new BufferedReader(new InputStreamReader(System.in));
		}
		
		String nextLine() {
			try {
				return in.readLine();
			} catch (IOException e) {
				e.printStackTrace();
			}
			return null;
		}
		
		String next() {
			while (st == null || !st.hasMoreTokens()) {
				try {
					st = new StringTokenizer(in.readLine());
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
			return st.nextToken();
		}
		
		int nextInt() {
			return Integer.parseInt(next());
		}
		
		long nextLong() {
			return Long.parseLong(next());
		}
		
		double nextDouble() {
			return Double.parseDouble(next());
		}
		
		boolean nextBoolean() {
			return Boolean.parseBoolean(next());
		}
	}
	
	public static void main(String[] args) {
		new A().run();
	}

}
