#include <iostream>
#include <set>
#include <vector>
#include <map>
#include <unordered_map>
#include <utility>
#include <cmath>
#include <queue>
#include <algorithm>
#include <memory>

template <typename T>
T make_vector() {
    return T();
}

template <typename T, typename V, typename... Args>
auto make_vector(V v, Args... args) {
    return std::vector(v, make_vector<T>(args...));
}

template <typename... Args>
void read(Args&... args) {
    (std::cin >> ... >> args);
}

void print() {
    std::cout << '\n';
}

template <typename T, typename... Args>
void print(T&& t, Args&&... args) {
    std::cout << std::forward<T>(t) << ' ';
    print(std::forward<Args>(args)...);
}

using namespace std;

int main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);
#ifdef HOME
    std::freopen("input.txt", "rt", stdin);
#endif

    int p, t, m;
    read(p, t, m);
    vector<vector<int>> know(t);
    for (int e = 0; e < m; ++e) {
        int u, v;
        read(u, v);
        --u, --v;
        know[v].push_back(u);
    }
    size_t degree = p;
    for (auto& v : know) {
        degree = min(degree, v.size());
        sort(v.begin(), v.end());
    }
    struct node {
        map<int, shared_ptr<node>> adj;
        vector<int> from;
    };
    using ptr_t = shared_ptr<node>;
    auto root = make_shared<node>();
    vector<int>* answer = nullptr;
    for (int i = 0; i < t; ++i) {
        auto& v = know[i];
        if (v.size() != degree) {
            continue;
        }
        auto cur = root;
        for (auto x : v) {
            if (!cur->adj.count(x)) {
                cur->adj[x] = make_shared<node>();
            }
            cur = cur->adj[x];
        }
        cur->from.push_back(i);
        if (!answer || cur->from.size() > answer->size()) {
            answer = &cur->from;
        }
    }
    print(p - degree, answer->size());
    for (auto x : *answer) {
        cout << x + 1 << ' ';
    }
    print();
}
