import java.io.*;
import java.util.*;

public class A {

	FastScanner in;
	PrintWriter out;

	public long pow(long x, long p) {
		if (p == 0) {
			return 1;
		}
		if (p % 2 == 0) {
			long ans = pow(x, p / 2);
			return ans * ans % mod;
		}
		return pow(x, p - 1) * x % mod;
	}

	public long modInv(long x) {
		return pow(x, mod - 2);
	}

	long n;
	long a = 26;
	long mod = 1000000007;

	public class Line {
		long b;
		long a;
		long begin;
		long end;

		public Line(long a, long b, long begin, long end) {
			this.a = a;
			this.b = b;
			this.begin = begin;
			this.end = end;
		}

		public long value(long x) {
			return a * x + b;
		}

		public String toString() {
			return a + "*x " + b + " begin) " + begin + " end) " + end;
		}
	}

	public class Stack {
		Line[] st;
		int sz;

		public Stack(int maxsz) {
			st = new Line[maxsz + 1];
			sz = 0;
		}

		public boolean isEmpty() {
			return sz == 0;
		}

		public void push(Line l) {
			st[sz] = l;
			sz++;
		}

		public Line peek() {
			return st[sz - 1];
		}

		public Line pop() {
			sz--;
			return st[sz];
		}

		public void clear() {
			sz = 0;
		}
	}

	public class Node {
		int count;
		Node[] to;

		public Node() {
			this.count = 0;
			this.to = new Node[26];
		}
	}

	public class Pair {
		int x;
		int y;

		public Pair(int x, int y) {
			this.x = x;
			this.y = y;
		}
	}

	Node root = new Node();

	@SuppressWarnings("unchecked")
	public void solve() {
		int n = in.nextInt();
		String[] s = new String[n];
		for (int i = 0; i < s.length; i++) {
			s[i] = in.next();
		}
		for (int i = 0; i < s.length; i++) {
			Node th = root;
			th.count++;
			for (int j = 0; j < s[i].length(); j++) {
				int l = s[i].charAt(j) - 'a';
				if (th.to[l] == null) {
					Node to = new Node();
					th.to[l] = to;
				}
				th = th.to[l];
				th.count++;
			}
		}
		int q = in.nextInt();
		ArrayList<Pair>[] requests = new ArrayList[n];
		for (int i = 0; i < requests.length; i++) {
			requests[i] = new ArrayList<>();
		}
		for (int i = 0; i < q; i++) {
			requests[in.nextInt() - 1].add(new Pair(in.nextInt(), i));
		}
		long[] ans = new long[q];
		Stack st = new Stack(200005);
		for (int i = 0; i < s.length; i++) {
			int[] sz = new int[s[i].length() + 1];
			Node th = root;
			for (int j = 0; j < s[i].length(); j++) {
				int l = s[i].charAt(j) - 'a';
				th = th.to[l];
				sz[s[i].length() - j] = th.count;
			}
			for (int j = 0; j < sz.length; j++) {
				Line l = new Line(j, -sz[j], 0, Integer.MAX_VALUE / 2);
				while (!st.isEmpty()) {
					Line lth = st.peek();
					if (lth.value(lth.begin) <= l.value(lth.begin)) {
						st.pop();
					} else {
						long begin = (lth.b - l.b + l.a - lth.a - 1) / (l.a - lth.a);
//						System.out.println(l + "\t " + lth + " " + begin);
						st.peek().end = begin - 1;
						l.begin = begin;
						break;
					}
				}
				st.push(l);
//				System.out.println(l);
			}
//			for (int j = 0; j < st.sz; j++) {
//				System.out.println(st.st[j]);
//			}
//			System.out.println();
			for (Pair p : requests[i]) {
				int k = p.x;
				int l = -1;
				int r = st.sz;
				while (l + 1 < r) {
					int m = (l + r) / 2;
					if (st.st[m].begin <= k) {
						l = m;
					} else {
						r = m;
					}
				}
				l = (int) st.st[l].a;
//				System.out.println(l + " " + p.x + " " + p.y);
				ans[p.y] = k * 1L * (s[i].length() - l) + sz[l];
			}
			st.clear();
//			for (int j = 0; j < st.sz; j++) {
//				System.out.println(st.st[j].toString());
//			}
//			System.out.println();
		}
		for (int i = 0; i < ans.length; i++) {
			out.println(ans[i]);
		}
	}

	public void run() {
		in = new FastScanner();
		out = new PrintWriter(System.out);

		solve();

		out.close();
	}

	class FastScanner {
		StringTokenizer st;
		BufferedReader in;

		FastScanner() {
			in = new BufferedReader(new InputStreamReader(System.in));
		}

		String nextLine() {
			try {
				return in.readLine();
			} catch (IOException e) {
				e.printStackTrace();
			}
			return null;
		}

		String next() {
			while (st == null || !st.hasMoreTokens()) {
				try {
					st = new StringTokenizer(in.readLine());
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
			return st.nextToken();
		}

		int nextInt() {
			return Integer.parseInt(next());
		}

		long nextLong() {
			return Long.parseLong(next());
		}

		double nextDouble() {
			return Double.parseDouble(next());
		}

		boolean nextBoolean() {
			return Boolean.parseBoolean(next());
		}
	}

	public static void main(String[] args) {
		new A().run();
	}

}
