#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <queue>
#include <stack>
#include <map>
#include <iomanip>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <cassert>
#include <bitset>

using namespace std;

typedef long long ll;
typedef unsigned int ui;
typedef long double ld;

const int LH = 190;
const int RH = 220;
const int MH = (LH + RH) / 2;

const int LW = 200;
const int RW = 250;
const int MW = (LW + RW) / 2;

const int LS = 10;
const int RS = 20;
const int MS = (LS + RS) / 2;

const int LR = 2;
const int RR = 6;
const int MR = (LR + RR) / 2;

const int LP = 3;
const int RP = 7;
const int MP = (LP + RP) / 2;

int get(int l, int m, int r, int x) {
    if (x < l) {
        return 0;
    } else if (l <= x && x < m) {
        return 1;
    } else if (m <= x && x <= r) {
        return 2;
    } else {
        return 3;
    }
}

struct Player {
    int h, w, s, r, p;
    int cnt[4];

    Player() {
        fill(cnt, cnt + 4, 0);
    }

    void read() {
        cin >> h >> w >> s >> r >> p;
        cnt[get(LH, MH, RH, h)]++;
        cnt[get(LW, MW, RW, w)]++;
        cnt[get(LS, MS, RS, s)]++;
        cnt[get(LR, MR, RR, r)]++;
        cnt[get(LP, MP, RP, p)]++;
    }

    bool is_0() {
        int is_h = get(LH, MH, RH, h) == 3;
        int is_w = get(LW, MW, RW, w) == 3;
        return ((is_h || is_w) && cnt[3] >= 3);
    }

    bool is_1() {
        if (cnt[3] >= 2 && (cnt[2] + cnt[3] >= 3)) {
            return true;
        }
        if ((cnt[0] + cnt[1] == 0) && (cnt[2] + cnt[3] >= 3)) {
            return true;
        }
        return false;
    }

    bool is_2() {
        if (cnt[3] >= 1 && (cnt[2] + cnt[3] >= 2)) {
            return true;
        }
        if (cnt[2] + cnt[3] >= 3) {
            return true;
        }
        return false;
    }

    int get_type() {
        if (is_0()) {
            return 0;
        }
        if (is_1()) {
            return 1;
        }
        if (is_2()) {
            return 2;
        }
        return 3;
    }
};

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif

    int n;
    cin >> n;

    vector<Player> players(n);

    for (int i = 0; i < n; i++) {
        players[i].read();
        cout << players[i].get_type() << "\n";
    }

    return 0;
}