#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <queue>
#include <stack>
#include <map>
#include <iomanip>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <cassert>
#include <bitset>

using namespace std;

typedef long long ll;
typedef unsigned int ui;
typedef long double ld;

const int MX = 1000 + 7;
const int INF = 1000 * 1000 * 1000 + 7;
char a[MX][MX];

int comp[MX * MX];
void init_comp() {
    for (int i = 0; i < MX; i++) {
        for (int j = 0; j < MX; j++) {
            comp[i * MX + j] = i * MX + j;
        }
    }
}
int get_comp(int v) {
    if (v == comp[v]) return v;
    return comp[v] = get_comp(comp[v]);
}
int get_comp(int i, int j) {
    return get_comp(i * MX + j);
}
void uni_comp(int a, int b) {
    a = get_comp(a), b = get_comp(b);
    comp[a] = b;
}

vector<int> cs_g[MX][MX];

pair<int, int> nd[MX][MX];
pair<int, int> nu[MX][MX];
pair<int, int> nl[MX][MX];
pair<int, int> nr[MX][MX];

void init_near(int n, int m) {
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (a[i][j] == 'W') {
                nu[i][j] = {i, j};
                nl[i][j] = {i, j};
            } else {
                nu[i][j] = nu[i - 1][j];
                nl[i][j] = nl[i][j - 1];
            }
        }
    }

    for (int i = n - 1; i >= 0; i--) {
        for (int j = m - 1; j >= 0; j--) {
            if (a[i][j] == 'W') {
                nd[i][j] = {i, j};
                nr[i][j] = {i, j};
            } else {
                nd[i][j] = nd[i + 1][j];
                nr[i][j] = nr[i][j + 1];
            }
        }
    }

}

vector<string> ans;
int used_st[MX][MX];
pair<int, int> p_st[MX][MX];
int timer = 1;

void go_by_steps(int fr_x, int fr_y, int to_x, int to_y) {
    queue<pair<int, int>> q{{{fr_x, fr_y}}};
    used_st[fr_x][fr_y] = ++timer;


    while (!q.empty()) {
        pair<int, int> v = q.front();
        q.pop();

        if (a[v.first - 1][v.second] == '.' && used_st[v.first - 1][v.second] != timer) {
            q.push({v.first - 1, v.second});
            used_st[v.first - 1][v.second] = timer;
            p_st[v.first - 1][v.second] = v;
        }

        if (a[v.first][v.second - 1] == '.' && used_st[v.first][v.second - 1] != timer) {
            q.push({v.first, v.second - 1});
            used_st[v.first][v.second - 1] = timer;
            p_st[v.first][v.second - 1] = v;
        }

        if (a[v.first + 1][v.second] == '.' && used_st[v.first + 1][v.second] != timer) {
            q.push({v.first + 1, v.second});
            used_st[v.first + 1][v.second] = timer;
            p_st[v.first + 1][v.second] = v;
        }

        if (a[v.first][v.second + 1] == '.' && used_st[v.first][v.second + 1] != timer) {
            q.push({v.first, v.second + 1});
            used_st[v.first][v.second + 1] = timer;
            p_st[v.first][v.second + 1] = v;
        }
    }
    vector<pair<int, int>> path;
    while (to_x != fr_x || to_y != fr_y) {
        path.push_back({to_x, to_y});
        pair<int, int> vv = p_st[to_x][to_y];
        to_x = vv.first;
        to_y = vv.second;
    }
    path.push_back({fr_x, fr_y});
    reverse(path.begin(), path.end());
    for (int i = 0; i + 1 < (int)path.size(); i++) {
        if (path[i + 1].first > path[i].first) ans.push_back("MD");
        if (path[i + 1].first < path[i].first) ans.push_back("MU");
        if (path[i + 1].second > path[i].second) ans.push_back("MR");
        if (path[i + 1].second < path[i].second) ans.push_back("ML");
    }
}

void print_ans() {
    int count_p = 0;
    for (string& s : ans) if (s[0] != 'M') count_p++;

    cout << count_p << ' ' << ans.size() - count_p << '\n';
    for (const string& s : ans) {
        cout << s << '\n';
    }
}

vector<pair<int, int>> g[MX][MX];

void init_g(int n, int m) {
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (a[i][j] != '.') continue;
            pair<int, int> x;

            x = nd[i][j];
            if (x.first && a[x.first - 1][x.second] == '.') g[i][j].push_back({x.first - 1, x.second});

            x = nu[i][j];
            if (x.first != n - 1 && a[x.first + 1][x.second] == '.') g[i][j].push_back({x.first + 1, x.second});

            x = nl[i][j];
            if (x.second != m - 1 && a[x.first][x.second + 1] == '.') g[i][j].push_back({x.first, x.second + 1});

            x = nr[i][j];
            if (x.second && a[x.first][x.second - 1] == '.') g[i][j].push_back({x.first, x.second - 1});
        }
    }
}

vector<pair<int, int>> points_by_comp[MX * MX];

void init_comp_again(int n, int m) {
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (a[i][j] != '.') continue;
            if (i && a[i - 1][j] == '.') uni_comp(i * MX + j, (i - 1) * MX + j);
            if (j && a[i][j - 1] == '.') uni_comp(i * MX + j, i * MX + j - 1);
        }
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (a[i][j] == '.')
                points_by_comp[get_comp(i, j)].push_back({i, j});
        }
    }
}

vector<pair<pair<int, int>, pair<int, int>>> bfs_comp(int st, int en) {
    vector<int> d(MX * MX, INF);
    vector<int> p(MX * MX, -1);
    vector<pair<pair<int, int>, pair<int, int>>> p_fr(MX * MX);
    d[st] = 0;
    queue<int> q{{st}};
    while (!q.empty()) {
        int v = q.front();
        q.pop();

        for (const auto& pt : points_by_comp[v]) {
            for (const auto& to: g[pt.first][pt.second]) {
                if (d[get_comp(to.first, to.second)] == INF) {
                    d[get_comp(to.first, to.second)] = d[v] + 1;
                    p[get_comp(to.first, to.second)] = v;
                    p_fr[get_comp(to.first, to.second)] = {pt, to};
                    q.push(get_comp(to.first, to.second));
                }
            }
        }
    }
    if (d[en] == INF) return {};

    int now = en;
    vector<pair<pair<int, int>, pair<int, int>>> go_path;
    while (now != st) {
        go_path.push_back(p_fr[now]);
        now = p[now];
    }
    reverse(go_path.begin(), go_path.end());
    return go_path;
}

bool portal_fl = 0;
int portal_dir = 0;
int portal_x, portal_y;
int n_x, n_y, n_dir;

void make_portal(pair<int, int>& fr, pair<int, int>& to, bool first_time = 0) {
    portal_x = n_x, portal_y = n_y, portal_dir = n_dir;
    string to_ans = "";
    if (portal_fl == 0) to_ans = "O";
    else to_ans = "B";
    portal_fl ^= 1;

    if (fr.first < to.first) {
        to_ans += "D";
        n_dir = 0;
    }
    if (fr.first > to.first) {
        to_ans += "U";
        n_dir = 1;
    }
    if (fr.second < to.second) {
        to_ans += "R";
        n_dir = 2;
    }
    if (fr.second > to.second) {
        to_ans += "L";
        n_dir = 3;
    }

    ans.push_back(to_ans);
    n_x = to.first;
    n_y = to.second;

    if (first_time) {
        n_x = fr.first;
        n_y = fr.second;
    }
}

bool find_portal_in_my_room(int st_x, int st_y) {
    pair<int, int> wh = {-1, -1};
    pair<int, int> to;
    for (auto& pt : points_by_comp[get_comp(st_x, st_y)]) {
        if (a[pt.first - 1][pt.second] == 'W') {
            wh = pt;
            to = {pt.first - 1, pt.second};
            break;
        }
        if (a[pt.first][pt.second - 1] == 'W') {
            wh = pt;
            to = {pt.first, pt.second - 1};
            break;
        }
        if (a[pt.first + 1][pt.second] == 'W') {
            wh = pt;
            to = {pt.first + 1, pt.second};
            break;
        }
        if (a[pt.first][pt.second + 1] == 'W') {
            wh = pt;
            to = {pt.first, pt.second + 1};
            break;
        }
    }

    if (wh.first == -1) return 0;

    go_by_steps(st_x, st_y, wh.first, wh.second);
    make_portal(wh, to, 1);


    return 1;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif

    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
        }
    }
    init_comp();
    init_comp_again(n, m);
    init_near(n, m);
    init_g(n, m);

    int st_x, st_y;
    int en_x, en_y;
    cin >> st_x >> st_y >> en_x >> en_y;
    st_x--, st_y--, en_x--, en_y--;



    if (get_comp(st_x, st_y) == get_comp(en_x, en_y)) {
        go_by_steps(st_x, st_y, en_x, en_y);
        print_ans();
        return 0;
    }

    if (!find_portal_in_my_room(st_x, st_y)) {
        cout << "-1 -1\n";
        return 0;
    }

    auto x = bfs_comp(get_comp(st_x, st_y), get_comp(en_x, en_y));
    if (x.empty()) {
        cout << "-1 -1\n";
        return 0;
    }


    for (auto& y : x) {
        go_by_steps(n_x, n_y, y.first.first, y.first.second);
        make_portal(y.first, y.second);
        go_by_steps(y.first.first, y.first.second, portal_x, portal_y);

        if (portal_dir == 0) ans.push_back("MD");
        if (portal_dir == 1) ans.push_back("MU");
        if (portal_dir == 2) ans.push_back("MR");
        if (portal_dir == 3) ans.push_back("ML");
    }
    go_by_steps(n_x, n_y, en_x, en_y);


    print_ans();
    return 0;
}