#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <bitset>
#include <deque>
#include <algorithm>

#define sz size()
#define pb push_back
#define mp make_pair
#define fs first
#define sc second
#define fori(i, s, n) for (int i = (s); (i) < (n); ++(i))

typedef long long LL;

using namespace std;

struct Node {
    map<string, Node*> next;
    Node* prev_node;
    string prev_s;
    LL sum;
    int stop;

    Node(int stop, Node* pn, string ps): 
        stop(stop),
        prev_node(pn),
        prev_s(ps)
    {};
};

void add_word(string word, Node* root) {
    Node* cur = root;
    fori(i, 0, word.length()) {
        string step = string{ word[i] };
        if (cur->next.find(step) == cur->next.end()) {
            Node* next_node = new Node(0, cur, step);
            cur->next[step] = next_node;
        }
        cur = cur->next[step];
    }
    cur->stop++;
}

int find_word(string word, Node* root) {
    Node* cur = root;
    fori(i, 0, word.length()) {
        string step = string{ word[i] };
        if (cur->next.find(step) == cur->next.end()) {
            return 0;
        }
        cur = cur->next[step];
    }
    return cur->stop;
}

int sum_below(Node* node) {
    int cur = node->stop;
    for (auto it = node->next.begin(); it != node->next.end(); ++it) {
        cur += sum_below(it->sc);
    }
    node->sum = cur;
    return cur;
}

void shrink(Node* node) {
    if (node->prev_node != 0 && node->stop == 0) {
        Node* prev_node = node->prev_node;
        string f_part = node->prev_s;
        string s_part = "";
        while (node->next.size() == 1) {
            Node* next_node = node->next.begin()->sc;
            string cur_s = node->next.begin()->fs;
            s_part += cur_s;
            node = next_node;
            if (node->stop) {
                break;
            }
        }
        string new_s = f_part + s_part;
        prev_node->next.erase(f_part);
        prev_node->next[new_s] = node;
    }
    vector <Node*> next_nodes;
    for (auto it = node->next.begin(); it != node->next.end(); ++it) {
        next_nodes.pb(it->sc);
    }
    fori(i, 0, next_nodes.sz) {
        shrink(next_nodes[i]);
    }
}

int solve(string word, int k, Node* node) {
    int ans = 0;
    string cur_word = "";
    int cur_step_k = 0;

    for (int pref_len = 1; pref_len <= word.length(); ++pref_len) {
        while (cur_word.length() < pref_len) {
            string step_s = "";
            for (auto it = node->next.begin(); it != node->next.end(); ++it) {
                if (it->fs[0] == word[cur_word.length()]) {
                    node = it->sc;
                    step_s = it->fs;
                    break;
                }
            }
            cur_word += step_s;
            cur_step_k = node->stop;
            for (auto it = node->next.begin(); it != node->next.end(); ++it) {
                if (cur_word.length() >= word.length() || it->fs[0] != word[cur_word.length()]) {
                    cur_step_k += it->sc->sum;
                }
            }
        }

        while (cur_step_k < k && cur_word.length() < word.length()) {
            string step_s = "";
            for (auto it = node->next.begin(); it != node->next.end(); ++it) {
                if (it->fs[0] == word[cur_word.length()]) {
                    node = it->sc;
                    step_s = it->fs;
                    cur_word += step_s;
                    cur_step_k += node->stop;
                    break;
                }
            }
            
            for (auto it = node->next.begin(); it != node->next.end(); ++it) {
                if (cur_word.length() >= word.length() || it->fs[0] != word[cur_word.length()]) {
                    cur_step_k += it->sc->sum;
                }
            }
            if (cur_word.length() == word.length()) {
                break;
            }
        }
        ans += min(k, cur_step_k);
        cur_step_k -= min(k, cur_step_k);
        if (cur_word.length() == word.length() && cur_step_k == 0) {
            break;
        }
    }
    return ans;
}

vector <string> words;

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
    int n;
    cin >> n;
    fori(i, 0, n) {
        string s;
        cin >> s;
        words.pb(s);
    }
    Node* root = new Node(0, 0, "");
    fori(i, 0, n) {
        add_word(words[i], root);
    }
    shrink(root);
    sum_below(root);
    int q;
    cin >> q;
    fori(i, 0, q) {
        int w;
        int k;
        cin >> w >> k;
        --w;
        cout << solve(words[w], k, root) << endl;
    }
	return 0;
}