#include <bits/stdc++.h>

#define ll long long
#define kek lol

using namespace std;

const int MAXN = 1111;
const int INF = 1e9;

char c[MAXN][MAXN];
int cmp[MAXN][MAXN];
pair <int, int> wall_border[MAXN * MAXN];

pair <int, int> portal_left[MAXN][MAXN];
pair <int, int> portal_right[MAXN][MAXN];
pair <int, int> portal_up[MAXN][MAXN];
pair <int, int> portal_down[MAXN][MAXN];

pair <int, int> parent_pos[MAXN][MAXN];

vector <int> dx = {1, -1, 0, 0};
vector <int> dy = {0, 0, 1, -1};

void dfs(int i, int j, int num) {
    if (cmp[i][j] != -1)
        return;
    cmp[i][j] = num;
    for (int k = 0; k < (int)dx.size(); k++) {
        int ni = i + dx[k], nj = j + dy[k];
        if (c[ni][nj] == '.' && cmp[ni][nj] == -1) {
            dfs(ni, nj, num);
            parent_pos[ni][nj] = make_pair(i, j);
        }
        if (c[ni][nj] == 'W')
            wall_border[num] = make_pair(i, j);
    }
}

struct Edge {
    int from, to;
    pair <int, int> from_pos, to_pos;
    string direction;

    Edge() {}
    Edge(int from, int to, pair <int, int> from_pos, pair <int, int> to_pos, string direction):
        from(from), to(to), from_pos(from_pos), to_pos(to_pos), direction(direction) {}
};

vector <Edge> gr[MAXN * MAXN];

int d[MAXN * MAXN];
Edge parent[MAXN * MAXN];

pair <vector <Edge>, int> bfs(int from, int to) {
    for (int i = 0; i < MAXN * MAXN; i++)
        d[i] = INF, parent[i] = Edge(-1, -1, make_pair(-1, -1), make_pair(-1, -1), "$");
    deque <int> q;
    q.push_back(from);
    d[from] = 0;
    while (!q.empty()) {
        int v = q[0];
        q.pop_front();
        for (int i = 0; i < (int)gr[v].size(); i++) {
            if (d[gr[v][i].to] == INF) {
                d[gr[v][i].to] = d[v] + 1;
                q.push_back(gr[v][i].to);
                parent[gr[v][i].to] = gr[v][i];
            }
        }
    }
    int res_val = d[to];
    if (d[to] == INF)
        return make_pair(vector <Edge> {}, INF);
    vector <Edge> res;
    while (parent[to].from != -1) {
        res.push_back(parent[to]);
        to = parent[to].from;
    }
    return make_pair(res, res_val);
}

pair <int, int> last_pos;
vector <string> commands;

void step(pair <int, int> pos) {
    if (last_pos == pos)
        return;
    //cout << "step(" << pos.first << " " << pos.second << ")" << endl;
    string dir = " ";
    if (last_pos.first == pos.first + 1 && last_pos.second == pos.second)
        dir = "U";
    if (last_pos.first == pos.first - 1 && last_pos.second == pos.second)
        dir = "D";
    if (last_pos.first == pos.first && last_pos.second == pos.second + 1)
        dir = "L";
    if (last_pos.first == pos.first && last_pos.second == pos.second - 1)
        dir = "R";
    commands.push_back("M" + dir);
    last_pos = pos;
}

void go_to(pair <int, int> pos) {
    //cout << "go to " << pos.first << " " << pos.second << endl;
    vector <pair <int, int> > to_root;
    while (pos.first != -1) {
        to_root.push_back(pos);
        pos = parent_pos[pos.first][pos.second];
    }
    pair <int, int> last_pos_ = last_pos;
    vector <pair <int, int> > from_root;
    while (last_pos_.first != -1) {
        from_root.push_back(last_pos_);
        last_pos_ = parent_pos[last_pos_.first][last_pos_.second];
    }
    pair <int, int> center = make_pair(-1, -1);
    while (!to_root.empty() && !from_root.empty() && to_root.back() == from_root.back()) {
        center = to_root.back();
        to_root.pop_back();
        from_root.pop_back();
    }

    for (int i = 0; i < (int)from_root.size(); i++)
        step(from_root[i]);
    step(center);
    for (int i = (int)to_root.size() - 1; i >= 0; i--)
        step(to_root[i]);
}

int count_portals() {
    int res = 0;
    for (int i = 0; i < (int)commands.size(); i++)
        if (commands[i][0] == 'O' || commands[i][0] == 'B')
            res++;
    return res;
}

int main() {
   // freopen("in.in", "r", stdin);
    //freopen("in.out", "w", stdout);

    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n, m; cin >> n >> m;
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            cin >> c[i][j];
    int rs, cs, re, ce;
    cin >> rs >> cs >> re >> ce;
    rs--, cs--, re--, ce--;

    for (int i = 0; i < MAXN * MAXN; i++)
        wall_border[i] = make_pair(-1, -1);
    for (int i = 0; i < MAXN; i++)
        for (int j = 0; j < MAXN; j++) {
            cmp[i][j] = -1;
            portal_down[i][j] = portal_left[i][j] = portal_right[i][j] = portal_up[i][j] = make_pair(-1, -1);
            parent_pos[i][j] = make_pair(-1, -1);
        }
    int last_cmp = 0;
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            if (c[i][j] == '.' && cmp[i][j] == -1)
                dfs(i, j, last_cmp++);

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (c[i][j] != 'W') {
                if (c[i][j - 1] != 'W')
                    portal_left[i][j] = portal_left[i][j - 1];
                else
                    portal_left[i][j] = make_pair(i, j);
            }
        }
        for (int j = m - 1; j >= 0; j--) {
            if (c[i][j] != 'W') {
                if (c[i][j + 1] != 'W')
                    portal_right[i][j] = portal_right[i][j + 1];
                else
                    portal_right[i][j] = make_pair(i, j);
            }
        }
    }

    for (int j = 0; j < m; j++) {
        for (int i = 0; i < n; i++) {
            if (c[i][j] != 'W') {
                if (c[i - 1][j] != 'W')
                    portal_up[i][j] = portal_up[i - 1][j];
                else
                    portal_up[i][j] = make_pair(i, j);
            }
        }

        for (int i = n - 1; i >= 0; i--) {
            if (c[i][j] != 'W') {
                if (c[i + 1][j] != 'W')
                    portal_down[i][j] = portal_down[i + 1][j];
                else
                    portal_down[i][j] = make_pair(i, j);
            }
        }
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (c[i][j] == '.' && wall_border[cmp[i][j]].first != -1) {
                int cur = cmp[i][j];
                int to_down = cmp[portal_down[i][j].first][portal_down[i][j].second];
                if (cur != to_down && c[portal_down[i][j].first][portal_down[i][j].second] == '.')
                    gr[cur].push_back(Edge(cur, to_down, make_pair(i, j), portal_down[i][j], "D"));
                int to_left = cmp[portal_left[i][j].first][portal_left[i][j].second];
                if (cur != to_left && c[portal_left[i][j].first][portal_left[i][j].second] == '.')
                    gr[cur].push_back(Edge(cur, to_left, make_pair(i, j), portal_left[i][j], "L"));
                int to_right = cmp[portal_right[i][j].first][portal_right[i][j].second];
                if (cur != to_right && c[portal_right[i][j].first][portal_right[i][j].second] == '.')
                    gr[cur].push_back(Edge(cur, to_right, make_pair(i, j), portal_right[i][j], "R"));
                int to_up = cmp[portal_up[i][j].first][portal_up[i][j].second];
                if (cur != to_up && c[portal_up[i][j].first][portal_up[i][j].second] == '.')
                    gr[cur].push_back(Edge(cur, to_up, make_pair(i, j), portal_up[i][j], "U"));
            }
        }
    }

    int from = cmp[rs][cs];
    int to = cmp[re][ce];

    pair <vector <Edge>, int> bfs_res = bfs(from, to);
    vector <Edge> components_path = bfs_res.first;
    if (bfs_res.second == INF) {
        cout << -1 << endl;
        return 0;
    }
    reverse(components_path.begin(), components_path.end());

    pair <int, int> last_O_pos = make_pair(-1, -1), last_B_pos = make_pair(-1, -1);
    string last_O_dir = "", last_B_dir = "";
    last_pos = make_pair(rs, cs);
    for (int i = 0; i < (int)components_path.size(); i++) {
        int from = components_path[i].from;
        int to = components_path[i].to;
        pair <int, int> b = wall_border[from];
        go_to(components_path[i].from_pos);
        if (i % 2 == 0) {
            commands.push_back("O" + components_path[i].direction);
            last_O_pos = components_path[i].to_pos;
            last_O_dir = components_path[i].direction;
            if (last_B_pos == make_pair(-1, -1)) {
                last_B_pos = b;
                if (last_B_dir == "") {
                    if (c[b.first][b.second + 1] == 'W')
                        last_B_dir = "R";
                    else if (c[b.first][b.second - 1] == 'W')
                        last_B_dir = "L";
                    else if (c[b.first + 1][b.second] == 'W')
                        last_B_dir = "D";
                    else if (c[b.first - 1][b.second] == 'W')
                        last_B_dir = "U";
                }
            }
            go_to(last_B_pos);
            if (i == 0)
                commands.push_back("B" + last_B_dir);
            commands.push_back("M" + last_B_dir);
        } else {
            commands.push_back("B" + components_path[i].direction);
            last_B_pos = components_path[i].to_pos;
            last_B_dir = components_path[i].direction;
            if (last_O_pos == make_pair(-1, -1)) {
                last_O_pos = b;
                if (last_O_dir == "") {
                    if (c[b.first][b.second + 1] == 'W')
                        last_O_dir = "R";
                    else if (c[b.first][b.second - 1] == 'W')
                        last_O_dir = "L";
                    else if (c[b.first + 1][b.second] == 'W')
                        last_O_dir = "D";
                    else if (c[b.first - 1][b.second] == 'W')
                        last_O_dir = "U";
                }
            }
            go_to(last_O_pos);
            if (i == 0)
                commands.push_back("O" + last_O_dir);
            commands.push_back("M" + last_O_dir);
        }
        last_pos = components_path[i].to_pos;
    }
    go_to(make_pair(re, ce));

    int cnt = count_portals();
    cout << cnt << " " << commands.size() - cnt << endl;
    for (int i = 0; i < (int)commands.size(); i++)
        cout << commands[i] << endl;
    cout << endl;

    return 0;
}
