#ifdef local
#define _GLIBCXX_DEBUG
#define _GLIBCXX_DEBUG_PEDANTIC
#endif // local
#include<bits/stdc++.h>
#define all(x) begin(x), end(x)
#define sz(x) ((int)(x).size())
#define def(x) memset(x, -1, sizeof(x))
using namespace std;
using ll  = long long;
int inf = 1e9 + 10;

const int nax = 1000;
int n, m;
string a[nax];
int comp[nax][nax];
int L[nax][nax], R[nax][nax], U[nax][nax], D[nax][nax];
pair<int, int> p[nax][nax];

const int di[] {1, 0, -1, 0};
const int dj[] {0, 1, 0, -1};
const int dir = 4;

int f(int i, int j) {
    return a[i][j] == '.';
}

int w(int i, int j) {
    return a[i][j] == 'W';
}

void bfs(int si, int sj, int c) {
    queue<pair<int, int>> q;
    q.push({si, sj});
    comp[si][sj] = c;
    while (sz(q)) {
        int i, j;
        tie(i, j) = q.front();
        q.pop();
        for (int k = 0; k < dir; ++k) {
            int ni = i + di[k];
            int nj = j + dj[k];
            if (f(ni, nj) && comp[ni][nj] != c) {
                comp[ni][nj] = c;
                p[ni][nj] = {i, j};
                q.push({ni, nj});
            }
        }
    }
}

int cnt = 0;
struct edge {
    int u, v;
    pair<int, int> s, t;
    char d;
};
vector<vector<edge>> g;
vector<edge> pcomp;
vector<int> dcomp;

void compbfs(int sc) {
    pcomp.resize(cnt);
    dcomp.assign(cnt, -1);
    queue<int> q;
    q.push(sc);
    dcomp[sc] = 0;
    while (sz(q)) {
        int u = q.front();
        q.pop();
        for (auto e : g[u]) {
            if (dcomp[e.v] == -1) {
                dcomp[e.v] = 1 + dcomp[u];
                pcomp[e.v] = e;
                q.push(e.v);
            }
        }
    }
}



edge be(int i, int j, int ti, int tj, char d) {
    return edge{comp[i][j], comp[ti][tj], {i, j}, {ti, tj}, d};
}

struct portal {
    int id, i, j;
    char d;
};

char portal_names[] {'O', 'B'};

char get_dir(pair<int, int> s, pair<int, int> t) {
    int di = t.first - s.first;
    int dj = t.second - s.second;
    if (di == 1) return 'D';
    if (di == -1) return 'U';
    if (dj == 1) return 'R';
    if (dj == -1) return 'L';
    return 'X';
}

int coco[nax][nax];

void gobfs(int si, int sj, int c) {
    queue<pair<int, int>> q;
    q.push({si, sj});
    coco[si][sj] = c;
    while (sz(q)) {
        int i, j;
        tie(i, j) = q.front();
        q.pop();
        for (int k = 0; k < dir; ++k) {
            int ni = i + di[k];
            int nj = j + dj[k];
            if (f(ni, nj) && coco[ni][nj] != c) {
                coco[ni][nj] = c;
                p[ni][nj] = {i, j};
                q.push({ni, nj});
            }
        }
    }
}

string go_to(pair<int, int> s, pair<int, int> e) {
    int si, sj, ei, ej;
    tie(si, sj) = s;
    tie(ei, ej) = e;
    static int infcomp = inf;
    gobfs(si, sj, infcomp++);
    string revres;
    for (pair<int, int> cur = make_pair(ei, ej); cur != make_pair(si, sj); ) {
        auto pr = p[cur.first][cur.second];
        revres += '\n';
        revres += get_dir(pr, cur);
        revres += 'M';
        cur = pr;
    }
    reverse(all(revres));
    return revres;
}

int main() {
#ifdef local
    assert(freopen("in.txt", "r", stdin));
#endif // local
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    def(comp);
    def(L);
    def(R);
    def(U);
    def(D);

    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    int si, sj, ei, ej;
    cin >> si >> sj >> ei >> ej;
    --si, --sj, --ei, --ej;
    // Calculate portal jumps
    for (int i = 0; i < n; ++i) {
        int last = -1;
        for (int j = 0; j < m; ++j) {
            if (w(i, j)) last = j;
            else if (f(i, j) && last != -1 && f(i, last + 1)) L[i][j] = last + 1;
        }
        last = m;
        for (int j = m-1; j >= 0; --j) {
            if (w(i, j)) last = j;
            else if (f(i, j) && last != m && f(i, last - 1)) R[i][j] = last - 1;
        }
    }
    for (int j = 0; j < m; ++j) {
        int last = -1;
        for (int i = 0; i < n; ++i) {
            if (w(i, j)) last = i;
            else if (f(i, j) && last != -1 && f(last + 1, j)) U[i][j] = last + 1;
        }
        last = n;
        for (int i = n-1; i >= 0; --i) {
            if (w(i, j)) last = i;
            else if (f(i, j) && last != n && f(last - 1, j)) D[i][j] = last - 1;
        }
    }
    // Color components
    for (int i = 0; i < n; ++i) {
        for(int j = 0; j < m; ++j) {
            if (comp[i][j] == -1 && f(i, j)) bfs(i, j, cnt++);
        }
    }
    // Build graph on components
    g.resize(cnt);
    for(int i = 1; i < n-1; ++i) {
        for(int j = 1; j < m-1; ++j) {
            if (L[i][j] != -1) {
                int ti = i, tj = L[i][j];
                g[comp[i][j]].push_back(be(i, j, ti, tj, 'L'));
            }
            if (R[i][j] != -1) {
                int ti = i, tj = R[i][j];
                g[comp[i][j]].push_back(be(i, j, ti, tj, 'R'));
            }
            if (U[i][j] != -1) {
                int ti = U[i][j], tj = j;
                g[comp[i][j]].push_back(be(i, j, ti, tj, 'U'));
            }
            if (D[i][j] != -1) {
                int ti = D[i][j], tj = j;
                g[comp[i][j]].push_back(be(i, j, ti, tj, 'D'));
            }
        }
    }
    compbfs(comp[si][sj]);
    if (dcomp[comp[ei][ej]] == -1) return cout << "-1 -1", 0;
    portal cur {-1, -1, -1, -1};
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (comp[i][j] == comp[si][sj]) {
                for (int k = 0; k < dir; ++k) {
                    int ni = i + di[k];
                    int nj = j + dj[k];
                    if (w(ni, nj)) {
                        cur = {0, i, j, get_dir({i, j}, {ni, nj})};
                        goto done;
                    }
                }
            }
        }
    }
    done:
    if (comp[si][sj] != comp[ei][ej] && cur.id == -1) return cout << "-1 -1", 0;
    // calculate path
    vector<edge> path;
    for (int curcomp = comp[ei][ej]; curcomp != comp[si][sj]; ) {
        auto pe = pcomp[curcomp];
        path.push_back(pe);
        curcomp = pe.u;
    }
    reverse(all(path));
    // build answer
    string ans;
    pair<int, int> curpos = {si, sj};
    bool first_portal = true;
    for(auto e : path) {
        ans += go_to(curpos, e.s);
        ans += portal_names[cur.id];
        ans += e.d;
        ans += '\n';
        ans += go_to(e.s, {cur.i, cur.j});
        if (first_portal) {
            ans += portal_names[cur.id ^ 1];
            ans += cur.d;
            ans += '\n';
            first_portal = false;
        }
        ans += 'M';
        ans += cur.d;
        ans += '\n';
        curpos = e.t;
        cur = {cur.id ^ 1, e.t.first, e.t.second, e.d};
    }
    ans += go_to(curpos, {ei, ej});
    int linecnt = count(all(ans), '\n');
    int shots = dcomp[comp[ei][ej]] == 0 ? 0 : dcomp[comp[ei][ej]] + 1;
    cout << shots << ' ' << linecnt - shots << '\n';
    cout << ans;
}
