#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <stack>

using namespace std;

typedef long long ll;
typedef long double ld;

/**
ll gcd(ll a, ll b) {
	return (b ? gcd(b, a % b) : a);
}

template <typename T>
T sqr(T a) {
	return a * a;
}

class point {
public:
	ld x, y;

	ld dist(point a, point b) {
		return sqrt(sqr(a.x - b.x) + sqr(a.y - b.y));
	}
};

//
vector<int> t, tADD, a;

void build(int v, int vl, int vr) {
	if (vl == vr) {
		t[v] = a[vl];
		return;
	}
	int vm = (vl + vr) / 2;
	build(2 * v, vl, vm);
	build(2 * v + 1, vm + 1, vr);
	t[v] = t[2 * v] + t[2 * v + 1];
}

int sum(int v, int vl, int vr, int l, int r) {
	if ((vr < l) || (r < vl)) {
		return 0;
	}
	else {
		if ((vl <= l) && (r <= vr)) {
			return t[v];
		}
		else {
			int vm = (vl + vr) / 2;
			return sum(2 * v, vl, vm, l, r) + sum(2 * v + 1, vm + 1, vr, l, r);
		}
	}
}

void modify(int v, int vl, int vr, int l, int r, int x) {
	if ((vr < l) || (r < vl)) {
		return;
	}
	else {
		if ((vl <= l) && (r <= vr)) {
			return;
		}
		else {
			int vm = (vl + vr) / 2;
			return;
		}
	}
}

//
*/

int main() {
	int n;
	cin >> n;

	for (int i = 0; i < n; i++) {

		int p1, p2, p3, p4, p5;
		cin >> p1 >> p2 >> p3 >> p4 >> p5;

		int countUpNorm = 0;
		if (p1 > 220) countUpNorm++;
		if (p2 > 250) countUpNorm++;
		if (p3 > 20) countUpNorm++;
		if (p4 > 6) countUpNorm++;
		if (p5 > 7) countUpNorm++;

		int countNorm = 0;
		if (p1 >= 190) countNorm++;
		if (p2 >= 200) countNorm++;
		if (p3 >= 10) countNorm++;
		if (p4 >= 2) countNorm++;
		if (p5 >= 3) countNorm++;

		int countUpMidNorm = 0;
		if (p1 >= 205) countUpMidNorm++;
		if (p2 >= 225) countUpMidNorm++;
		if (p3 >= 15) countUpMidNorm++;
		if (p4 >= 4) countUpMidNorm++;
		if (p5 >= 5) countUpMidNorm++;//

		//cout << countNorm << " " << countUpMidNorm << " " << countUpNorm << '\n';

		if (countUpNorm >= 3 && (p2 > 250 || p1 > 220)) {
			cout << 0 << '\n';
			continue;
		}

		if ((countUpNorm >= 2 && countUpMidNorm >= 3) || (countNorm >= 5 && countUpMidNorm >= 3)) {
			cout << 1 << '\n';;
			continue;
		}

		if ((countUpNorm >= 1 && countUpMidNorm >= 2) || (countUpMidNorm >= 3)) {
			cout << 2 << '\n';;
			continue;
		}

		cout << 3 << '\n';;

	}

	return 0;
}