#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <stack>
#include <string>

using namespace std;

typedef long long ll;
typedef long double ld;

/**
ll gcd(ll a, ll b) {
	return (b ? gcd(b, a % b) : a);
}

template <typename T>
T sqr(T a) {
	return a * a;
}

class point {
public:
	ld x, y;

	ld dist(point a, point b) {
		return sqrt(sqr(a.x - b.x) + sqr(a.y - b.y));
	}
};

//
vector<int> t, tADD, a;

void build(int v, int vl, int vr) {
	if (vl == vr) {
		t[v] = a[vl];
		return;
	}
	int vm = (vl + vr) / 2;
	build(2 * v, vl, vm);
	build(2 * v + 1, vm + 1, vr);
	t[v] = t[2 * v] + t[2 * v + 1];
}

int sum(int v, int vl, int vr, int l, int r) {
	if ((vr < l) || (r < vl)) {
		return 0;
	}
	else {
		if ((vl <= l) && (r <= vr)) {
			return t[v];
		}
		else {
			int vm = (vl + vr) / 2;
			return sum(2 * v, vl, vm, l, r) + sum(2 * v + 1, vm + 1, vr, l, r);
		}
	}
}

void modify(int v, int vl, int vr, int l, int r, int x) {
	if ((vr < l) || (r < vl)) {
		return;
	}
	else {
		if ((vl <= l) && (r <= vr)) {
			return;
		}
		else {
			int vm = (vl + vr) / 2;
			return;
		}
	}
}

//
*/

struct table {
	ll t[3][3];
	table() {
		for (int i = 0; i < 3; i++) {
			for (int j = 0; j < 3; j++) {
				t[i][j] = 0;
			}
		}
	}
};

const ll MOD = 1'000'000'007;


table mult(table a, table b) {
	table c;
	for (int x = 0; x < 3; x++) {
		for (int y = 0; y < 3; y++) {
			c.t[x][y] = 0;
		}
	}
	for (int xb = 0; xb < 3; xb++) {
		for (int ya = 0; ya < 3; ya++) {
			for (int u = 0; u < 3; u++) {
				c.t[xb][ya] = (c.t[xb][ya] + a.t[u][ya] * b.t[xb][u]) % MOD;
			}
		}
	}
	return c;
}

int main() {
	/*
	int p, t, m;
	cin >> p >> t >> m;
	vector <pair <bool, pair <int, int> > > a(m);
	vector <int> count_task(t, 0);
	vector <int> answer;
	for (int i = 0; i < m; i++) {
		a[i].first = true;
		cin >> a[i].second.first >> a[i].second.second;
		a[i].second.first--, a[i].second.second--;
		count_task[a[i].second.second]++;
	}
	int minimal = 1e9, marked_task = -1;
	for (int i = 0; i < t; i++) {
		if (minimal > count_task[i]) {
			minimal = count_task[i];
			marked_task = i;
		}
	}
	for (int i = 0; i < m; i++) {
		if (marked_task == a[i].second.second) {
			a[i].first = false;
		}
	}
	vector <int> people(p, 0);
	for (int i = 0; i < m; i++) {
		if (!a[i].first) people[a[i].second.first] = 1;
	}
	count_task.clear();
	count_task.resize(t);
	for (int i = 0; i < m; i++) {
		if (a[i].first && !people[a[i].second.first]) count_task[a[i].second.second]++;
	}
	for (int i = 0; i < t; i++) {
		if (!count_task[i]) answer.push_back(i);
	}
	int sum = -0;
	for (int i = 0; i < p; i++) {
		sum += (1 - people[i]);
	}
	cout << sum << ' ' << answer.size() << endl;
	for (int i = 0; i < answer.size(); i++) cout << answer[i] + 1 << ' ';
	return 0;
	*/
	table ini = table();
	ini.t[0][0] = 26;
	ini.t[1][0] = 0;
	ini.t[2][0] = 0;
	ini.t[0][1] = 26;
	ini.t[1][1] = 26;
	ini.t[2][1] = 0;
	ini.t[0][2] = 0;
	ini.t[1][2] = 1;
	ini.t[2][2] = 1;
	int l;
	cin >> l;
	if (l < 4) {
		cout << 0;
		return 0;
	}
	if (l == 4) {
		cout << 4;
		return 0;
	}
	int arr[40];
	int maxi = -1;
	l = l - 3;
	int tmp = l;
	while (tmp > 0) {
		maxi++;
		arr[maxi] = tmp % 2;
		tmp /= 2;
	}
	table powers[40];
	powers[0] = ini;
	for (int i = 1; i <= maxi; i++) {
		powers[i] = mult(powers[i - 1], powers[i - 1]);
	}

	table test = table();
	test.t[0][0] = 1;
	test.t[1][1] = 1;
	test.t[2][2] = 1;
	
	for (int i = 0; i <= maxi; i++) {
		if (arr[i] == 1) {
			test = mult(powers[i], test);
		}
	}
	/*for (int y = 0; y < 3; y++) {
		for (int x = 0; x < 3; x++) {
			cout << test.t[x][y] << " ";
		}
		cout << endl;
	}
	*/
	cout << (test.t[0][2] + test.t[1][2] * 4) % MOD;
	return 0;
}
