import java.io.*;
import java.util.StringTokenizer;

public class Main {
    class Reader {
        BufferedReader in;

        Reader() throws IOException {
            in = new BufferedReader(new InputStreamReader(System.in));
        }

        StringTokenizer tok = new StringTokenizer("");

        String next() throws IOException {
            if (!tok.hasMoreTokens()) {
                tok = new StringTokenizer(in.readLine());
            }
            return tok.nextToken();
        }

        long nextLong() throws IOException {
            return Long.parseLong(next());
        }

        int nextInt() throws IOException {
            return Integer.parseInt(next());
        }
    }

    class Writer {
        PrintWriter out;

        Writer() throws IOException {
            out = new PrintWriter(System.out);
        }

        StringBuilder str = new StringBuilder();

        void print(Object o) {
            str.append(o);
        }

        void close() throws IOException {
            out.write(str.toString());
            out.close();
        }
    }

    void solve() throws IOException {
        Reader in = new Reader();
        Writer out = new Writer();
        int n = in.nextInt();
        boolean a[] = new boolean[n + 1];
        int ans = 0;
        for (int i = 0; i < n; i++) {
            int v = in.nextInt();
            if (v <= n) {
                if (!a[v]) {
                    ans++;
                    a[v] = true;
                }
            }
        }
        out.print(ans);
        out.close();
    }

    public static void main(String[] args) throws IOException {
        new Main().solve();
    }
}