import java.io.*;
import java.util.*;

public class Main {
    class Reader {
        BufferedReader in;

        Reader() throws IOException {
            in = new BufferedReader(new InputStreamReader(System.in), 1048576);
        }

        StringTokenizer tok = new StringTokenizer("");

        String next() throws IOException {
            if (!tok.hasMoreTokens()) {
                tok = new StringTokenizer(in.readLine());
            }
            return tok.nextToken();
        }

        long nextLong() throws IOException {
            return Long.parseLong(next());
        }

        int nextInt() throws IOException {
            return Integer.parseInt(next());
        }
    }

    class Writer {
        PrintWriter out;

        Writer() throws IOException {
            out = new PrintWriter(System.out);
        }

        StringBuilder str = new StringBuilder();

        void print(Object o) {
            str.append(o);
        }

        void close() throws IOException {
            out.write(str.toString());
            out.close();
        }
    }

    class Node {
        HashMap<Integer, Node> t;
        LinkedList<Integer> T;

        Node() {
            t = new HashMap<>();
            T = new LinkedList<>();
        }
    }

    LinkedList<Integer> ans = new LinkedList<>();

    void add(LinkedList<Integer> list, int t0) {
        Node had = root;
        for (int v : list) {
            if (!had.t.containsKey(v)) {
                had.t.put(v, new Node());
            }
            had = had.t.get(v);
        }
        had.T.add(t0);
        if (ans.size() < had.T.size()) {
            ans = had.T;
        }
    }


    Node root = new Node();

    void solve() throws IOException {
        Reader in = new Reader();
        Writer out = new Writer();
        int P = in.nextInt();
        int t = in.nextInt();
        int m = in.nextInt();
        HashMap<Integer, LinkedList<Integer>> a = new HashMap<>();
        HashSet<Integer> tr = new HashSet<>();
        for (int i = 0; i < m; i++) {
            int p0 = in.nextInt();
            int t0 = in.nextInt();
            if (!a.containsKey(t0)) {
                a.put(t0, new LinkedList<>());
                tr.add(t0);
            }
            a.get(t0).add(p0);
        }
        if (tr.size() < t) {
            out.print(P + " " + (t - tr.size()) + "\n");
            for (int i = 1; i <= t; i++) {
                if (!tr.contains(i)) {
                    out.print(i + " ");
                }
            }
        } else {
            int mn = Integer.MAX_VALUE;
            for (int t0 : tr) {
                mn = Math.min(mn, a.get(t0).size());
            }
            for (int t0 : tr) {
                if (a.get(t0).size() == mn) {
                    Collections.sort(a.get(t0));
                    add(a.get(t0), t0);
                }
            }
            out.print((P - mn) + " " + (ans.size()));
            out.print("\n");
            Collections.sort(ans);
            for (int v : ans) {
                out.print(v + " ");
            }
        }
        out.close();
    }

    public static void main(String[] args) throws IOException {
        new Main().solve();
    }
}