#include <iostream>
#include <vector>
#include <set>
#include <queue>
#include <stack>
#include <math.h>
#include <random>
#include <chrono>
#include <map>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

const int INF = 1000 * 1000 * 1000;
const ll LLINF = 1LL * INF * INF;

mt19937 gen(chrono::high_resolution_clock::now().time_since_epoch().count());

int low_param[5] = { 190, 200, 10, 2, 3 };
int high_param[5] = { 220, 250, 20, 6, 7 };
int mid_param[5];
void cal_mid_param() {
	for (int i = 0; i < 5; ++i) mid_param[i] = (low_param[i] + high_param[i]) / 2 - 1;
}

struct player {
	int param[5];
	void read() {
		for (int i = 0; i < 5; ++i) cin >> param[i];
	}

	int cnt(int* arr) {
		int cnt = 0;
		for (int i = 0; i < 5; ++i) cnt += param[i] > arr[i];
		return cnt;
	}

	bool can_be_0() {
		return cnt(high_param) >= 3 and (param[0] > high_param[0] or param[1] > high_param[1]);
	}

	bool can_be_1() {
		if (cnt(high_param) >= 2 and cnt(mid_param) >= 1) return true;
		if (cnt(low_param) == 5 and cnt(mid_param) >= 3) return true;
		return false;
	}

	bool can_be_2() {
		if (cnt(high_param) >= 1 and cnt(mid_param) >= 1) return true;
		if (cnt(mid_param) >= 3) return true;
		return false;
	}

	int get_category() {
		if (can_be_0()) return 0;
		if (can_be_1()) return 1;
		if (can_be_2()) return 2;
		return 3;
	}
};

int main()
{
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	cal_mid_param();

	int n; cin >> n;
	while (n--) {
		player p;
		p.read();
		cout << p.get_category() << '\n';
	}

	return 0;
}