#pragma GCC optimize("O3")

#include <iostream>
#include <vector>
#include <set>
#include <queue>
#include <stack>
#include <math.h>
#include <random>
#include <cassert>
#include <chrono>
#include <map>
#include <algorithm>
using namespace std;

typedef long long ll;
typedef unsigned long long ull;

const int INF = 1000 * 1000 * 1000;
const ll LLINF = 1LL * INF * INF;

mt19937 gen(chrono::high_resolution_clock::now().time_since_epoch().count());

int getNum(const string& s, int base, int mod)
{
	int res = 0;

	while (base >= mod)
		base -= mod;

	for (char c : s)
	{
		res = res * base + c - '0';

		while (res >= mod)
			res -= mod;
	}

	return res;
}

int main()
{
	cin.tie(0);
	ios_base::sync_with_stdio(0);

	string s;
	cin >> s;
	if (s.size() == 1) {
		int z = s[0] - '0';
		for (int i = 2; i < z; i++) {
			if (z % i == 0)
				return cout << 10 << ' ' << i, 0;
		}
		return cout << -1, 0;
	}
	if (s.back() == '1')
	{
		int sum = 0;

		for (int i = 0; i < s.size(); i++)
		{
			sum += s[i] - '0';
		}

		cout << sum + 1 << " " << sum;
		return 0;
	}
	if (s.back() == '0')
		cout << 10 << ' ' << 2;
	else
		cout << s.back() << "0 " << s.back();

	return 0;
}