#include <iostream>
#include <vector>
#include <set>
#include <queue>
#include <stack>
#include <math.h>
#include <random>
#include <chrono>
#include <map>
#include <algorithm>
using namespace std;

typedef long long ll;
typedef unsigned long long ull;

const int INF = 1000 * 1000 * 1000;
const ll LLINF = 1LL * INF * INF;

mt19937 gen(chrono::high_resolution_clock::now().time_since_epoch().count());

#define maxn 1010101
int p, t, m;
vector<int> gr[maxn];

const ll rem = (1e9 + 8181);
ll hash1(const vector<int>& a) {
	ll res = 0;
	for (auto i : a) res = (res * maxn + i) % rem;
	return res;
}

#define base 1235
ull hash2(const vector<int>& a) {
	ull res = 0;
	for (auto i : a) res = (res + base) ^ i;
	return res;
}

map<pair<ll, ull>, vector<int>> cnt;
int main() {
	cin.tie(0);
	ios_base::sync_with_stdio(0);

	cin >> p >> t >> m;
	for (int i = 0; i < m; ++i) {
		int u, v; cin >> u >> v;
		gr[v].push_back(u);
	}

	int max_parti = -1;
	for (int i = 1; i <= t; ++i) {
		sort(gr[i].begin(), gr[i].end());
		pair<ll, ull> hash = { hash1(gr[i]), hash2(gr[i]) };
		cnt[hash].push_back(i);
		max_parti = max(max_parti, p - (int)gr[i].size());
	}

	cout << max_parti<< ' ';
	int max_excer = -1;
	for (auto& i : cnt) {
		int v = i.second[0];
		if (p - (int)gr[v].size() != max_parti) continue;
		max_excer = max(max_excer, (int)i.second.size());
	}

	cout << max_excer << '\n';

	for (auto& i : cnt) {
		int v = i.second[0];
		if (p - (int)gr[v].size() != max_parti) continue;
		if ((int)i.second.size() != max_excer) continue;
		for (auto v : i.second) cout << v << ' ';
		break;
	}

	return 0;
}