#include <iostream>
#include <vector>
#include <set>
#include <queue>
#include <stack>
#include <math.h>
#include <random>
#include <chrono>
#include <map>
using namespace std;

typedef long long ll;
typedef unsigned long long ull;

const int INF = 1000 * 1000 * 1000;
const ll LLINF = 1LL * INF * INF;
const int L = 26;

mt19937 gen(chrono::high_resolution_clock::now().time_since_epoch().count());

struct T {
	T* a[L];
	int cnt;
	T() {
		for (int i = 0; i < L; i++)
			a[i] = nullptr;
		cnt = 0;
	}
};

int n, m;
vector <string> a;
T* root = new T();

void add(int id) {
	T* t = root;
	root->cnt++;
	for (int i = 0; i < a[id].size(); i++) {
		int c = a[id][i] - 'a';
		if (!t->a[c])
			t->a[c] = new T();
		t = t->a[c];
		t->cnt++;
	}
}
int go(int id,int k) {
	T* t = root;
	int z = INT_MAX;
	int ans = 0;
	for (int i = 0; i < a[id].size(); i++) {
		int c = a[id][i] - 'a';
		t = t->a[c];
		int z1 = min(t->cnt, z);
		if (z1 <= k)
			return ans + z1;
		ans += k;
		z = z1 - k;
	}
	/*z = min(t->cnt, z);
	if (z <= k)
		return ans + z;
	ans += k;*/
	return ans;
}

int main()
{
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	cin >> n;
	a.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		add(i);
	}
	cin >> m;
	for (int i = 0; i < m; i++) {
		int q, k;
		cin >> q >> k;
		cout << go(q - 1, k) << '\n';
	}
	return 0;
}