//#include <bits/stdc++.h>
#include <iostream>
#include <vector>
#include <stack>

using namespace std;

const long long MOD = 1e9 + 7;

vector<vector<long long>> mul(const vector<vector<long long>> &a, const vector<vector<long long>> &b) {
    int n = a.size();
    vector<vector<long long>> ans(n, vector<long long>(n));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            for (int k = 0; k < n; k++) {
                ans[i][j] += a[i][k] * b[k][j];
            }
            ans[i][j] %= MOD;
        }
    }
    return ans;
}

vector<vector<long long>> pow(const vector<vector<long long>> &a, long long x) {
    vector<vector<long long>> d = a;
    int n = a.size();
    vector<vector<long long>> ans(n, vector<long long>(n));
    for (int i = 0; i < n; i++) {
        ans[i][i] = 1;
    }
    while (x > 0) {
        if (x & 1) {
            ans = mul(ans, d);
        }
        d = mul(d, d);
        x = x >> 1;
    }
    return ans;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    long long n;
    cin >> n;
    if (n < 4) {
        cout << 0;
        return 0;
    }

    vector<vector<long long>> ans = {{26, 0, 0},
                                     {1, 26, 0},
                                     {4, 26, 1}};
    ans = pow(ans, n - 3);
    cout << ans[2][0] << endl;

    return 0;
}