#include <bits/stdc++.h>
#ifdef VRI
#define err(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)
#else
#define err(...) 42
#endif

typedef long long ll;

using namespace std;

void solve();
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef VRI
    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}

const int dd = (int)1e3 + 3;

int dx[] = { 0, 0, 1, -1 }, dy[] = { 1, -1, 0, 0 };
string DIR[] = { "R", "L", "D", "U" };
int used[dd][dd], cnt = 0;

string A[dd];

void dfs(int i, int j, int num) {
    used[i][j] = num;
    for (int k = 0; k < 4; ++k) {
        int ni = i + dx[k], nj = j + dy[k];
        if (!used[ni][nj] && A[ni][nj] == '.') {
            dfs(ni, nj, num);
        }
    }
}

struct edge {
    int to;
    pair<int, int> sp, fp;
};

vector<vector<edge>> G;
int cur[dd][dd];
int USED[dd][dd];

vector<string> moves;

bool gogo(int &cx, int &cy, int fx, int fy) {
    USED[cx][cy] = 1;
    if (cx == fx && cy == fy) {
        return true;
    }
    for (int k = 0; k < 4; ++k) {
        cx += dx[k], cy += dy[k];
        moves.push_back("M" + DIR[k]);
        if (!USED[cx][cy] && A[cx][cy] == '.' && gogo(cx, cy, fx, fy)) {
            return true;
        }
        cx -= dx[k], cy -= dy[k];
        moves.pop_back();
    }
    return false;
}

void clear_used(int i, int j) {
    USED[i][j] = 0;
    for (int k = 0; k < 4; ++k) {
        int ni = i + dx[k], nj = j + dy[k];
        if (USED[ni][nj]) {
            clear_used(ni, nj);
        }
    }
}

void GO(int &cx, int &cy, int fx, int fy) {
    int ox = cx, oy = cy;
    gogo(cx, cy, fx, fy);
    clear_used(cx, cy);
}

string get_dir(edge Edge) {
    pair<int, int> sx = Edge.sp, fx = Edge.fp;
    if (sx.first == fx.first) {
        return sx.second < fx.second ? "R" : "L";
    }
    return sx.first < fx.first ? "D" : "U";
}

edge my_find(int x, int y) {
    for (edge &j : G[x]) if (j.to == y) {
        return j;
    }
    assert(-1);
}

void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        cin >> A[i];
    }
    for (int i = 0; i < n; ++i) for (int j = 0; j < m; ++j) if (!used[i][j] && A[i][j] == '.') {
        dfs(i, j, ++cnt);
    }
    G.resize(cnt);

    int ans = -1;
    for (int i = 0; i < n; ++i) for (int j = 0; j < m; ++j) {
        if (A[i][j] == 'W') {
            ans = j;
        }
        if (A[i][j] == '.' && A[i][ans + 1] == '.' && used[i][j] != used[i][ans + 1]) {
            G[used[i][j] - 1].push_back({ used[i][ans + 1] - 1, {i, j}, {i, ans + 1} });
        }
    }
    for (int i = 0; i < n; ++i) for (int j = m - 1; j >= 0; --j) {
        if (A[i][j] == 'W') {
            ans = j;
        }
        if (A[i][j] == '.' && A[i][ans - 1] == '.' && used[i][j] != used[i][ans - 1]) {
            G[used[i][j] - 1].push_back({ used[i][ans - 1] - 1, {i, j}, {i, ans - 1} });
        }
    }
    for (int j = 0; j < m; ++j) for (int i = 0; i < n; ++i) {
        if (A[i][j] == 'W') {
            ans = i;
        }
        if (A[i][j] == '.' && A[ans + 1][j] == '.' && used[i][j] != used[ans + 1][j]) {
            G[used[i][j] - 1].push_back({ used[ans + 1][j] - 1, {i, j}, {ans + 1, j} });
        }
    }
    for (int j = 0; j < m; ++j) for (int i = n - 1; i >= 0; --i) {
        if (A[i][j] == 'W') {
            ans = i;
        }
        if (A[i][j] == '.' && A[ans - 1][j] == '.' && used[i][j] != used[ans - 1][j]) {
            G[used[i][j] - 1].push_back({ used[ans - 1][j] - 1, {i, j}, {ans - 1, j} });
        }
    }

    int sx, sy, fx, fy;
    cin >> sx >> sy >> fx >> fy;
    --sx, --sy, --fx, --fy;

    vector<int> dist(cnt, (int)1e9);
    vector<int> pred(cnt, -1);

    queue<int> q;
    int QQ = used[sx][sy] - 1;

    pair<int, int> start = { -1, -1 };
    for (int i = 0; i < n; ++i) for (int j = 0; j < m; ++j) if (used[i][j] - 1 == QQ) {
        for (int k = 0; k < 4; ++k) {
            int ni = i + dx[k], nj = j + dy[k];
            if (A[ni][nj] == 'W') {
                start = { i, j };
            }
        }
    }

    q.push(QQ);
    dist[QQ] = 0;
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (edge &i : G[v]) {
            if (dist[i.to] == (int)1e9) {
                dist[i.to] = dist[v] + 1;
                pred[i.to] = v;
                q.push(i.to);
            }
        }
    }

    int fin = used[fx][fy] - 1;
    if (dist[fin] == (int)1e9 || (dist[fin] != 0 && start.first == -1)) {
        cout << "-1 -1\n";
        return;
    }


    int copyF = fin;
    vector<int> pops;
    pops.push_back(fin);
    while (fin != QQ) {
        pops.push_back(fin = pred[fin]);
    }
    reverse(pops.begin(), pops.end());
    fin = copyF;

    int cx = sx, cy = sy;
    if (dist[fin] == 0) {
        GO(cx, cy, fx, fy);
    } else {
        edge Edge = my_find(pops[0], pops[1]);
        GO(cx, cy, Edge.sp.first, Edge.sp.second);
        string MV = get_dir(Edge);
        moves.push_back("B" + MV);
        GO(cx, cy, start.first, start.second);

        for (int k = 0; k < 4; ++k) {
            int ni = cx + dx[k], nj = cy + dy[k];
            if (A[ni][nj] == 'W') {
                moves.push_back("O" + DIR[k]);
                moves.push_back("M" + DIR[k]);
                break;
            }
        }
        cx = Edge.fp.first, cy = Edge.fp.second;

        for (int i = 1; i < (int)pops.size() - 1; ++i) {
            int px = cx, py = cy;
            Edge = my_find(pops[i], pops[i + 1]);
            GO(cx, cy, Edge.sp.first, Edge.sp.second);
            string MV2 = get_dir(Edge);
            moves.push_back((i % 2 ? "O" : "B") + MV2);
            GO(cx, cy, px, py);
            moves.push_back("M" + MV);
            MV = MV2;
            cx = Edge.fp.first, cy = Edge.fp.second;
        }
        GO(cx, cy, fx, fy);
    }

    cout << (dist[fin] == 0 ? 0 : dist[fin] + 1) << " " << moves.size() << "\n";
    for (string &i : moves) {
        cout << i << "\n";
    }
}