#include <algorithm>
#include <iostream>
#include <cstdio>
#include <string>
#include <bitset>
#include <vector>
//#include <random>
#include <stack>
#include <queue>
#include <deque>
#include <cmath>
#include <ctime>
#include <map>
#include <set>

typedef long long ll;
typedef long double ld;

using namespace std;

const ll x = 1e5 + 3;
const ll mod_g = 1e13 + 119;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	vector<ll> x_pow(1e5 + 1);
	x_pow[0] = 1;
	for (int i = 1; i <= 100000; i++) {
		x_pow[i] = (x_pow[i - 1] * x) % mod_g;
	}

	int p, t, m; cin >> p >> t >> m;

	vector<vector<ll>> tasks(t + 1, vector<ll>());

	for (int i = 0; i < m; i++) {
		int a, b; cin >> a >> b;
		tasks[b].push_back(a);
	}

	int min_size = p;
	for (int i = 1; i <= t; i++) {
		min_size = min(min_size, (int)tasks[i].size());
	}

	if (!min_size) {
		int cnt_zero_size = 0;
		vector<int> ans;

		for (int i = 1; i <= t; i++) {
			if (!tasks[i].size()) {
				cnt_zero_size++;
				ans.push_back(i);
			}
		}

		cout << p << " " << cnt_zero_size << "\n";
		for (int i = 0; i < ans.size(); i++) {
			cout << ans[i] << " ";
		}

		return 0;
	}

	for (int i = 1; i <= t; i++) {
		sort(tasks[i].rbegin(), tasks[i].rend());
	}

	vector<ll> hs(t + 1, -1);
	map<ll, int> hash_cnt;

	for (int i = 1; i <= t; i++) {
		if (tasks[i].size() != min_size) {
			continue;
		}
		ll now = 0;
		for (int j = 0; j < tasks[i].size(); j++) {
			now = (now + x_pow[j] * tasks[i][j]) % mod_g;
		}
		hs[i] = now;
		hash_cnt[now]++;
	}

	ll HASH = 0;
	int MAX_CNT = 0;
	for (auto v : hash_cnt) {
		if (MAX_CNT < v.second) {
			HASH = v.first;
			MAX_CNT = v.second;
		}
	}

	cout << (p - min_size) << " " << MAX_CNT << "\n";
	for (int i = 1; i <= t; i++) {
		if (hs[i] == HASH) {
			cout << i << " ";
		}
	}
	return 0;
}
/*
3 4 6
1 1
1 2
2 2
2 3
3 3
3 4

3 5 6
1 1
1 2
2 1
2 3
3 1
3 3
*/