#ifdef DEBUG
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#define ff first
#define ss second
#define bend(x) (x).begin(), (x).end()
#define szof(x) ((int) (x).size())
#define ALL(v) v.begin(), v.end()
#define SZ(x) szof(x)
#define TYPEMAX(T) std::numeric_limits<T>::max()
#define TYPEMIN(T) std::numeric_limits<T>::min()

using namespace std;
typedef pair<int, int> pii;
typedef long long ll;
const int INF = 1e9 + 123;
const ll INFL = 1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll l, ll r) {
	return ll_distr(tw) % (r - l + 1) + l;
}

template <typename T>
T input() {
	T res; cin >> res; return res;
}

template <typename IT>
void input_seq(IT a, IT b) {
	generate(a, b, input<typename std::remove_reference<decltype(*a)>::type>);
}

vector<int> dx = {0, 1, 0, -1};
vector<int> dy = {1, 0, -1, 0};
string dirlets = "RDLU";

void solve() {
	int n, m;
	cin >> n >> m;
	vector<vector<char>> field(n, vector<char>(m));
	for (int i = 0; i < n; ++i) {
		string s;
		cin >> s;
		for (int j = 0; j < m; ++j) {
			field[i][j] = s[j];
		}
	}
	int sx, sy, tx, ty;
	cin >> sx >> sy >> tx >> ty;
	--sx; --sy; --tx; --ty;
	
	vector<vector<int>> used(n, vector<int>(m));
	vector<vector<int>> color(n, vector<int>(m));
	
	int cnt = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			if (!used[i][j] && field[i][j] == '.') {
				queue<pii> qu;
				qu.push({i, j});
				used[i][j] = true;
				while (szof(qu)) {
					int x, y;
					tie(x, y) = qu.front();
					qu.pop();
					color[x][y] = cnt;
					for (int d = 0; d < 4; ++d) {
						int nx = x + dx[d];
						int ny = y + dy[d];
						if (field[nx][ny] == '.' && !used[nx][ny]) {
							used[nx][ny] = true;
							qu.push({nx, ny});
						}
					}
				}
				++cnt;
			}
		}
	}
	
	vector<vector<int>> from_field(n, vector<int>(m));
	int used_cnt = 123;
	auto find_path = [&](int x1, int y1, int x2, int y2) {
		++used_cnt;
		queue<pii> qu;
		qu.push({x1, y1});
		used[x1][y1] = used_cnt;
		while (szof(qu)) {
			int x, y;
			tie(x, y) = qu.front();
			if (x == x2 && y == y2) {
				break;
			}
			qu.pop();
			for (int d = 0; d < 4; ++d) {
				int nx = x + dx[d];
				int ny = y + dy[d];
				if (0 <= nx && nx < n && 0 <= ny && ny < m && used[nx][ny] != used_cnt && field[nx][ny] == '.') {
					used[nx][ny] = used_cnt;
					qu.push({nx, ny});
					from_field[nx][ny] = d;
				}
			}
		}
		assert(used[x2][y2] == used_cnt);
		vector<int> ret;
		while (x2 != x1 || y2 != y1) {
			int d = from_field[x2][y2];
			ret.push_back(d);
			x2 -= dx[d];
			y2 -= dy[d];
		}
		reverse(bend(ret));
		return ret;
	};
	
	if (color[sx][sy] == color[tx][ty]) {
		auto path = find_path(sx, sy, tx, ty);
		cout << "0 " << szof(path) << "\n";
		for (auto d : path) {
			cout << "M" << dirlets[d] << "\n";
		}
		return;
	}
	
	vector<vector<int>> graph(cnt);
	vector<bool> can_start(cnt);
	map<pii, pair<pii, int>> edges;

	vector<vector<vector<pii>>> nearest(4, vector<vector<pii>>(n, vector<pii>(m, {-1, -1})));
	
	function<pii(int, int, int)> get_nearest = [&](int x, int y, int d) {
		if (nearest[d][x][y].ff != -1) {
			return nearest[d][x][y];
		}
		if (field[x][y] == 'W') {
			return nearest[d][x][y] = {x, y};
		}
		int nx = x + dx[d];
		int ny = y + dy[d];
		return nearest[d][x][y] = get_nearest(nx, ny, d);
	};
	
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			if (field[i][j] != '.') {
				continue;
			}
			for (int d = 0; d < 4; ++d) {
				int x, y;
				tie(x, y) = get_nearest(i, j, d);
				//cerr << x << " " << y << endl;
				x -= dx[d];
				y -= dy[d];
				//cerr << i << " " << j << " " << dirlets[d] << " " << x << " " << y << endl;
				if (field[x][y] != '.') {
					continue;
				}
				edges[{color[i][j], color[x][y]}] = {{i, j}, d};
				if (color[x][y] == color[i][j]) {
					can_start[color[i][j]] = true;
				} else {
					graph[color[i][j]].push_back(color[x][y]);
				}
			}
		}
	}
	
	if (!can_start[color[sx][sy]]) {
		cout << "-1 -1\n";
		return;
	}
	
	vector<int> from(cnt);
	vector<int> dist(cnt, INF);
	dist[color[sx][sy]] = 0;
	queue<int> qu;
	qu.push(color[sx][sy]);
	while (szof(qu)) {
		int v = qu.front();
		qu.pop();
		
		for (int to : graph[v]) {
			if (dist[to] > dist[v] + 1) {
				dist[to] = dist[v] + 1;
				from[to] = v;
				qu.push(to);
			}
		}
	}
	
	if (dist[color[tx][ty]] == INF) {
		cout << "-1 -1\n";
		return;
	}
	
	vector<int> comps_path;
	int cur = color[tx][ty];
	while (cur != color[sx][sy]) {
		comps_path.push_back(cur);
		cur = from[cur];
	}
	comps_path.push_back(color[sx][sy]);
	
	reverse(bend(comps_path));

	int x = sx, y = sy;
	vector<pair<char, char>> ans;
	int shoot_type = 0;

	auto add_go = [&](int d) {
		ans.push_back({'M', dirlets[d]});
		x += dx[d];
		y += dy[d];
	};
	
	auto add_path = [&](vector<int> const& arrd) {
		for (int d : arrd) {
			add_go(d);
		}
	};
	
	vector<pair<pii, int>> portals;
	
	auto make_shoot = [&](int d) {
		ans.push_back({"OB"[shoot_type], dirlets[d]});
		auto tmp = get_nearest(x, y, d);
		tmp.ff -= dx[d];
		tmp.ss -= dy[d];
		portals.push_back({tmp, d});
		shoot_type ^= 1;
	};
	
	auto tmp = edges[{color[x][y], color[x][y]}];
	add_path(find_path(x, y, tmp.ff.ff, tmp.ff.ss));
	make_shoot(tmp.ss);

	for (int i = 0; i < szof(comps_path) - 1; ++i) {
		auto p = edges[{comps_path[i], comps_path[i + 1]}];
		add_path(find_path(x, y, p.ff.ff, p.ff.ss));
		make_shoot(p.ss);
		auto port = portals[szof(portals) - 2];
		add_path(find_path(x, y, port.ff.ff, port.ff.ss));
		add_go(port.ss);
		tie(x, y) = portals.back().ff;
	}
	
	add_path(find_path(x, y, tx, ty));
	
	cout << dist[color[tx][ty]] + 1 << " " << szof(ans) - (dist[color[tx][ty]] + 1) << "\n";
	
	for (auto p : ans) {
		cout << p.ff << p.ss << "\n";
	}
}

int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(5) << fixed;
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	cout << setprecision(15) << fixed;
	
	solve();
	
#ifdef LOCAL
	auto end_time = clock();
	cerr << "time: " << (end_time - start_time) * 1000 / CLOCKS_PER_SEC << endl;
#endif
	return 0;
}