#ifdef DEBUG
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#define ff first
#define ss second
#define bend(x) (x).begin(), (x).end()
#define szof(x) ((int) (x).size())
#define ALL(v) v.begin(), v.end()
#define SZ(x) szof(x)
#define TYPEMAX(T) std::numeric_limits<T>::max()
#define TYPEMIN(T) std::numeric_limits<T>::min()

using namespace std;
typedef pair<int, int> pii;
typedef long long ll;
const int INF = 1e9 + 123;
const ll INFL = 1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll l, ll r) {
	return ll_distr(tw) % (r - l + 1) + l;
}

template <typename T>
T input() {
	T res; cin >> res; return res;
}

template <typename IT>
void input_seq(IT a, IT b) {
	generate(a, b, input<typename std::remove_reference<decltype(*a)>::type>);
}

struct point {
	ll x, y;
	point(ll _x, ll _y) : x(_x), y(_y) {}
	
	point operator+(point const& other) const {
		return point(x + other.x, y + other.y);
	}
	
	point operator-(point const& other) const {
		return point(x - other.x, y - other.y);
	}	
	
	void norm() {
		ll tmp = __gcd(abs(x), abs(y));
		x /= tmp;
		y /= tmp;
	}
};

ll cross(point const& p1, point const& p2) {
	return p1.x * p2.y - p1.y * p2.x;
}

ll scalar(point const& p1, point const& p2) {
	return p1.x * p2.x + p1.y * p2.y;
}

struct line {
	ll a, b, c;
	line(ll _a, ll _b, ll _c) : a(_a), b(_b), c(_c) {}
};

void solve() {
	int n, m, k;
	cin >> n >> m >> k;
	vector<point> points;
	for (int i = 0; i < k; ++i) {
		int x, y;
		cin >> x >> y;
		points.push_back(point(x, y));
	}
	int l = 0, r = n;
	vector<line> upper, down;
	upper.push_back(line(0, -1, m));
	down.push_back(line(0, 1, 0));
	for (int i = 1; i < k; ++i) {
		if (points[i].y > points[0].y) {
			point v = points[0] - points[i];
			v.norm();
			upper.push_back(line(v.x * 2, v.y * 2, -(scalar(v, points[0]) + scalar(v, points[i]))));
		} else if (points[i].y < points[0].y) {
			point v = points[0] - points[i];
			v.norm();
			down.push_back(line(v.x * 2, v.y * 2, -(scalar(v, points[0]) + scalar(v, points[i]))));
		} else {
			if (points[i].x < points[0].x) {
				l = max(l, (int) (points[i].x + points[0].x + 1) / 2);
			} else {
				r = min(r, (int) (points[i].x + points[0].x) / 2);
			}
		}
	}
		
	sort(bend(upper), [&](line a, line b) {
		ll val = cross(point(a.a, a.b), point(b.a, b.b));
		if (val) {
			return val < 0;
		}
		return a.c > b.c;
	});
	
	auto eval_upper = [&](line l, int x) {
		return (l.c + l.a * x) / (-l.b);
	};
	
	auto eval_down = [&](line l, int x) {
		return (-l.c - l.a * x) / l.b;
	};

	auto pred_upper = [&](auto a, auto b, auto c) {
		int l = 0, r = n;
		while (r - l > 1) {
			int mid = (l + r) / 2;
			if (eval_upper(a, mid) <= eval_upper(b, mid)) {
				l = mid;
			} else {
				r = mid;
			}
		}
		return eval_upper(c, r) <= eval_upper(b, r);
	};
	
	auto pred_down = [&](auto a, auto b, auto c) {
		int l = 0, r = n;
		while (r - l > 1) {
			int mid = (l + r) / 2;
			if (eval_down(a, mid) >= eval_down(b, mid)) {
				l = mid;
			} else {
				r = mid;
			}
		}
		return eval_down(c, r) >= eval_down(b, r);
	};
	
	vector<line> st_upper;
	for (auto l : upper) {
		if (szof(st_upper) && l.a == st_upper.back().a && l.b == st_upper.back().b) {
			st_upper.pop_back();
		}
		while (szof(st_upper) >= 2) {
			auto a = st_upper[szof(st_upper) - 2];
			auto b = st_upper.back();
			if (pred_upper(a, b, l)) {
				st_upper.pop_back();
			} else {
				break;
			}
		}
		st_upper.push_back(l);
	}
	
	sort(bend(down), [&](line a, line b) {
		ll val = cross(point(a.a, a.b), point(b.a, b.b));
		if (val) {
			return val > 0;
		}
		return a.c > b.c;
	});	
	
	vector<line> st_down;
	for (auto l : down) {
		if (szof(st_down) && l.a == st_down.back().a && l.b == st_down.back().b) {
			st_down.pop_back();
		}
		while (szof(st_down) >= 2) {
			auto a = st_down[szof(st_down) - 2];
			auto b = st_down.back();
			if (pred_down(a, b, l)) {
				st_down.pop_back();
			} else {
				break;
			}
		}
		st_down.push_back(l);
	}
	
	swap(st_upper, upper);
	swap(st_down, down);

	//for (auto l : down) {
	//	cerr << l.a << " " << l.b << " " << l.c << endl;
	//}
	
	int cnt0 = 0, cnt1 = 0;
	ll ans = 0;
	for (int x = l; x <= r; ++x) {
		//cerr << x << endl;
		while (cnt0 < szof(upper) - 1 && eval_upper(upper[cnt0], x) > eval_upper(upper[cnt0 + 1], x)) {
			++cnt0;
		}
		int y1 = eval_upper(upper[cnt0], x);
		while (cnt1 < szof(down) - 1 && eval_down(down[cnt1], x) < eval_down(down[cnt1 + 1], x)) {
			++cnt1;
		}
		int y0 = eval_down(down[cnt1], x);
		if (y0 <= y1) {
			ans += y1 - y0 + 1;
		}
		//cerr << y0 << " " << y1 << endl;
	}
	
	cout << ans << "\n";
}

int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(5) << fixed;
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	cout << setprecision(15) << fixed;
	
	solve();
	
#ifdef LOCAL
	auto end_time = clock();
	cerr << "time: " << (end_time - start_time) * 1000 / CLOCKS_PER_SEC << endl;
#endif
	return 0;
}