#include <vector>
#include <iostream>
#include <string>
#include <queue>
#include <fstream>
#include <algorithm>

using namespace std;

vector<vector<char> > f;
vector<vector<int> > cc;

const int dx[4] = { -1, 0, 1, 0 };
const int dy[4] = { 0, 1, 0, -1 };
const char dc[4] = { 'U', 'R', 'D', 'L' };

void cc_dfs(int x, int y, int ccn)
{
	if (f[x][y] != '.')
		return;
	if (cc[x][y] != -1)
		return;
	cc[x][y] = ccn;
	for (int j = 0; j < 4; j++)
		cc_dfs(x + dx[j], y + dy[j], ccn);
}

vector<vector<int> > g;

vector<int> sp_dfs(int s, int f)
{
	queue<int> q;
	vector<int> ans(g.size(), -1);
	vector<int> prev(g.size());
	ans[s] = 0;
	q.push(s);
	while (q.size())
	{
		int v = q.front();
		q.pop();
		for (int u : g[v])
		{
			if (ans[u] == -1)
			{
				ans[u] = ans[v] + 1;
				prev[u] = v;
				q.push(u);
			}
		}
	}
	vector<int> ret;
	if (ans[f] != -1)
	{
		ret.push_back(f);
		while (ret.back() != s)
			ret.push_back(prev[ret.back()]);
		reverse(ret.begin(), ret.end());
	}
	return ret;
}

vector<string> out;

char port_col = 'O';
char port()
{
	if (port_col == 'O')
		port_col = 'B';
	else
		port_col = 'O';
	return port_col;
}

vector<vector<pair<int, int> > > sl;
vector<vector<pair<int, int> > > sr;
vector<vector<pair<int, int> > > su;
vector<vector<pair<int, int> > > sd;

vector<vector<char> > fn_used;
vector<vector<char> > fw_used;
vector<vector<char> > ff_used;

bool find_wall(int x, int y)
{
	if (f[x][y] != '.' || fw_used[x][y])
		return 0;
	fw_used[x][y] = 1;
	//cerr << "found_wall\n";
	//for (string s : out)
	//	cout << s << "\n";
	//cerr << "--\n";
	if (sl[x][y].first == x && sl[x][y].second == y) {out.push_back(string(1, port()) + 'L');out.push_back("ML"); return 1;}
	if (sr[x][y].first == x && sr[x][y].second == y) {out.push_back(string(1, port()) + 'R');out.push_back("MR"); return 1;}
	if (su[x][y].first == x && su[x][y].second == y) {out.push_back(string(1, port()) + 'U');out.push_back("MU"); return 1;}
	if (sd[x][y].first == x && sd[x][y].second == y) {out.push_back(string(1, port()) + 'D');out.push_back("MD"); return 1;}
	for (int j = 0; j < 4; j++)
	{
		out.push_back(string("M") + dc[j]);
		if (find_wall(x + dx[j], y + dy[j]))
		{
			return 1;
		}
		out.pop_back();
	}
	return 0;
}


int fx, fy;

bool find_fin(int x, int y)
{
	if (f[x][y] != '.' || ff_used[x][y])
		return 0;
	if (x == fx && y == fy)
	{
		//cerr << "found_fin\n";
		//for (string s : out)
		//	cout << s << "\n";
		//cerr << "--\n";
		return 1;
	}
	ff_used[x][y] = 1;
	for (int j = 0; j < 4; j++)
	{
		out.push_back(string("M") + dc[j]);
		if (find_fin(x + dx[j], y + dy[j]))
		{
			return 1;
		}
		out.pop_back();
	}
	return 0;
}

pair<pair<int, int>, int> find_next(int x, int y, int nxt, bool st)
{
	if (f[x][y] != '.' || fn_used[x][y])
		return { {0, 0}, -1 };
	fn_used[x][y] = 1;
	pair<int, int> arr[] = { su[x][y], sr[x][y], sd[x][y], sl[x][y] };
	for (int j = 0; j < 4; j++)
	{
		if (cc[arr[j].first][arr[j].second] == nxt)
		{
			out.push_back(string(1, port()) + dc[j]);
			if (st)
				if (!find_wall(x, y))
					return { {0, 0}, -1 };
					
			return { arr[j], j };
		}
	}
	for (int j = 0; j < 4; j++)
	{
		out.push_back(string("M") + dc[j]);
		auto ret = find_next(x + dx[j], y + dy[j], nxt, st);
		if (ret.second == -1)
		{
			out.pop_back();
			continue;
		}
		if (!st)
			out.push_back(string("M") + dc[(j + 2) % 4]);
		return ret;
	}
	return { {0, 0}, -1 };
}

int main()
{
	//ifstream cin("input.txt");
	int n, m;
	cin >> n >> m;
	f.resize(n, vector<char>(m));
	for (auto& a : f)
		for (auto& c : a)
			cin >> c;
	sl.resize(n, vector<pair<int, int> >(m));
	sr.resize(n, vector<pair<int, int> >(m));
	su.resize(n, vector<pair<int, int> >(m));
	sd.resize(n, vector<pair<int, int> >(m));
	fn_used.resize(n, vector<char>(m));
	fw_used.resize(n, vector<char>(m));
	ff_used.resize(n, vector<char>(m));
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < m; j++)
		{
			if (f[i][j] == 'W')
			{
				sl[i][j] = { -1, -1 };
				su[i][j] = { -1, -1 };
				continue;
			}
			sl[i][j] = sl[i][j - 1];
			su[i][j] = su[i - 1][j];
			if (sl[i][j].first == -1)
				sl[i][j] = { i, j };
			if (su[i][j].first == -1)
				su[i][j] = { i, j };
		}
	}
	for (int i = n - 1; i >= 0; --i)
	{
		for (int j = m - 1; j >= 0; --j)
		{
			if (f[i][j] == 'W')
			{
				sd[i][j] = { -1, -1 };
				sr[i][j] = { -1, -1 };
				continue;
			}
			sd[i][j] = sd[i + 1][j];
			sr[i][j] = sr[i][j + 1];
			if (sr[i][j].first == -1)
				sr[i][j] = { i, j };
			if (sd[i][j].first == -1)
				sd[i][j] = { i, j };
		}
	}
	cc.resize(n, vector<int>(m, -1));
	int cct = 0;
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < m; j++)
		{
			if (f[i][j] == '.' && cc[i][j] == -1)
				cc_dfs(i, j, cct++);
		}
	}
	int sx, sy;
	cin >> sx >> sy >> fx >> fy;
	--sx, --sy, --fx, --fy;
	g.resize(cct);
	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < m; j++)
		{
			if (f[i][j] != '.')
				continue;
			for (auto p : { sd[i][j], su[i][j], sl[i][j], sr[i][j] })
				if (cc[p.first][p.second] != -1)
					g[cc[i][j]].push_back(cc[p.first][p.second]);
		}
	}
	vector<int> p = sp_dfs(cc[sx][sy], cc[fx][fy]);
	if (p.empty())
	{
		cout << "-1 -1";
		return 0;
	}
	pair<pair<int, int>, int> pos = { {sx, sy}, -1 };
	for (int j = 0; j < p.size(); j++)
	{
		if (j == p.size() - 1)
		{
			find_fin(pos.first.first, pos.first.second);
			int port_cnt = p.size() - (p.size() == 1);
			cout << port_cnt << " " << out.size() - port_cnt << "\n";
			for (auto s : out)
			{
				cout << s << "\n";
			}
			return 0;
		}
		if (pos.second == -1 && j)
		{
			cout << "-1 -1";
			return 0;
		}
		auto npos = find_next(pos.first.first, pos.first.second, p[j + 1], j == 0);
		if (j != 0)
			out.push_back(string("M") + dc[pos.second]);
		pos = npos;
	}
	return 0;
}