#include <bits/stdc++.h>
using namespace std;

#define forn(i, n) for (int i = 0;i < (n); i++)
#define fornr(i, n) for (int i = (n) - 1; i >=0 ; i--)
#define forab(i, a, b) for (int i = (a); i < (b); i++)

#define pb push_back
#define mp make_pair
#define all(v) (v).begin(), (v).end()

typedef long long ll;
typedef long long LL;
typedef unsigned long long ull;
typedef unsigned long long ULL;
typedef pair<int, int> pii;
typedef vector<int> vi;

struct __TIMESTAMP {
     ~__TIMESTAMP() {
        cerr << "\n\n" << 1.0 * clock() / CLOCKS_PER_SEC << " sec\n";
     }
} __T;

const int MOD = 1e9 + 7;

struct Mx {
    vector<vector<LL>> a;

    Mx() {
        a.resize(4);
        forn(i, 4) a[i].resize(4);
        forn(i, 4) forn(j, 4) a[i][j] = 0;
    }

    Mx (int x) {
        a.resize(4);
        forn(i, 4) a[i].resize(4);
        forn(i, 4) a[i][i] = x;
    }

    Mx operator * (const Mx &x) const {
        Mx res;
        forn(i, 4) {
            forn(j, 4) {
                res.a[i][j] = 0;
                forn(k, 4) res.a[i][j] += a[i][k] * x.a[k][j];
                res.a[i][j] %= MOD;
            }
        }
        return res;
    }

    Mx operator + (const Mx &x) const {
        Mx res;
        forn(i, 4) {
            forn(j, 4) {
                res.a[i][j] = (a[i][j] + x.a[i][j]) % MOD;
            }
        }
        return res;
    }
};

const Mx E(1);

LL fastpow(LL x, int y) {
    if (y == 0) return 1;
    LL k = fastpow(x, y / 2);
    k = k * k % MOD;
    if (y % 2) return (x * k) % MOD;
    return k;
}

Mx fastpow(const Mx& x, int y) {
    if (y == 0) return E;
    Mx k = fastpow(x, y / 2);
    k = k * k;
    if (y % 2) return (x * k);
    return k;
}

Mx A;

LL rev(LL x) {
    return fastpow(x, MOD - 2);
}

Mx getSum(int k) {
    Mx B = A;
    Mx S = E;
    forn(i, k) {
        S = S + B * S;
        B = B * B;
    }

    return S;
}

int main() {
/*
    A.a[0][1] = 1;
    A.a[1][0] = A.a[1][2] = 1;
    A.a[2][0] = A.a[2][1] = A.a[2][2] = A.a[2][3] = 1;
    A.a[3][0] = 23; A.a[3][1] = 25; A.a[3][2] = 24; A.a[3][3] = 25;
  */
    A.a = {
        {25, 1, 0, 0},
        {24, 1, 1, 0},
        {24, 1, 0, 1},
        {24, 1, 0, 0}
        };
    int n;
    scanf("%d", &n);

    if (n < 4) {
        puts("0");
        return 0;
    }
    
    LL ans = 3 * (fastpow(26, n - 3) - 1) % MOD * rev(25) % MOD;
    
    ans = (ans + (fastpow(26, n + 1) - 1) * rev(25)) % MOD;

    Mx S, T = E;
    Mx sum;
    for (int bit = 30; bit >= 0; bit--) {
        if ((1<<bit) <= n + 1) {
            sum = sum + getSum(bit) * T;      
            T = T * fastpow(A, 1<<bit);
            n -= 1<<bit;
        }
    }

    /*
    forn(i, 4) {
        forn(j, 4) {
            printf("%lld ", sum.a[i][j]);
        }
        puts("");
    }
    cerr << ans << endl;
    */
    forn(i, 4) ans -= sum.a[0][i];
    //cerr << ans % MOD << endl;
    printf("%lld\n", (ans % MOD + MOD) % MOD);
}

