#include <bits/stdc++.h>
using namespace std;

#define forn(i, n) for (int i = 0;i < (n); i++)
#define fornr(i, n) for (int i = (n) - 1; i >=0 ; i--)
#define forab(i, a, b) for (int i = (a); i < (int)(b); i++)

#define pb push_back
#define mp make_pair
#define all(v) (v).begin(), (v).end()
#define ff first
#define ss second

typedef long long ll;
typedef long long LL;
typedef unsigned long long ull;
typedef unsigned long long ULL;
typedef pair<int, int> pii;
typedef vector<int> vi;

struct __TIMESTAMP {
     ~__TIMESTAMP() {
        cerr << "\n\n" << 1.0 * clock() / CLOCKS_PER_SEC << " sec\n";
     }
} __T;

const int maxn = 1179;

string field[maxn];

vector<pair<int, int>> path;
int mark[maxn][maxn];
int dx[4] = {-1, 1, 0, 0};
int dy[4] = {0, 0, -1, 1};
bool dfs(int x, int y, int c, int fx, int fy) {
    mark[x][y] = c;
    path.push_back(mp(x, y));
    if (x == fx && y == fy)
        return true;
    forn(k, 4) {
        int nx = x + dx[k];
        int ny = y + dy[k];
        if (mark[nx][ny] == c)
            continue;
        if (field[nx][ny] != '.' && (nx != fx || ny != fy))
            continue;
        if (dfs(nx, ny, c, fx, fy))
            return true;
    }
    path.pop_back();
    return false;
}

vector<string> ans;

void restore() {
    int cx = path[0].first, cy = path[0].second;
    forab(i, 1, path.size()) {
         int x = path[i].first;
         int y = path[i].second;
         if (x - cx == 1)
            ans.pb("MD");
         if (cx - x == 1)
            ans.pb("MU");
         if (y - cy == 1)
            ans.pb("MR");
         if (cy - y == 1)
            ans.pb("ML");
         cx = x;
         cy = y;
    }    
    path.clear();
}

int dist[maxn][maxn];
bool vis[maxn][maxn];
int prev_x[maxn][maxn];
int prev_y[maxn][maxn];

int next_wall_w[maxn][maxn];
int next_wall_e[maxn][maxn];
int next_wall_n[maxn][maxn];
int next_wall_s[maxn][maxn];

pair<int, int> reach_wall(int x, int y, int c) {
    if (field[x][y] == 'W')
        return {x, y};
    mark[x][y] = c;
    forn(k, 4) {
        int nx = x + dx[k], ny = y + dy[k];
        if (field[nx][ny] == 'G')
            continue;
        if (mark[nx][ny] == c)
            continue;
        auto p = reach_wall(nx, ny, c);
        if (p != mp(-1, -1))
            return p;
    }
    return mp(-1, -1);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    forn(i, n)
        cin >> field[i];
    int sx, sy, ex, ey;
    cin >> sx >> sy >> ex >> ey;
    sx--; sy--; ex--; ey--;

    int cc = 0;
    if (dfs(sx, sy, ++cc, ex, ey)) {
        cout << "0 " << path.size() - 1 << endl;
        restore();
        for (auto s : ans)
            cout << s << endl;
        return 0;
    }
    path.clear();

    forn(i, n) {
        forn(j, m) {
            if (field[i][j] == 'W')
                next_wall_w[i][j] = j;
            else
                next_wall_w[i][j] = next_wall_w[i][j - 1];
        }
    }
    forn(i, n) {
        fornr(j, m) {
            if (field[i][j] == 'W')
                next_wall_e[i][j] = j;
            else
                next_wall_e[i][j] = next_wall_e[i][j + 1];
        }
    }
    forn(j, m) {
        forn(i, n) {
            if (field[i][j] == 'W')
                next_wall_n[i][j] = i;
            else
                next_wall_n[i][j] = next_wall_n[i - 1][j];
        }
    }
    forn(j, m) {
        fornr(i, n) {
            if (field[i][j] == 'W')
                next_wall_s[i][j] = i;
            else
                next_wall_s[i][j] = next_wall_s[i + 1][j];
        }
    }

    auto p = reach_wall(sx, sy, ++cc);

    if (p == mp(-1, -1)) {
        cout << "-1 -1";
        cerr << "wall" << endl;
        return 0;
    }

    dfs(sx, sy, ++cc, p.ff, p.ss);
    restore();
    ans.back()[0] = 'B';
    int px = p.ff, py = p.ss;
    sx = p.ff; sy = p.ss;
    if (ans.back()[1] == 'L') {
        sy += 1;    
    }
    if (ans.back()[1] == 'R') {
        sy -= 1;
    }
    if (ans.back()[1] == 'U') {
        sx += 1;
    }
    if (ans.back()[1] == 'D') {
        sx -= 1;
    }

    forn(i, n)
        forn(j, m)
            dist[i][j] = numeric_limits<int>::max();

    deque<pii> dq;
    dq.push_back(mp(sx, sy));
    dist[sx][sy] = 0;
    prev_x[sx][sy] = prev_y[sx][sy] = -1;

    while (!dq.empty()) {
        int x = dq.front().first;
        int y = dq.front().second;
        dq.pop_front();

        if (vis[x][y])
            continue;
        vis[x][y] = true;
                                            

        for (int i = 0; i < 4; i++) {
            int nx = x + dx[i];
            int ny = y + dy[i];
            if (field[nx][ny] != '.')
                continue;
            if (dist[nx][ny] <= dist[x][y])
                continue;
            dist[nx][ny] = dist[x][y];
            prev_x[nx][ny] = x;
            prev_y[nx][ny] = y;
            dq.push_front(mp(nx, ny));
        }
        forn(_, 1)
        if (field[x + 1][y] == 'G') {
            int nx = next_wall_s[x][y] - 1;
            int ny = y;
            if (field[nx][ny] != '.')
                continue;
            if (dist[nx][ny] <= dist[x][y] + 1)
                continue;
            dist[nx][ny] = dist[x][y] + 1;
            prev_x[nx][ny] = x;
            prev_y[nx][ny] = y;
            dq.push_back(mp(nx, ny));
        }
        forn(_, 1)
        if (field[x - 1][y] == 'G') {
            int nx = next_wall_n[x][y] + 1;
            int ny = y;
            if (field[nx][ny] != '.')
                continue;
            if (dist[nx][ny] <= dist[x][y] + 1)
                continue;
            dist[nx][ny] = dist[x][y] + 1;
            prev_x[nx][ny] = x;
            prev_y[nx][ny] = y;
            dq.push_back(mp(nx, ny));
        }
        forn(_, 1)
        if (field[x][y + 1] == 'G') {
            int ny = next_wall_e[x][y] - 1;
            int nx = x;
            if (field[nx][ny] != '.')
                continue;
            if (dist[nx][ny] <= dist[x][y] + 1)
                continue;
            dist[nx][ny] = dist[x][y] + 1;
            prev_x[nx][ny] = x;
            prev_y[nx][ny] = y;
            dq.push_back(mp(nx, ny));
        }
        forn(_, 1)                          
        if (field[x][y - 1] == 'G') {
            int ny = next_wall_w[x][y] + 1;
            int nx = x;                         
            if (field[nx][ny] != '.')
                continue;
            if (dist[nx][ny] <= dist[x][y] + 1)
                continue;
            dist[nx][ny] = dist[x][y] + 1;
            prev_x[nx][ny] = x;
            prev_y[nx][ny] = y;
            dq.push_back(mp(nx, ny));
        }
    }

    if (!vis[ex][ey]) {
        cout << "-1 -1";
        cerr << "bfs" << endl;
        return 0;
    }

    vector<pair<int, int>> pp;
    int cx = ex, cy = ey;
    while (prev_x[cx][cy] >= 0) {
        pp.pb(mp(cx, cy));
        tie(cx, cy) = mp(prev_x[cx][cy], prev_y[cx][cy]);
    }
    pp.pb(mp(sx, sy));
    reverse(all(pp));
    char color[2] = {'B', 'O'};
    int b = 1;
    forab(i, 1, pp.size()) {
        int x, y;
        x = pp[i].ff, y = pp[i].ss;
        if (x - sx == 1)
            ans.pb("MD");
        else if (sx - x == 1)
            ans.pb("MU");
        else if (y - sy == 1)
            ans.pb("MR");
        else if (sy - y == 1)
            ans.pb("ML");
        else {
            string s = "  ";
            s[0] = color[b];
            b ^= 1;
            int npx = x, npy = y;
            if (x > sx) {
                s[1] = 'D';
                npx++; 
            }
            if (x < sx) {
                s[1] = 'U';
                npx--;
            }
            if (y < sy) {
                s[1] = 'L';
                npy--;
            }
            if (sy < y) {
                s[1] = 'R';
                npy++;
            }
            ans.pb(s);
            assert(dfs(sx, sy, ++cc, px, py));
            restore();
            px = npx;
            py = npy;
        }
        sx = x;
        sy = y;
    }

    assert((int)ans.size() - (dist[ex][ey] + 1) <= 2 * n * m);
    cout << dist[ex][ey] + 1 << " " << ans.size() - (dist[ex][ey] + 1) << endl;
    for (auto s : ans)
        cout << s << endl;

    return 0;
}

