#include <bits/stdc++.h>

using namespace std;

using ll = long long;

mt19937 mt(736);

const int mod = 1e9 + 7;

void add (int &a, int b)
{
	a += b;
	if (a >= mod)
		a -= mod;
}
void sub (int &a, int b)
{
	a -= b;
	if (a < 0)
		a += mod;
}
int mult (int a, int b)
{
	return ll(a) * b % mod;
}
int powmod (int a, int pw)
{
	int res = 1;
	while (pw)
	{
		if (pw & 1)
			res = mult(res, a);
		a = mult(a, a);
		pw >>= 1;
	}

	return res;
}
int mult (int a, int b, int c)
{
	return mult(mult(a, b), c);
}

const int let = 26;

int f (int n)
{
	int ans = mult(n + 1, let - 1, powmod(let, n));
	sub(ans, powmod(let, n + 1));
	add(ans, 1);
	ans = mult(ans, powmod((let - 1) * (let - 1), mod - 2));
	return ans;
}

void solve(istream &cin = std::cin, ostream &cout = std::cout)
{
	int n;
	cin >> n;

	if (n <= 3)
	{
		cout << 0 << endl;
		return;
	}

	int ans = f(n);
	sub(ans, f(3));

#ifdef LOCAL
	int rans = 0;
	for (int i = 4; i <= n; i++)
		add(rans, mult(i, powmod(let, i - 1)));
	assert(ans == rans);
#endif

	ans = mult(ans, powmod(let * let * let, mod - 2));
	cout << ans << endl;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	cout << fixed;

#ifdef LOCAL
	ifstream fin("../input.txt");

	solve(fin);

	cout << "clock: " << clock() / (double) CLOCKS_PER_SEC << endl;
#else
	solve();
#endif

	return 0;
}
