#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>

using namespace std;

using ll = long long;

mt19937 mt(736);

const int let = 26;

struct query
{
	int k, id;

	bool operator<(const query &o) const
	{
		return k < o.k;
	}
};

struct trie
{
	vector<vector<int>> sons;
	vector<int> dep, cnt, par;

	trie ()
	{
		sons.assign(1, vector<int>(let, -1));
		dep.assign(1, -1);
		cnt.assign(1, 0);
		par.assign(1, -1);
	}

	int add (const string &s)
	{
		int v = 0;
		for (char ch : s)
		{
			cnt[v]++;
			if (sons[v][ch - 'a'] == -1)
			{
				sons[v][ch - 'a'] = int(sons.size());
				sons.emplace_back(let, -1);
				dep.push_back(dep[v] + 1);
				cnt.push_back(0);
				par.push_back(v);
			}

			v = sons[v][ch - 'a'];
		}

		cnt[v]++;
		return v;
	}

	vector<ll> work (int v, const vector<query> &qs)
	{
		const ll inf = ll(1e18);
		assert(is_sorted(qs.begin(), qs.end()));

		vector<pair<int, int>> order;

		{
			int nv = v;
			while (nv != 0)
			{
				order.emplace_back(dep[nv], cnt[nv]);
				nv = par[nv];
			}
		}

		vector<ll> ans(int(qs.size()), inf);

		function<void(int, int, int, int)> rec = [&] (int l, int r, int pl, int pr)
		{
			if (l >= r)
				return;
			const int m = (l + r) / 2;

			int where = -1;
			for (int p = pl; p < pr; p++)
			{
				ll cur = ll(qs[m].k) * order[p].first + order[p].second;
				if (ans[m] > cur)
				{
					ans[m] = cur;
					where = p;
				}
			}

			assert(where != -1);

			rec(l, m, pl, where + 1);
			rec(m + 1, r, where, pr);
		};

		rec(0, int(qs.size()), 0, int(order.size()));

		for (int i = 0; i < int(qs.size()); i++)
			ans[i] = min(ans[i], ll(dep[v] + 1) * qs[i].k);
		return ans;
	}
};

void solve(istream &cin = std::cin, ostream &cout = std::cout)
{
	int n;
	cin >> n;

	trie data;
	vector<int> v_num(n);

	for (int i = 0; i < n; i++)
	{
		string s;
		cin >> s;
		v_num[i] = data.add(s);
	}

	int q;
	cin >> q;

	vector<vector<query>> by_v(n);
	vector<ll> ans(q, -1);

	for (int i = 0; i < q; i++)
	{
		int w, k;
		cin >> w >> k;
		--w;

		by_v[w].push_back({k, i});
	}

	for (int i = 0; i < n; i++)
	{
		sort(by_v[i].begin(), by_v[i].end());
		vector<ll> cur_ans = data.work(v_num[i], by_v[i]);

		for (int j = 0; j < int(by_v[i].size()); j++)
			ans[by_v[i][j].id] = cur_ans[j];
	}

	for (int i = 0; i < q; i++)
		cout << ans[i] << '\n';
	cout.flush();
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	cout << fixed;

#ifdef LOCAL
	ifstream fin("../input.txt");

	solve(fin);

	cout << "clock: " << clock() / (double) CLOCKS_PER_SEC << endl;
#else
	solve();
#endif

	return 0;
}
