#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <unordered_map>
#include <set>
#include <cmath>
#include <iomanip>
#include <queue>
#include <stack>


using namespace std;

typedef long long ll;
typedef unsigned long long ull;

const ll MOD = ll(1e9) + 7;

ll binpow(ll a, ll p) {
	if (p == 0)
		return 1;
	if (p == 1)
		return a;
	if (p % 2 == 1) {
		return (a * binpow(a, p - 1)) % MOD;
	}
	ll b = binpow(a, p / 2);
	return (b * b) % MOD;
}

ll del(ll a, ll b) {
	return a * binpow(b, MOD - 2) % MOD;
}

int main() {
	ll n;
	cin >> n;
	ll ans = 0;
	vector <ll> v = { 364228286, 264751201, 234447052, 842257687, 601571710, 499780605, 781999629, 906514422, 203018974, 372863040, 372863040 };
	for (int i = 4; i <= 1e7; ++i) {
		ans += i * binpow(26, i - 4);
		ans %= MOD;
		if (i % (int)1e6 == 0) {
			v.push_back(ans);
			cout << "GOSHA";
		}
	}
	for (ll x : v)
		cout << x << ' ';
	cout << ans;
}
