#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <unordered_map>
#include <set>
#include <cmath>
#include <iomanip>
#include <queue>
#include <stack>


using namespace std;

typedef long long ll;
typedef unsigned long long ull;

vector<vector<int>> graph;
vector<bool> vis;
vector <int> ans;
int maxans = -1;
int comp = 0;
ll p, t, m;

void dfs(int cur) {
	vis[cur] = true;
	if (cur >= p) comp++;
	for (auto i : graph[cur]) if (!vis[i]) dfs(i);
}

void dfs2(int cur) {
	vis[cur] = true;
	if (cur >= p) ans.push_back(cur - p);
	for (auto i : graph[cur]) if (!vis[i]) dfs2(i);
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cin >> p >> t >> m;
	vector <int> cnt(t, 0);
	vector<pair<int, int>> cnt_task(p);
	vector <vector <int> > g(t);
	graph.resize(p + t);
	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		u--, v--;
		cnt[v]++;
		g[v].push_back(u);
		cnt_task[u].first++;
		cnt_task[u].second = u;
	}
	for (int i = 0; i < t; ++i) {
		if (cnt[i] == 0) {
			ans.push_back(i);
		}
	}
	if (ans.size() > 0) {
		cout << p << ' ' << ans.size() << endl;
		for (int x : ans)
			cout << x + 1 << ' ';
		return 0;
	}
	int min_task = 1e9, min_id = -1;
	for (int i = 0; i < t; ++i) {
		if (cnt[i] < min_task) {
			min_task = cnt[i];
			min_id = i;
		}
	}
	graph.resize(p + t);
	vis.resize(p + t);
	for (int i = 0; i < t; i++) {
		if (cnt[i] == min_task) {
			for (auto c : g[i]) {
				graph[p + i].push_back(c);
				graph[c].push_back(p + i);
			}
		}
	}
	int maxindex = -1;
	for (int i = 0; i < t; i++) {
		if (cnt[i] == min_task) {
			comp = 0;
			dfs(p + i);
			if (comp > maxans) {
				maxans = comp;
				maxindex = i;
			}
		}
	}
	vis.assign(p + t, false);
	dfs2(maxindex + p);
	cout << p - min_task << ' ' << ans.size() << endl;
	for (int x : ans)
		cout << x + 1 << ' ';
}

