data class Player (val height: Int,
                   val wingSpan: Int,
                   val avgScore: Int,
                   val avgPickup: Int,
                   val avgPasses: Int) {
    
    // Количество категорий лучше или равно указанной
    private fun hasCategory(cat: Int): Int {
        var result = 0
        if (height == cat) result++
        if (wingSpan == cat) result++
        if (avgScore == cat) result++
        if (avgPickup == cat) result++
        if (avgPasses == cat) result++
        return result
    }

    // Выше (включая) диапазона cat
    private fun categoryHigherOrEquals(cat: Int): Int {
        var result = 0
        if (height >= cat) result++
        if (wingSpan >= cat) result++
        if (avgScore >= cat) result++
        if (avgPickup >= cat) result++
        if (avgPasses >= cat) result++
        return result
    }
    
    val playerCategory = when {
        // 0 cat
        (hasCategory(3) >= 3) && ((wingSpan == 3) || (height == 3)) -> 0
        // 1 cat
        (hasCategory(3) >= 2) && (categoryHigherOrEquals(2) >= 1) -> 1
        (categoryHigherOrEquals(1) == 5) && (categoryHigherOrEquals(2) >= 3) -> 1
        // 2 cat
        (hasCategory(3) == 1) && (categoryHigherOrEquals(2) >= 2) -> 2
        (categoryHigherOrEquals(2) >= 3) -> 2
        // 3 cat
        else -> 3
    }
}

fun Int.getCategory(low: Int, high: Int)
    = when {
    (this < low) -> 0
    (this > low) && (this < low + ((high - low) / 2)) -> 1
    (this >= low + ((high - low) / 2)) && (this < high) -> 2
    else -> 3
}

fun readInt() = readLine()!!.toInt()

fun makePlayer(): Player
    = Player(readInt().getCategory(190, 220),
        readInt().getCategory(200, 250),
        readInt().getCategory(10, 20),
        readInt().getCategory(2, 6),
        readInt().getCategory(3, 7))

fun solve(): Any {
    val n = readInt()
    return (1..n)
        .map { makePlayer().playerCategory }
        .joinToString("\n")
}

fun main() = println(solve())