#include <iostream>
#include <vector>
#include <random>

typedef long long int ll;
using namespace std;

const ll MOD = 1000000007;

vector<vector<ll>> st = {{0, 4, 26, 1, 4}};
vector<vector<ll>> one =
        {{1, 0, 0, 0, 0},
         {0, 1, 0, 0, 0},
         {0, 0, 1, 0, 0},
         {0, 0, 0, 1, 0},
         {0, 0, 0, 0, 1}};
vector<vector<ll>> matrix =
        {{1, 0, 0,  0, 0},
         {0, 1, 0,  0, 0},
         {0, 0, 26, 0, 1},
         {0, 1, 0,  1, 0},
         {1, 0, 0,  0, 26}};

vector<vector<ll>> mul(vector<vector<ll>> first, vector<vector<ll>> second) {
    int n = first.size();
    int m = first[0].size();
    int k = second[0].size();
    vector<vector<ll>> res(n, vector<ll>(k, 0));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < k; ++j) {
            for (int u = 0; u < m; ++u) {
                res[i][j] += (first[i][u] * second[u][j]) % MOD;
            }
            res[i][j] %= MOD;
        }
    }
    return res;
}

vector<vector<ll>> binPow(vector<vector<ll>> m, int p) {
    if (p == 0) {
        return one;
    }
    if (p == 1) {
        return m;
    }
    vector<vector<ll>> h = binPow(m, p / 2);
    if (p & 1) {
        return mul(mul(h, h), m);
    } else {
        return mul(h, h);
    }
}

int main() {
#ifdef LOCAL_VAR
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
//    ll ans = 0;
//    ll t = 1;
//    for (int i = 4; i <= n; ++i) {
//        ans += i * t;
//        t *= 26;
//        t %= MOD;
//        ans %= MOD;
//    }
//    cout << ans << endl;
    if (n <= 3) {
        cout << 0;
        return 0;
    }
    vector<vector<ll>> y = mul(st, binPow(matrix, n - 3));
    cout << y[0][0];
}