#include <iostream>
#include <vector>
#include <set>
#include <unordered_map>
#include <algorithm>

using namespace std;

constexpr long long mod = 1e9 +7;
constexpr long long step = 100003;

bool comp(const pair<set<int>, int>& l, const pair<set<int>, int>& r){
    return l.first.size() < r.first.size();
}

long long make_hash(const set<int>& elements){
    long long res = 0;
    for(auto& elem : elements){
        res = (((res + elem)%mod)*step)%mod;
    }
    return res;
}

pair<set<int>, int> G[100001];
int main() {
    for(int i=0;i<100001; ++i){
        G[i].second = i;
    }
    int p, t, m;
    std::cin>>p>>t>>m;
    for(int i=0;i<m;++i){
        int a, b;
        std::cin>>a>>b;
        G[b-1].first.insert(a-1);
    }
    sort(G, G+t, comp);
    int min_val = G[0].first.size();
    unordered_map<long long, vector<int>> hash_table;
    for(int i=0;i<m && G[i].first.size() == min_val; ++i){
        hash_table[make_hash(G[i].first)].emplace_back(G[i].second);
    }
    int m_val = hash_table.begin()->second.size();
    auto res_hash = hash_table.begin()->first;
    for(auto &elem: hash_table){
        if(m_val < elem.second.size()){
            m_val = elem.second.size();
            res_hash = elem.first;
        }
    }
    std::cout<<p - min_val<<' '<<m_val<<'\n';
    for(auto &elem: hash_table[res_hash]){
        std::cout<<elem+1<<' ';
    }
}

/*
3 4 6
1 1
1 2
2 2
2 3
3 3
3 4

3 5 6
1 1
1 2
2 1
2 3
3 1
3 3
*/