#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <unordered_map>
#include <unordered_set>

using namespace std;

struct bor {
    bor(): cnt(0), cntInSubtree(0), next('z' - 'a' + 1, {"", nullptr}) {}
    vector<pair<string, bor*>> next;
    int cnt;
    int cntInSubtree;
};

int get(char a) {
    return a - 'a';
}

void add2bor(bor* node, const char* str, size_t length) {
    if (length == 0) {
        node->cnt += 1;
        return;
    }
    auto& here = node->next[get(str[0])];
    if (here.second == nullptr) {
        here.second = new bor();
        here.second->cnt += 1;
        here.first = string(str);
    } else {
        size_t pos = 0;
        for (size_t i = 0; i < min(length, here.first.size()); i++) {
            if (here.first[i] != str[i]) {
                break;
            }
            pos++;
        }
        if (pos == here.first.size()) {
            add2bor(here.second, str + here.first.size(), length - here.first.size());
        } else {
            string left;
            string right;
            for (size_t i = 0; i < pos; i++) {
                left += here.first[i];
            }
            for (size_t i = pos; i < here.first.size(); i++) {
                right += here.first[i];
            }
            bor* then = new bor();
            then->next[get(right[0])] = {right, here.second};
            node->next[get(left[0])] = {left, then};
            add2bor(then, str + pos, length - pos);
        }
    }
}

void countChildren(bor* node) {
    int now = 0;
    for (auto& a: node->next) {
        if (a.second != nullptr) {
            countChildren(a.second);
            now += a.second->cntInSubtree;
        }
    }
    node->cntInSubtree = now + node->cnt;
}

void print(bor* node) {
    cout << "Node: " << node << " (" << node->cnt << ' ' << node->cntInSubtree << ")" << endl;
    for (auto& a: node->next) {
        if (a.second != nullptr) {
            cout << "Edge: " << node << " -> " << a.first << " -> " << a.second << endl;
            print(a.second);
        }
    }
}

void go(bor* node, const char* str, size_t length, size_t index, vector<pair<size_t, int>>& ans) {
    int answer = node->cntInSubtree;
    if (length != 0) {
        answer -= node->next[get(str[0])].second->cntInSubtree;
    }
    ans.emplace_back(index, answer);
    if (length == 0) {
        return;
    }
    auto& here = node->next[get(str[0])];
    go(here.second, str + here.first.size(), length - here.first.size(), index + here.first.size(), ans);
}

int main() {
    cin.tie(0);
    ios_base::sync_with_stdio(false);

    int n;
    cin >> n;
    bor* root = new bor();
    vector<string> words;
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        add2bor(root, s.data(), s.size());
        words.push_back(s);
    }
    countChildren(root);
    int q;
    cin >> q;
    for (int t = 0; t < q; t++) {
        int num;
        size_t K;
        cin >> num >> K;
        num--;
        vector<pair<size_t, int>> v;
        go(root, words[num].data(), words[num].size(), 0, v);
        size_t j = 1;
        size_t cur = 0;
        int ans = 0;
        while (true) {
            size_t k = K;
            if (j > v[cur].first) {
                cur++;
                if (cur == v.size()) {
                    break;
                }
            }
            while (k > 0) {
                if (v[cur].second >= k) {
                    ans += k;
                    v[cur].second -= k;
                    k = 0;
                } else {
                    ans += v[cur].second;
                    k -= v[cur].second;
                    v[cur].second = 0;
                    ++cur;
                    if (cur == v.size()) {
                        break;
                    }
                }
            }
            if (cur == v.size()) {
                break;
            }
            ++j;
        }
        cout << ans << endl;
    }

    return 0;
}