#include <bits/stdc++.h>
#define f first
#define s second

using namespace std;

using pii = pair<int, int>;

const int maxn = 1200;

string fie[maxn];
int col[maxn][maxn];
int cc = 1;
int dir[4][2] = {{0, 1}, {1, 0}, {0, -1}, {-1, 0}};

void dfs_comp(int x, int y)
{
    col[x][y] = cc;
    for (int i = 0; i < 4; ++i) {
        int nx = x + dir[i][0];
        int ny = y + dir[i][1];
        if (fie[nx][ny] == '.' && col[nx][ny] == 0) {
            dfs_comp(nx, ny);
        }
    }
}

int n, m;
int inf = 1e9;

map<pii, char> diff_to_dir = {{{0, 1}, 'R'}, {{1, 0}, 'D'}, {{0, -1}, 'L'}, {{-1, 0}, 'U'}};
char dir_to_str[4] = {'R', 'D', 'L', 'U'};

pii clcl[maxn][maxn][4];

struct edge {
    int fr;
    pii st;
    int dire;
    pii ed;
    int to;
};

int dist[maxn * maxn];
edge last[maxn * maxn];

int grid_dist[maxn][maxn];
int grid_used[maxn][maxn];
pii grid_last[maxn][maxn];
int grid_used_cur = 1;
vector<string> whole_path;

void grid_path(pii from, pii to)
{
    queue<pii> q;
    q.push(from);
    grid_used[from.f][from.s] = grid_used_cur;
    grid_dist[from.f][from.s] = 0;

    while (!q.empty()) {
        pii u = q.front(); q.pop();
        for (int d = 0; d < 4; ++d) {
            pii p = u;
            p.f += dir[d][0];
            p.s += dir[d][1];
            if (fie[p.f][p.s] != '.') continue;
            if (grid_used[p.f][p.s] == grid_used_cur) continue;
            grid_dist[p.f][p.s] = grid_dist[u.f][u.s] + 1;
            grid_used[p.f][p.s] = grid_used_cur;
            grid_last[p.f][p.s] = u;
            q.push(p);
        }
    }

    vector<char> local_path;

    pii cur = to;
    while (grid_dist[cur.f][cur.s] != 0) {
        pii next = grid_last[cur.f][cur.s];
        local_path.push_back(diff_to_dir[{cur.f - next.f, cur.s - next.s}]);
        cur = next;
    }

    reverse(local_path.begin(), local_path.end());

    for (char t: local_path) {
        whole_path.push_back(string("M") + t);
    }

    grid_used_cur++;
}

char peeu_color = 'O';

void peeu(int d)
{
    whole_path.push_back(string(1, peeu_color) + string(1, dir_to_str[d]));
    peeu_color = peeu_color == 'O' ? 'B' : 'O';
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        cin >> fie[i];
    }
    pii be, ed;
    cin >> be.f >> be.s >> ed.f >> ed.s;
    --be.f;
    --be.s;
    --ed.f;
    --ed.s;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (col[i][j] == 0 && fie[i][j] == '.') {
                dfs_comp(i, j);
                ++cc;
            }
        }
    }

  //  cout << cc << endl;

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
    //        cout << col[i][j] << ' ';
        }
    //    cout << endl;
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (fie[i][j] == 'W') continue;

            if (fie[i-1][j] == 'W') clcl[i][j][3] = {i, j};
            else clcl[i][j][3] = clcl[i-1][j][3];

            if (fie[i][j-1] == 'W') clcl[i][j][2] = {i, j};
            else clcl[i][j][2] = clcl[i][j-1][2];
        }
    }

    for (int i = n-1; i >= 0; --i) {
        for (int j = m-1; j >= 0; --j) {
            if (fie[i][j] == 'W') continue;

            if (fie[i+1][j] == 'W') clcl[i][j][1] = {i, j};
            else clcl[i][j][1] = clcl[i+1][j][1];

            if (fie[i][j+1] == 'W') clcl[i][j][0] = {i, j};
            else clcl[i][j][0] = clcl[i][j+1][0];
        }
    }

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            pii w = clcl[i][j][3];
          //  cout << col[w.f][w.s] << ' ';
        }
      //  cout << endl;
    }

    vector<vector<edge>> g(cc); // g[0] = NULL

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (fie[i][j] != '.') continue;
            for (int d = 0; d < 4; ++d) {
                pii endd = clcl[i][j][d];
                if (col[endd.f][endd.s] == col[i][j]) continue;
                g[col[i][j]].push_back({col[i][j], {i, j}, d, endd, col[endd.f][endd.s]});
            }
        }
    }

    queue<int> q;
    q.push(col[be.f][be.s]);
    fill(dist, dist+cc, inf);
    dist[col[be.f][be.s]] = 0;

    while (!q.empty()) {
        int u = q.front(); q.pop();
        for (auto e: g[u]) {
            if (dist[e.to] != inf) continue;
            dist[e.to] = dist[u] + 1;
            last[e.to] = e;
            q.push(e.to);
        }
    }

    int distan = dist[col[ed.f][ed.s]];
    distan = distan == 0 ? 0 : distan + 1;
    cout << distan << ' ';

    if (distan == 0) {
        grid_path(be, ed);
        cout << whole_path.size() << '\n';
        for (string &dd: whole_path) {
            cout << dd << '\n';
        }
        return 0;
    }

    vector<edge> path;

    int cur = col[ed.f][ed.s];

    while (dist[cur] != 0) {
        path.push_back(last[cur]);
        cur = last[cur].fr;
    }

    reverse(path.begin(), path.end());

    pii curpos;
    int get_out;

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (col[i][j] == col[be.f][be.s]) {
                for (int d = 0; d < 4; ++d) {
                    int ni = i + dir[d][0];
                    int nj = j + dir[d][1];
                    if (fie[ni][nj] == 'W') {
               //         cout << be.f << ' ' << be.s << endl;
               //         cout << i << ' ' << j << endl;
                        grid_path(be, {i, j});
                        peeu(d);
                        curpos = {i, j};
                        get_out = d;
                        goto out;
                    }
                }
            }
        }
    }
out:;

    for (auto e: path) {
        grid_path(curpos, e.st);
        peeu(e.dire);
        grid_path(e.st, curpos);
        whole_path.push_back(string("M") + string(1, dir_to_str[get_out]));
        curpos = e.ed;
        get_out = e.dire;
    }

    grid_path(curpos, ed);

    cout << whole_path.size() - distan << '\n';

    for (string &dd: whole_path) {
        cout << dd << '\n';
    }

    return 0;
}
