﻿#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

struct task {
	int id;
	set <int> s;

	bool operator == (task& p) {
		return s.size() == p.s.size() && s == p.s;
	}

	bool operator < (task& p) {
		if (s.size() == p.s.size()) {
			auto ts = s.begin();
			auto ps = p.s.begin();

			do {
				if (*ts != *ps)
					return *ts < *ps;

				++ts, ++ps;
			} while (ts != s.end());
		}

		return s.size() < p.s.size();
	}
};

int main() {
	// ...
	int p, t, m;
	cin >> p >> t >> m;

	vector <task> d(t+1);

	for (int i(0); i < m; i++) {
		int u, z;
		cin >> u >> z;

		d[z].s.insert(u);
		d[z].id = z;
	}

	int num(0);
	vector <int> tasks;
	
	// ТОЛЬКО НУЛЕВЫЕ
	bool is = false;
	for (int i(1); i < d.size(); i++) {
		if (d[i].s.size() == 0) {
			tasks.push_back(i);
			is = true;
		}
	}

	if (is) {
		cout << p - num << " " << tasks.size() << endl;
		for (auto i : tasks)
			cout << i << " ";

		return 0;
	}

	//cout << endl;
	//for (int i(1); i < d.size(); i++) {
	//	cout << d[i].id << ": ";

	//	for (auto j : d[i].s)
	//		cout << j << " ";
	//	cout << endl;
	//}
	//cout << endl;

	// ВСЕ ОСТАЛЬНЫЕ СЛУЧАИ
	sort(d.begin(), d.end());

	//cout << endl;
	//for (int i(1); i < d.size(); i++) {
	//	cout << d[i].id << ": ";

	//	for (auto j : d[i].s)
	//		cout << j << " ";
	//	cout << endl;
	//}
	//cout << endl;

	int dist = distance(d.begin(), adjacent_find(d.begin(), d.end()));

	if (dist != d.size() && d[dist].s.size() == d[1].s.size()) {
		num += d[dist].s.size();
		tasks.push_back(d[dist].id);

		for (int i(dist+1); i < d.size(); i++) {
			if (d[i].s.size() == d[i-1].s.size() && d[i].s == d[i-1].s) {
				tasks.push_back(d[i].id);
			}
			else {
				break;
			}
		}
	}
	else {
		num += d[1].s.size();
		tasks.push_back(d[1].id);
	}

	cout << p - num << " " << tasks.size() << endl;
	for (auto i : tasks)
		cout << i << " ";
}
