#include <bits/stdc++.h>
using namespace std;


struct fastio{
	fastio(){
		ios::sync_with_stdio(0);
		cin.tie(0);

		cout << setprecision(12);
		cout << fixed;

		cerr << setprecision(6);
		cerr << fixed;
	}
}______________;

#ifdef LOCAL
#define debug(x) cerr << #x << " = " << x << endl;
#define ddebug(x, y) cerr << #x << ", " << #y << " = " << x << ", " << y << endl;
#else
#define debug(x);
#define ddebug(x, y);
#endif

#define fi first
#define se second
#define pb push_back
#define mp make_pair
#define sq(a) ((a) * (a))
#define sz(a) ((int)a.size())
#define FOR(i, a, b) for(int i = (int)(a); i < (int)(b); i++)
#define FORD(i, a, b) for(int i = (int)(a); i > (int)(b); i--)

typedef long long ll;
typedef long double ld;
typedef vector <int> vi;
typedef vector <ll> vl;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;

const int MAX = 2e6 + 10;
const ld eps = 1e-8;
const ll INF = 1e9 + 10;
const ll mod = 1e9 + 7;

int n, m;
int sx, sy;
int fx, fy;
char a[1010][1010];

int comp;
int col[1010][1010];

void dfs_paint(int x, int y){
	if(x >= n || y >= m || x < 0 || y < 0 ||
		col[x][y] || a[x][y] != '.') return;
	col[x][y] = comp;
	dfs_paint(x + 1, y);
	dfs_paint(x, y + 1);
	dfs_paint(x - 1, y);
	dfs_paint(x, y - 1);
}

struct edge{
	int v;
	int u;
	pii in;
	pii out;
};
vector <edge> e[MAX];
pii place[MAX];

pii check_portal(int x, int y){
	if(a[x][y] != '.') return mp(-1, -1);
	if(x + 1 < n && a[x + 1][y] == 'W') return mp(x, y);
	else if(x - 1 >= 0 && a[x - 1][y] == 'W') return mp(x, y);
	else if(y + 1 < m && a[x][y + 1] == 'W') return mp(x, y);
	else if(y - 1 >= 0 && a[x][y - 1] == 'W') return mp(x, y);
	else return mp(-1, -1);	
}

void build(){
	FOR(i, 0, n)
		FOR(j, 0, m)
			if(!col[i][j] && a[i][j] == '.'){
				comp++;
				dfs_paint(i, j);
			}
	ddebug(n, m);
	debug(comp);
	#ifdef LOCAL
	cerr << endl;
	FOR(i, 0, n){    
		FOR(j, 0, m)
			cerr << col[i][j] << "\t";
		cerr << endl;
	}

	cerr << endl;
	#endif
	

	FOR(i, 0, n)
		FOR(j, 0, m)
			if(check_portal(i, j) != mp(-1, -1)){
				place[col[i][j]] = check_portal(i, j);
			}

	
	// W -> |G| -> W
	FOR(i, 0, n){
		int last = -1;
		FOR(j, 1, m){
			if(a[i][j] == 'W'){
				last = -1;
				continue;
			}
			if(a[i][j - 1] == 'W' && a[i][j] == '.')
				last = j;
			if(last != -1 && place[col[i][j]] != mp(-1, -1)){
				pii from = mp(i, last);
				pii to = mp(i, j);
				int from_col = col[from.fi][from.se];
				int to_col = col[to.fi][to.se];
				if(from_col == to_col)
					continue;
				debug("HOZ");
				ddebug(from_col, to_col);
				
				e[to_col].pb({from_col, to_col, to, from});
			}
		}

	}

	FOR(i, 0, n){
		int last = -1;
		FORD(j, m - 1, -1){
			if(a[i][j] == 'W'){
				last = -1;
				continue;
			}
			if(a[i][j + 1] == 'W' && a[i][j] == '.')
				last = j;
			if(last != -1 && place[col[i][j]] != mp(-1, -1)){
				pii from = mp(i, last);
				pii to = mp(i, j);
				int from_col = col[from.fi][from.se];
				int to_col = col[to.fi][to.se];
				if(from_col == to_col)
					continue;
				debug("HOZ");
				ddebug(from_col, to_col);
				
				e[to_col].pb({from_col, to_col, to, from});
			}
		}

	}

	// W
	// ^
	// |
	// G
	// ^
	// |
	// W
	FOR(j, 0, m){
		int last = -1;
		FOR(i, 1, n - 1){
			if(a[i][j] == 'W'){
				last = -1;
				continue;
			}
			if(a[i - 1][j] == 'W' && a[i][j] == '.')
				last = i;
			if(last != -1 && place[col[i][j]] != mp(-1, -1)){
				pii from = mp(last, j);
				pii to = mp(i, j);
				int from_col = col[from.fi][from.se];
				int to_col = col[to.fi][to.se];
				if(from_col == to_col)
					continue;
				debug("VER");
				ddebug(from_col, to_col);
				e[to_col].pb({from_col, to_col, to, from});
			}
		}

	}
	
	FOR(j, 0, m){
		int last = -1;
		FORD(i, n - 1, -1){
			if(a[i][j] == 'W'){
				last = -1;
				continue;
			}
			if(a[i + 1][j] == 'W' && a[i][j] == '.')
				last = i;
			if(last != -1 && place[col[i][j]] != mp(-1, -1)){
				pii from = mp(last, j);
				pii to = mp(i, j);
				int from_col = col[from.fi][from.se];
				int to_col = col[to.fi][to.se];
				if(from_col == to_col)
					continue;
				debug("VER");
				ddebug(from_col, to_col);
				e[to_col].pb({from_col, to_col, to, from});
			}
		}

	}

}
            
vector <edge> route;   
int find_route(){
	queue <int> q;
	vi used(comp + 1, false);
	used[col[sx][sy]] = true;
	vi d(comp + 1, INF);
	d[col[sx][sy]] = 0;
	edge bad_e = {-1, -1, mp(-1, -1), mp(-1, -1)};
	vector <edge> p(comp + 1, bad_e);
	q.push(col[sx][sy]);
	while(!q.empty()){
		int v;
		v = q.front();
		q.pop();
		FOR(i, 0, sz(e[v])){
			int nxt = e[v][i].v;
			if(!used[nxt]){
				q.push(nxt);
				used[nxt] = true;
                d[nxt] = d[v] + 1;
                p[nxt] = e[v][i];
			}
		}
		ddebug(v, d[v]);
	}             
	int cur = col[fx][fy];
	while(cur != -1 && p[cur].u != -1){
		route.pb(p[cur]);
		cur = p[cur].u;
	}
	reverse(route.begin(), route.end());
	#ifdef LOCAL
	cerr << "Route is: " << sz(route) + 1 << endl;
	cerr << col[sx][sy] << " ";
	FOR(i, 0, sz(route))
		cerr << route[i].v << " ";
	cerr << endl;
	#endif                      
	return sz(route) + 1;
}
            
int was[1010][1010];
vi tmp;
int m_timer = 1;
#define UP 0
#define DOWN 1
#define LEFT 2
#define RIGHT 3
#define BLUE 4
#define ORANGE 12
bool dfs_inside(int x, int y, int goal_x, int goal_y){
	if(x < 0 || y < 0 || x >= n || y >= m || col[goal_x][goal_y] != col[x][y] && was[x][y] == m_timer)
		return false;
	was[x][y] = m_timer;
	if(x == goal_x && y == goal_y){
		tmp.clear();
		return true;
	}         
	if(dfs_inside(x + 1, y, goal_x, goal_y)){
		tmp.pb(DOWN);
		return true;
	}
	if(dfs_inside(x - 1, y, goal_x, goal_y)){
		tmp.pb(UP);
		return true;
	}
	if(dfs_inside(x, y + 1, goal_x, goal_y)){
		tmp.pb(RIGHT);
		return true;
	}
	if(dfs_inside(x, y - 1, goal_x, goal_y)){
		tmp.pb(LEFT);
		return true;
	}
	
	return false;
}              

int open_portal(int x, int y){
	if(x + 1 < n && a[x + 1][y] == 'W') return DOWN;
	else if(x - 1 >= 0 && a[x - 1][y] == 'W') return UP;
	else if(y + 1 < m && a[x][y + 1] == 'W') return RIGHT;
	else if(y - 1 >= 0 && a[x][y - 1] == 'W') return LEFT;
	assert(false);
	return -1;
}

int shoot_portal(int x, int y, int nx, int ny){
	if(y == ny){
		if(x > nx)
			return DOWN;
		else
			return UP;
	}
	else{
		if(y < ny)
			return RIGHT;
		else
			return LEFT;
	}
}


vi ans_move;


void add_to_ans(int nx, int ny){
	ddebug(sx, sy);
	ddebug(nx, ny);
	m_timer++;
	assert(dfs_inside(sx, sy, nx, ny));
	reverse(tmp.begin(), tmp.end());
   	FOR(i, 0, sz(tmp))
	   	ans_move.pb(tmp[i]);
	sx = nx, ny = sy;
}

string parse_move(int com){
    string res = "";
	if((com & BLUE) == BLUE){
		res += "B";
	}
	else if((com & ORANGE) == ORANGE){
		res += "O";
	}
	else{
		res += "M";
	}
	if((com & RIGHT) == RIGHT)
		res += "R";
	else if((com & LEFT) == LEFT)
		res += "L";
	else if((com & DOWN) == DOWN)
		res += "D";
	else
		res += "U";
	return res;		
}

void solve(){
	cin >> n >> m;
	FOR(i, 0, n)
		FOR(j, 0, m)
			cin >> a[i][j];
	cin >> sx >> sy;
	cin >> fx >> fy;
	sx--, sy--;
	fx--, fy--;
	build();
	FOR(i, 1, comp + 1)
		ddebug(place[i].fi, place[i].se);
	if(col[sx][sy] == col[fx][fy]){
		add_to_ans(fx, fy);
		cout << 0 << " " << sz(ans_move) << endl;
		FOR(i, 0, sz(ans_move))
			cout << parse_move(ans_move[i]) << "\n";
	}
	else{
		int ans = find_route();
		int cur = 0;
		pii first_portal = place[col[sx][sy]];
		add_to_ans(first_portal.fi, first_portal.se);
		ans_move.pb(BLUE | open_portal(first_portal.fi, first_portal.se));
		FOR(i, 0, sz(route)){
			ddebug(route[i].u, route[i].v);
			add_to_ans(route[i].in.fi, route[i].in.se);
			if(cur % 2)
				ans_move.pb(BLUE | shoot_portal(route[i].in.fi, route[i].in.se, route[i].out.fi, route[i].out.se));
			else
				ans_move.pb(ORANGE | shoot_portal(route[i].in.fi, route[i].in.se, route[i].out.fi, route[i].out.se));
			add_to_ans(place[col[sx][sy]].fi, place[col[sx][sy]].se);
			ans_move.pb(open_portal(sx, sy));
			sx = route[i].out.fi;
			sy = route[i].out.se;
			cur++;
		}
		add_to_ans(fx, fy);

		cout << ans << " " << sz(ans_move) << endl;
		FOR(i, 0, sz(ans_move))
			cout << parse_move(ans_move[i]) << "\n";
	}

}

int main(){
    clock_t beg = clock();
    solve();
    clock_t end = clock();
    ld elapsed_time = (ld)(end - beg) / CLOCKS_PER_SEC;
    debug(elapsed_time);
	return 0;
}