#pragma GCC optimize("Ofast")
//#define _CRT_SECURE_NO_WARNINGS


#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <functional>
#include <numeric>
#include <limits>
#include <cstdio>

using namespace std;
using ll = long long;

const ll MOD = 1000000007;
const ll INV = 280000002;

using Matrix = vector<vector<ll>>;

Matrix mult(Matrix a, Matrix b) {
	ll n = a.size();
	ll m = b.size();
	ll p = b[0].size();
	Matrix res(n, vector<ll>(p));
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < p; ++j) {
			for (int k = 0; k < m; ++k) {
				res[i][j] += a[i][k] * b[k][j];
				res[i][j] %= MOD;
			}
		}
	}
	return res;
}

Matrix mid(ll n) {
	Matrix res(n, vector<ll>(n));
	for (ll i = 0; i < n; ++i) res[i][i] = 1;
	return res;
}

Matrix mpow(Matrix x, ll p) {
	if (p == 0) {
		return mid(x.size());
	}
	if (p & 1) {
		return mult(x, mpow(x, p - 1));
	}
	auto t = mpow(x, p / 2);
	return mult(t, t);
}

ll npow(ll x, ll p) {
	if (p == 0) return 1;
	if (p & 1) return x * npow(x, p - 1) % MOD;
	ll t = npow(x, p / 2);
	return t * t % MOD;
}

void solve() {
	Matrix m(3, vector<ll>(3));
	m[0][0] = 26;
	m[0][1] = INV;
	m[0][2] = MOD - 1;
	m[1][1] = 26;
	m[1][2] = 25;
	m[2][2] = 1;

	ll n;
	cin >> n;
	if (n < 4) {
		cout << 0 << endl;
		return;
	}

	m = mpow(m, n - 4);
	Matrix v(3, vector<ll>(1));
	v[0][0] = 0;
	v[1][0] = 26 * 26 - 1;
	v[2][0] = 1;

	ll S = mult(m, v)[0][0];
	S += INV * 4 * (npow(26, n - 3) - 1) % MOD;
	S %= MOD;
	cout << S << endl;
}


int main() {
	//(void)freopen("input.txt", "r", stdin);
	cin.tie(nullptr);
	cout.tie(nullptr);
	ios::sync_with_stdio(false);
	solve();
	return 0;
}
