#pragma GCC optimize("Ofast")
//#define _CRT_SECURE_NO_WARNINGS


#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <functional>
#include <numeric>
#include <limits>
#include <cstdio>

using namespace std;
using ll = long long;

struct edge {
	int from, to, x, y, d;
};

vector<vector<edge>> g;
set<pair<int, int>> edges;
vector<string> res;
vector<edge> space;
vector<vector<int>> txused[4];
vector<int> clobber;
vector<char> has_walls;

int n, m, portals;
vector<vector<char>> mp;
vector<vector<pair<int, int>>> nearest[4];
vector<vector<int>> used;
int sx, sy, tx, ty, colors;
int start, finish;
int curx, cury, cur;

int portx[2] = { -1, -1 };
int porty[2] = { -1, -1 };
int portd[2] = { -1, -1 };

const int dx[] = { 0, 1, 0, -1 };
const int dy[] = { 1, 0, -1, 0 };
char dir[] = "RDLU";

void dfs(int x, int y, int color) {
	if (used[x][y] != -1) return;
	if (mp[x][y] != '.') return;
	used[x][y] = color;
	for (int d = 0; d < 4; ++d) {
		dfs(x + dx[d], y + dy[d], color);
	}
}

void move_inside_block(int tx, int ty) {
	auto& tused = txused[clobber[cur]];
	++clobber[cur];
	queue<pair<int, int>> q;
	q.push(make_pair(curx, cury));
	tused[curx][cury] = 0;
	while (!q.empty()) {
		auto p = q.front();
		q.pop();
		
		for (int d = 0; d < 4; ++d) {
			int nx = p.first + dx[d];
			int ny = p.second + dy[d];

			if (tused[nx][ny] != -1) continue;
			if (mp[nx][ny] != '.') continue;
			tused[nx][ny] = d;
			q.push(make_pair(nx, ny));
		}
	}

	int x = tx;
	int y = ty;
	vector<int> path;
	
	while (x != curx || y != cury) {
		int d = tused[x][y];
		path.push_back(d);
		x -= dx[d];
		y -= dy[d];
	}

	for (auto it = path.rbegin(); it != path.rend(); ++it) {
		res.push_back(string("M") + dir[*it]);
	}

	curx = tx;
	cury = ty;
}

void place_portal(int tx, int ty, int d, int idx = 0) {
	move_inside_block(tx, ty);
	if (idx == 0)
		res.push_back(string("B") + dir[d]);
	else
		res.push_back(string("O") + dir[d]);
	portx[idx] = nearest[d][tx][ty].first;
	porty[idx] = nearest[d][tx][ty].second;
	portd[idx] = d;
	++portals;
}

void place_portal_anywhere() {
	if (!has_walls[cur]) {
		cout << "-1 -1\n";
		exit(0);
	}
	int x = space[cur].x;
	int y = space[cur].y;
	int d = space[cur].d;
	place_portal(x, y, d);
}

void go_through_portal(int enter) {
	move_inside_block(portx[enter], porty[enter]);
	res.push_back(string("M") + dir[portd[enter]]);
	curx = portx[enter ^ 1];
	cury = porty[enter ^ 1];
}

void solve() {
	cin >> n >> m;
	mp.resize(n, vector<char>(m));
	used.resize(n, vector<int>(m, -1));
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			cin >> mp[i][j];
		}
	}
	cin >> sx >> sy;
	cin >> tx >> ty;
	--sx, --sy, --tx, --ty;
	curx = sx;
	cury = sy;
	for (int i = 0; i < 4; ++i)
		txused[i].resize(n, vector<int>(m, -1));

	for (int d = 0; d < 4; ++d) {
		nearest[d].resize(n, vector<pair<int, int>>(m, make_pair(-1, -1)));
		for (int x = (dx[d] == 1) ? n - 2 : 1, i = 0; i < n - 2; ++i, x -= dx[d] ? dx[d] : -1) {
			for (int y = (dy[d] == 1) ? m - 2 : 1, j = 0; j < m - 2; ++j, y -= dy[d] ? dy[d] : -1) {
				if (mp[x][y] == 'W') {
					// nearest[d][x][y] = nearest[d][x + dx[d]][y + dy[d]];
					nearest[d][x][y] = { -1, -1 };
					continue;
				}
				nearest[d][x][y] = nearest[d][x + dx[d]][y + dy[d]];
				if (nearest[d][x][y].first == -1) {
					nearest[d][x][y] = { x, y };
				}
			}
		}
	}

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			if (mp[i][j] != '.') continue;
			if (used[i][j] == -1) {
				dfs(i, j, colors);
				++colors;
			}
		}
	}
	clobber.resize(colors);
	/*
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			if (used[i][j] == -1) cout << 'x'; else cout << used[i][j];
		}
		cout << endl;
	}*/

	space.resize(colors);
	has_walls.resize(colors);
	g.resize(colors);
	start = used[sx][sy];
	finish = used[tx][ty];
	cur = start;

	if (start == -1 || finish == -1) {
		cout << "-1 -1\n";
		exit(0);
	}

	if (start == finish) {
		// Find path in one node
		move_inside_block(tx, ty);
		cout << "0 " << res.size() << endl;
		for (auto s : res) cout << s << '\n';
		exit(0);
	}

	for (int d = 0; d < 4; ++d) {
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < m; ++j) {
				int q = used[i][j];
				if (q == -1) continue;
				auto t = nearest[d][i][j];
				if (t.first == -1) continue;
				int c = used[t.first][t.second];
				if (c == -1) continue;
				if (c == q) {
					space[c] = edge{ c, c, i, j, d };
					has_walls[c] = 1;
					continue;
				}
				if (edges.find({ c, q }) != edges.end()) continue;
				edges.insert({ c, q });
				g[q].push_back(edge{ q, c, i, j, d });
			}
		}
	}
	edges.clear();

	queue<int> q;
	q.push(start);
	vector<char> qused(colors);
	vector<edge> prev(colors);
	qused[start] = 1;

	while (!q.empty()) {
		int v = q.front();
		q.pop();
		for (auto &e : g[v]) {
			if (qused[e.to]) continue;
			qused[e.to] = true;
			q.push(e.to);
			prev[e.to] = e;
		}
	}

	if (!qused[finish]) {
		cout << "-1 -1\n";
		exit(0);
	}

	int zz = finish;
	vector<edge> path;
	while (zz != start) {
		path.push_back(prev[zz]);
		zz = prev[zz].from;
	}
	reverse(path.begin(), path.end());
	place_portal_anywhere();
	int idx = 1;
	for (auto &e : path) {
		place_portal(e.x, e.y, e.d, idx);
		idx ^= 1;
		go_through_portal(idx);
	}
	move_inside_block(tx, ty);
	cout << portals << ' ' << res.size() - portals << endl;
	for (auto s : res) cout << s << '\n';
}

int main() {
	//(void)freopen("input.txt", "r", stdin);
	cin.tie(nullptr);
	cout.tie(nullptr);
	ios::sync_with_stdio(false);
	solve();
	return 0;
}
