#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <string>

//#define THIRD_ROOM
#define NUM_TEST 2

typedef enum {
	P_LOW = 0,
	P_MID_DOWN,
	P_MID_UP,
	P_HIGH
}rate;


typedef struct{

	int height;
	int arms;
	int points;
	int grabs;
	int passes;


	int num_exact(rate r)
	{
		return (height == r) + (arms == r) + (points == r) + (grabs == r) + (passes == r);
	}

	int num_higherEqual(rate r)
	{
		return (height >= r) + (arms >= r) + (points >= r) + (grabs >= r) + (passes >= r);
	}


	int num_lowerEqual(rate r)
	{
		return (height <= r) + (arms <= r) + (points <= r) + (grabs <= r) + (passes <= r);
	}

}player_t;



int calcParam(int bottom, int top, int param)
{
	if (param < bottom)
		return P_LOW;
	else if (param > top)
		return P_HIGH;
	else if (param >= (top + bottom) / 2)
		return P_MID_UP;
	else if (param < (top + bottom) / 2)
		return P_MID_DOWN;
	return 0;
}

void calcRates(player_t* pl)
{
	pl->height = calcParam(190, 220, pl->height);
	pl->arms = calcParam(200, 250, pl->arms);
	pl->points = calcParam(10, 20, pl->points);
	pl->grabs = calcParam(2, 6, pl->grabs);
	pl->passes = calcParam(3, 7, pl->passes);
}



int getType(player_t* pl)
{
	calcRates(pl);

	///////////////// CHECK class 0
	if (pl->arms == P_HIGH || pl->height == P_HIGH)
	{
		if (pl->num_exact(P_HIGH) >= 3)
			return 0;
	}

	/////////////// CHECK class 1
	if (pl->num_exact(P_HIGH) >= 2 && pl->num_higherEqual(P_MID_UP) >= 3)
		return 1;

	if (pl->num_higherEqual(P_MID_DOWN) == 5 && pl->num_higherEqual(P_MID_UP) >= 3)
		return 1;

	///////////////////// CHECK class 2
	if (pl->num_exact(P_HIGH) >= 1 && pl->num_higherEqual(P_MID_UP) >= 2)
		return 2;

	if (pl->num_higherEqual(P_MID_UP) >= 3)
		return 2;

	///// else return bad
	return 3;
}



void run(FILE* in, FILE* out) {
	int N;
	player_t pl;
	fscanf(in, "%d", &N);

	for (int i = 0; i < N; i++) {
		fscanf(in, "%d%d%d%d%d", &(pl.height), &(pl.arms), &(pl.points), &(pl.grabs), &(pl.passes));
		fprintf(out, "%d\n", getType(&pl));
	}
}

#ifndef THIRD_ROOM
int main() {
	run(stdin, stdout);
	return 0;
}
#else

#include <direct.h>

int compareFiles(FILE* f1, FILE* f2) {
	int c1, c2;

	do {
		c1 = fgetc(f1);
		c2 = fgetc(f2);
		if (c1 != c2) {
			return 0; //false
		}
	} while (c1 != EOF && c2 != EOF);

	if (c1 == EOF && c2 == EOF) {
		return 1; //true
	}
	return 0; //false
}

int main() {
	FILE* in;
	FILE* out;
	FILE* test;
	char inputName[25];
	char outputName[25];

	for (int i = 0; i < NUM_TEST; i++) {
		sprintf(inputName, "input%d.txt", i);
		sprintf(outputName, "output%d.txt", i);

		in = fopen(inputName, "rt");
		out = fopen("output.txt", "wt");
		test = fopen(outputName, "rt");

		run(in, out);

		fclose(in);
		fclose(out);

		out = fopen("output.txt", "rt");
		printf("TEST #%2d: %s\n", i, compareFiles(out, test) ? "OK" : "FAIL");

		fclose(test);
		fclose(out);
	}
}

#endif
