#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <stack>
#include <string>

// #define THIRD_ROOM
#define NUM_TEST 2

void run(FILE* in, FILE* out) {
	std::stack<char> st;
	int N;
	char line[8] = "";
	char tmp, sym;
	fscanf(in, "%d", &N);
	for (int i = 0; i < N; i++) {
		fscanf(in, "%s%c%c", line, &tmp, &sym);
		if (std::string(line).find("Add") == 0) {
			st.push(sym);
		}
		else if (st.empty() || st.top() != sym) {
			fprintf(out, "No");
			return;
		}
		else {
			st.pop();
		}
	}
	if (!st.empty()) {
		fprintf(out, "No");
	}
	else {
		fprintf(out, "Yes");
	}
}

#ifndef THIRD_ROOM
int main() {
	run(stdin, stdout);
	return 0;
}
#else

#include <direct.h>

int compareFiles(FILE* f1, FILE* f2) {
	int c1, c2;

	do {
		c1 = fgetc(f1);
		c2 = fgetc(f2);
		if (c1 != c2) {
			return 0; //false
		}
	} while (c1 != EOF && c2 != EOF);

	if (c1 == EOF && c2 == EOF) {
		return 1; //true
	}
	return 0; //false
}

int main() {
	FILE* in;
	FILE* out;
	FILE* test;
	char inputName[25];
	char outputName[25];

	for (int i = 0; i < NUM_TEST; i++) {
		sprintf(inputName, "input%d.txt", i);
		sprintf(outputName, "output%d.txt", i);

		in = fopen(inputName, "rt");
		out = fopen("output.txt", "wt");
		test = fopen(outputName, "rt");

		run(in, out);

		fclose(in);
		fclose(out);

		out = fopen("output.txt", "rt");
		printf("TEST #%2d: %s\n", i, compareFiles(out, test) ? "OK" : "FAIL");

		fclose(test);
		fclose(out);
	}
}

#endif
