#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <string>
#include <vector>

// #define THIRD_ROOM
#define NUM_TEST 4


void run(FILE* in, FILE* out) {
	int P, T, M;
	int player, task;
	int count_players = 0;
	
	fscanf(in, "%d%d%d", &P, &T, &M);
	std::vector<int> minimum_ids;
	std::vector<int> tasks;
	std::vector<int> max_tasks;
	int min = INT_MAX;
	// std::vector<int>* player_tasks = (std::vector<int>*)malloc(sizeof(std::vector<int>) * P);
	// std::vector<int>* known_tasks = (std::vector<int>*)malloc(sizeof(std::vector<int>) * T);
	std::vector<std::vector<int>> player_tasks(P), known_tasks(T);
	for (int i = 0; i < M; i++) {
		fscanf(in, "%d%d", &player, &task); 
		known_tasks[task- 1].push_back(player - 1);
		player_tasks[player -1].push_back(task - 1);
	}
	for (int i = 0; i < T; i++) {
		if (min > known_tasks[i].size()) {
			min = known_tasks[i].size();
		}
	}
	for (int i = 0; i < T; i++) {
		if (known_tasks[i].size() == min) {
			minimum_ids.push_back(i);
		}
	}
	if (min == 0) {
		fprintf(out, "%d %d\n", P, minimum_ids.size());
		for (int i = 0; i < minimum_ids.size(); i++) {
			fprintf(out, "%d ", minimum_ids[i] + 1);
		}
	}
	else {
		int max = 0;
		for (int i = 0; i < minimum_ids.size(); i++) {
			tasks.push_back(i);
			for (int j = i + 1; j < minimum_ids.size(); j++) {
				if (known_tasks[minimum_ids[i]] == known_tasks[minimum_ids[j]]) {
					tasks.push_back(j);
				}
			}
			if (tasks.size() > max) {
				max_tasks = tasks;
				max = tasks.size();
			}
			tasks.clear();
		}
		fprintf(out, "%d %d\n", P - min, max);
		for (int i = 0; i < max_tasks.size(); i++) {
			fprintf(out, "%d ", minimum_ids[max_tasks[i]] + 1);
		}
	}

}

#ifndef THIRD_ROOM
int main() {
	run(stdin, stdout);
	return 0;
}
#else

#include <direct.h>

int compareFiles(FILE* f1, FILE* f2) {
	int c1, c2;

	do {
		c1 = fgetc(f1);
		c2 = fgetc(f2);
		if (c1 != c2) {
			return 0; //false
		}
	} while (c1 != EOF && c2 != EOF);

	if (c1 == EOF && c2 == EOF) {
		return 1; //true
	}
	return 0; //false
}

int main() {
	FILE* in;
	FILE* out;
	FILE* test;
	char inputName[25];
	char outputName[25];

	for (int i = 0; i < NUM_TEST; i++) {
		sprintf(inputName, "input%d.txt", i);
		sprintf(outputName, "output%d.txt", i);

		in = fopen(inputName, "rt");
		out = fopen("output.txt", "wt");
		test = fopen(outputName, "rt");

		run(in, out);

		fclose(in);
		fclose(out);

		out = fopen("output.txt", "rt");
		printf("TEST #%2d: %s\n", i, compareFiles(out, test) ? "OK" : "FAIL");

		fclose(test);
		fclose(out);
	}
}

#endif
