#include <algorithm>
#include <cassert>
#include <cmath>
#include <ctime>
#include <functional>
#include <iostream>
#include <map>
#include <vector>
#include <set>
#include <string>
#include <unordered_map>
#include <unordered_set>

using namespace std;

using ll = long long;
using ld = long double;
using vi = vector<int>;
using pii = pair<int, int>;

#define forn(i, n) for (int i = 0; i < n; i++)
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#define endl '\n'

namespace {
	istream& operator >> (istream& is, pair<int, int>& value) {
		is >> value.first >> value.second;
		return is;
	}

	ostream& operator << (ostream& os, const pair<int, int>& value) {
		os << value.first << " " << value.second << "\n";
		return os;
	}

	template<class T = int>
	T read() {
		T x; cin >> x; return x;
	}

	template<class T>
	void sort(vector<T>& v) {
		sort(all(v));
	}

	template<class T>
	void unique(vector<T>& v) {
		sort(v);
		v.erase(unique(all(v)), v.end());
	}

	template<class T>
	void print(T value) {
		cout << value << "\n";
	}

	template<class T, class... Args>
	void print(T value, Args... args) {
		cout << value << " ";
		print(args...);
	}
}

void solve() {
	ll n; cin >> n;
	vector<ll>v(n);
	set<ll>st;
	for (ll i = 0; i < n; i++) cin >> v[i], st.insert(v[i]);
	ll ans = 0;
	for (ll x : st) if (x <= n) {
		ans++;
	}
	cout << ans << endl;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int t = 1;
	while (t--) {
		auto timer = clock();
		solve();
		fprintf(stderr, "Time = %.3f\n", (double)(clock() - timer) / CLOCKS_PER_SEC);
	}
}