#include <algorithm>
#include <cassert>
#include <cmath>
#include <ctime>
#include <functional>
#include <iostream>
#include <map>
#include <vector>
#include <set>
#include <string>
#include <unordered_map>
#include <unordered_set>

using namespace std;

using ll = long long;
using ld = long double;
using vi = vector<int>;
using pii = pair<int, int>;

#define forn(i, n) for (int i = 0; i < n; i++)
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#define endl '\n'

namespace {
	istream& operator >> (istream& is, pair<int, int>& value) {
		is >> value.first >> value.second;
		return is;
	}

	ostream& operator << (ostream& os, const pair<int, int>& value) {
		os << value.first << " " << value.second << "\n";
		return os;
	}

	template<class T = int>
	T read() {
		T x; cin >> x; return x;
	}

	template<class T>
	void sort(vector<T>& v) {
		sort(all(v));
	}

	template<class T>
	void unique(vector<T>& v) {
		sort(v);
		v.erase(unique(all(v)), v.end());
	}

	template<class T>
	void print(T value) {
		cout << value << "\n";
	}

	template<class T, class... Args>
	void print(T value, Args... args) {
		cout << value << " ";
		print(args...);
	}
}


bool is_unicorn(int h, int rr, int pts, int pdb, int prd) {
	int cnt = 0;
	if (h > 220) cnt++;
	if (rr > 250) cnt++;
	if (pts > 20) cnt++;
	if (pdb > 6) cnt++;
	if (prd > 7) cnt++;
	return (cnt >= 3 && (h > 220 || rr > 250));
}

bool first_round(int h, int rr, int pts, int pdb, int prd) {
	int cnt = 0, wp = 0, dd = 0;
	if (h > 220) cnt++; else if (h >= 205) wp++; else if (h >= 190) dd++;
	if (rr > 250) cnt++; else if (rr >= 225) wp++; else if (rr >= 200) dd++;
	if (pts > 20) cnt++; else if (pts >= 15) wp++; else if (pts >= 10) dd++;
	if (pdb > 6) cnt++; else if (pdb >= 4) wp++; else if (pdb >= 2) dd++;
	if (prd > 7) cnt++; else if (prd >= 5) wp++; else if (prd >= 3) dd++;
	return ((cnt >= 2 && wp > 0) || (wp >= 3 && dd == 5));
}

bool second_round(int h, int rr, int pts, int pdb, int prd) {
	int cnt = 0, wp = 0, dd = 0;
	if (h > 220) cnt++; else if (h >= 205) wp++; else if (h >= 190) dd++;
	if (rr > 250) cnt++; else if (rr >= 225) wp++; else if (rr >= 200) dd++;
	if (pts > 20) cnt++; else if (pts >= 15) wp++; else if (pts >= 10) dd++;
	if (pdb > 6) cnt++; else if (pdb >= 4) wp++; else if (pdb >= 2) dd++;
	if (prd > 7) cnt++; else if (prd >= 5) wp++; else if (prd >= 3) dd++;
	return ((cnt > 0 && wp > 0) || (wp >= 3));
}

void solve() {
	int n = read();
	forn(i, n) {
		int h = read(), rr = read(), pts = read(), pdb = read(), prd = read();
		if (is_unicorn(h, rr, pts, pdb, prd)) {
			print(0);
			continue;
		}
		if (first_round(h, rr, pts, pdb, prd)) {
			print(1);
			continue;
		}
		if (second_round(h, rr, pts, pdb, prd)) {
			print(2);
			continue;
		}
		print(3);
	}

	/*string s; cin >> s;
	ll t = s.back() - '0';
	if (t > 1) {
		cout << t * 2 << " " << t << endl;
		return;
	}
	else if (t == 0) {
		cout << 10 << " " << 10 << endl;
	}
	else {

	}*/
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int t = 1;
	while (t--) {
		auto timer = clock();
		solve();
		fprintf(stderr, "Time = %.3f\n", (double)(clock() - timer) / CLOCKS_PER_SEC);
	}
}