#include <algorithm>
#include <cassert>
#include <cmath>
#include <ctime>
#include <functional>
#include <iostream>
#include <map>
#include <vector>
#include <set>
#include <string>
#include <unordered_map>
#include <unordered_set>

using namespace std;

using ll = long long;
using ld = long double;
using vi = vector<int>;
using pii = pair<int, int>;

#define forn(i, n) for (int i = 0; i < n; i++)
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#define endl '\n'

namespace {
	istream& operator >> (istream& is, pair<int, int>& value) {
		is >> value.first >> value.second;
		return is;
	}

	ostream& operator << (ostream& os, const pair<int, int>& value) {
		os << value.first << " " << value.second << "\n";
		return os;
	}

	template<class T = int>
	T read() {
		T x; cin >> x; return x;
	}

	template<class T>
	void sort(vector<T>& v) {
		sort(all(v));
	}

	template<class T>
	void unique(vector<T>& v) {
		sort(v);
		v.erase(unique(all(v)), v.end());
	}

	template<class T>
	void print(T value) {
		cout << value << "\n";
	}

	template<class T, class... Args>
	void print(T value, Args... args) {
		cout << value << " ";
		print(args...);
	}
}

void solve() {
	int p = read(), t = read(), m = read();
	vector<vector<int>> ts(t + 1);
	forn(i, m) {
		int par = read(), tsk = read();
		ts[tsk].push_back(par);
	}
	map<vector<int>, vector<int>> mp;
	int ans = 0;
	vector<int> tasks;
	for (int i = 1; i <= t; i++) {
		if (sz(ts[i])) {
			sort(ts[i]);
			mp[ts[i]].push_back(i);
		}
		else {
			ans = p;
			tasks.push_back(i);
		}
	}
	for (auto& kvp : mp) {
		if (ans < p - sz(kvp.first)) {
			ans = p - sz(kvp.first);
			tasks = kvp.second;
		}
		else if (ans == p - sz(kvp.first) && sz(tasks) < sz(kvp.second)) {
			ans = p - sz(kvp.first);
			tasks = kvp.second;
		}
	}
	print(ans, sz(tasks));
	for (auto v : tasks) cout << v << " ";
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int t = 1;
	while (t--) {
		auto timer = clock();
		solve();
		fprintf(stderr, "Time = %.3f\n", (double)(clock() - timer) / CLOCKS_PER_SEC);
	}
}