#include <algorithm>
#include <array>
#include <cassert>
#include <cmath>
#include <ctime>
#include <functional>
#include <iostream>
#include <map>
#include <vector>
#include <set>
#include <string>
#include <unordered_map>
#include <unordered_set>

using namespace std;

using ll = long long;
using ld = long double;
using vi = vector<int>;
using pii = pair<int, int>;

#define forn(i, n) for (int i = 0; i < n; i++)
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#define endl '\n'

namespace {
	istream& operator >> (istream& is, pair<int, int>& value) {
		is >> value.first >> value.second;
		return is;
	}

	ostream& operator << (ostream& os, const pair<int, int>& value) {
		os << value.first << " " << value.second << "\n";
		return os;
	}

	template<class T = int>
	T read() {
		T x; cin >> x; return x;
	}

	template<class T>
	void sort(vector<T>& v) {
		sort(all(v));
	}

	template<class T>
	void unique(vector<T>& v) {
		sort(v);
		v.erase(unique(all(v)), v.end());
	}

	template<class T>
	void print(T value) {
		cout << value << "\n";
	}

	template<class T, class... Args>
	void print(T value, Args... args) {
		cout << value << " ";
		print(args...);
	}
}

const int mod = 1e9 + 7;

ll mul(ll x, ll y) { return (x * y) % mod; }
ll add(ll x, ll y) { return ((x + y) % mod + mod) % mod; }

ll mpow(ll x, ll p) {
	if (!p) return 1;
	ll res = mpow(x, p / 2);
	res = mul(res, res);
	if (p & 1) res = mul(res, x);
	return res;
}

const int N = 3e5 + 5;
const int M = 1e3;

int nxt(char c) {
	return c - 'a';
}

struct node {
	array<int, 26> nxt;
	array<int, 26> cnt;
	int total_cnt = 0;
	int inside = 0;
} t[N];

int ptr = 1;

void add(const string& s, int pos = 0, int p = 1) {
	int lt = nxt(s[pos]);
	int& val = t[p].nxt[lt];
	if (val == -1) {
		val = ++ptr;
	}
	if (s.size() == pos + 1) {
		t[val].inside++;
		return;
	}
	add(s, pos + 1, val);
}

void dfs(int p = 1) {
	auto& x = t[p];
	x.total_cnt += x.inside;
	forn(i, 26)
		if (x.nxt[i] != -1) {
			dfs(x.nxt[i]);
			x.cnt[i] = t[x.nxt[i]].total_cnt;
			x.total_cnt += x.cnt[i];
		}
}

int ans(const string& s, int k_real, int k_curr, int pos = 0, int p = 1) {
	if (p == -1) return 0;
	if (p == 1) {
		int lt = nxt(s[pos]);
		p = t[p].nxt[lt];
		pos++;
	}
	const auto& v = t[p];
	if (pos == s.size()) {
		return min(v.total_cnt, k_curr);
	}
	int lt = nxt(s[pos]);
	int lans = 0;
	if (v.total_cnt <= k_curr) {
		return v.total_cnt;
	}
	if (v.total_cnt - v.cnt[lt] >= k_curr) {
		lans += k_curr;
		lans += ans(s, k_real, k_real, pos + 1, v.nxt[lt]);
	}
	else {
		k_curr -= (v.total_cnt - v.cnt[lt]);
		lans += (v.total_cnt - v.cnt[lt]);
		lans += ans(s, k_real, k_curr + k_real, pos + 1, v.nxt[lt]);
	}
	return lans;
}

string arr[N];

int answ[N];

void solve() {
	int n = read();
	forn(i, N) fill(t[i].nxt.begin(), t[i].nxt.end(), -1);
	forn(i, N) fill(t[i].cnt.begin(), t[i].cnt.end(), 0);

	forn(i, n) {
		auto s = read<string>();
		arr[i] = s;
		add(s);
	}

	dfs(1);

	int q = read();
	forn(i, q) {
		int pos = read();
		int k = read();
		const auto& s = arr[pos - 1];
		//if (sz(s) <= M) {
		answ[i] = ans(s, k, k);
			//continue;
		//}
	}
	forn(i, q) print(answ[i]);
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	int t = 1;
	while (t--) {
		auto timer = clock();
		solve();
		fprintf(stderr, "Time = %.3f\n", (double)(clock() - timer) / CLOCKS_PER_SEC);
	}
}

/*
6
asassin
assistant
astronaut
abrakadabra
abbey
automaton
9
1 1
1 2
1 3
4 1
4 2
4 3
6 1
6 2
6 3
*/