#include <Bits.h>
#include <iostream>

#include <set>


#define HEIGHT 0
#define HANDS 1
#define POINTS 2
#define CATCHES 3
#define PASSES 4


struct Player {
	std::set<int> above;
	std::set<int> upper;
	std::set<int> lower;
	std::set<int> below;
};


void fill(Player & player, int max, int min, int parameter, int value) {
	if (value > max) {
		player.above.emplace(parameter);
	}
	else if (value >= (max + min) / 2) {
		player.upper.emplace(parameter);
	}
	else if (value >= min) {
		player.lower.emplace(parameter);
	}
	else {
		player.below.emplace(parameter);
	}
}


int main() {
	std::ios_base::sync_with_stdio(false);
	std::cout.tie(0);
	std::cin.tie(0);

	int N;
	std::cin >> N;

	for (size_t it = 0; it < N; it++) {
		Player player;
		
		int height, hands, points, catches, passes;
		std::cin >> height >> hands >> points >> catches >> passes;
		
		fill(player, 220, 190, HEIGHT,  height);
		fill(player, 250, 200, HANDS,   hands);
		fill(player,  20,  10, POINTS,  points);
		fill(player,   6,   2, CATCHES, catches);
		fill(player,   7,   3, PASSES,  passes);

		std::cout << "Player above: " << player.above.size() << std::endl;
		std::cout << "Player upper: " << player.upper.size() << std::endl;
		std::cout << "Player lower: " << player.lower.size() << std::endl;
		std::cout << "Player below: " << player.below.size() << std::endl;

		if (
			(
				player.above.find(HEIGHT) != player.above.end() || 
				player.above.find(HANDS)  != player.above.end()
			) &&
			player.above.size() >= 3
		) {
			std::cout << 0;
		}

		else if (
			player.above.size() >= 3 ||
			player.above.size() >= 2 && player.upper.size() >= 1 ||
			player.above.size() + player.upper.size() >= 3 && player.above.size() + player.upper.size() + player.lower.size() >= 5
		) {
			std::cout << 1;
		}

		else if (
			player.above.size() >= 2 ||
			player.above.size() >= 1 && player.upper.size() >= 1 ||
			player.above.size() + player.upper.size() >= 3
		) {
			std::cout << 2;
		}

		else {
			std::cout << 3;
		}
	}
}