#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

using namespace std;

const int maxn = 1e5;
const int pr = 239;
const int mod = 1e9+9;

vector<int> part[maxn];
vector<int> powers;
map<int, vector<int>> task_to_hash;

int main()
{
    int p, t, m, u, v;
    cin >> p >> t >> m;
    for (int i = 0; i < m; i++) {
        cin >> u >> v;
        part[v - 1].push_back(u - 1);
    }
    int min_size = p + 1;
    for (int i = 0; i < t; i++) {
        min_size = min(min_size, (int)part[i].size());
    }
    vector<int> min_tasks;
    for (int i = 0; i < t; i++) {
        if (part[i].size() == min_size) {
            min_tasks.push_back(i);
        }
    }
    powers.push_back(1);
    for (int i = 1; i < p; i++) {
        powers[i] = (1ll * powers[i - 1] * pr) % mod;
    }
    for (const auto& task : min_tasks) {
        long long hash = 0;
        for (const auto& pa : part[task]) {
            hash += 1ll * powers[pa];
        }
        hash %= mod;
        task_to_hash[(int)hash].push_back(task);
    }
    int max_size = 0;
    int max_hash = -1;
    for (const auto& it : task_to_hash) {
        if (it.second.size() > max_size) {
            max_size = it.second.size();
            max_hash = it.first;
        }
    }
    set<int> parts;
    for (int i = 0; i < p; i++) {
        parts.insert(i);
    }
    int task_ind = task_to_hash[max_hash].front();
    for (const auto& pa : part[task_ind]) {
        parts.erase(pa);
    }
    cout << parts.size() << " " << task_to_hash[max_hash].size() << endl;
    for (const auto& task: task_to_hash[max_hash]) {
        cout << task + 1 << " ";
    }
    return 0;
}
