#include <iostream>
#include <algorithm>
#include <random>
#include <numeric>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cassert>
// #include <cmath>

/* IO */
template <class... Args> void write(Args&& ...args) { (std::cout << ... << args); }
template <class... Args> void writeln(Args&& ...args) { (std::cout << ... << args) << '\n'; }
template <class... Args> bool read(Args& ...args) { return (bool)(std::cin >> ... >> args); }

/* code */


struct res_t { int b, x; };

int get(const std::vector<int>& v, int b, int64_t mod) {
	int64_t res = 0;
	for (int x : v)
		res = (res * b + x) % mod;
	return (int)res;
}

int parse(const std::vector<int>& v) {
	int res = 0;
	for (int x : v)
		res = res * 10 + x;
	return res;
}

res_t solve(const std::vector<int>& v) {
	if (v.size() == 1 && v[0] == 1)
		return { -1, -1 };

	int mx = 1e9;
	if (v.size() <= 9)
		mx = parse(v) - 1;

	for (int x = 2; x <= mx; ++x) {
		for (int b = 0; b < x; ++b) {
			if (get(v, b, x) == 0)
				return { b, x };
		}
	}

	return { -1, -1 };
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	std::string s; read(s);
	std::vector<int> v(s.begin(), s.end());
	for (int& x : v) x -= '0';

	res_t r = solve(v);
	if (r.b == -1) {
		writeln("-1");
	} else {
		int mx = *std::max_element(v.begin(), v.end());
		while (r.b <= mx) r.b += r.x;
		writeln(r.b, ' ', r.x);
	}

	return 0;
}