#include <iostream>
#include <algorithm>
#include <random>
#include <numeric>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
// #include <cmath>

/* IO */
template <class... Args> void write(Args&& ...args) { (std::cout << ... << args); }
template <class... Args> void writeln(Args&& ...args) { (std::cout << ... << args) << '\n'; }
template <class... Args> bool read(Args& ...args) { return (bool)(std::cin >> ... >> args); }

/* code */

template <class T>
struct ptr_cmp {
	bool operator()(const T* a, const T* b) const {
		return *a < *b;
	}
};

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	int p, t, m; read(p, t, m);
	std::vector<std::vector<int>> t2p(t);
	for (int i = 0; i < m; ++i) {
		int pp, tt; read(pp, tt);
		t2p[tt - 1].push_back(pp - 1);
	}

	int optimalSize = p;
	for (const auto& v : t2p)
		optimalSize = std::min(optimalSize, (int)v.size());

	std::map<std::vector<int>*, std::vector<int>, ptr_cmp<std::vector<int>>> mp;
	for (int i = 0; i < t; ++i) {
		if (t2p[i].size() != optimalSize)
			continue;
		mp[&t2p[i]].push_back(i);
	}

	using iter_t = typename decltype(mp)::const_iterator;
	iter_t mx_it = mp.begin();
	for (iter_t it = mp.begin(); it != mp.end(); ++it) {
		if (it->second.size() > mx_it->second.size())
			it = mx_it;
	}

	writeln(p - optimalSize, ' ', mx_it->second.size());
	for (const auto& x : mx_it->second)
		write(x + 1, ' ');
	writeln();

	return 0;
}